/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 * Edition de la balance au format OpenOffice
 */

package org.opensi.compta.actions.etats;

import java.io.File;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import org.experlog.openeas.api.Action;
import org.experlog.openeas.api.ServletRequest;
import org.experlog.openeas.api.Session;
import org.opensi.util.openoffice.CreateurOpenOffice;
import org.opensi.util.openoffice.OooCellule;
import org.opensi.util.openoffice.OooLigne;
import org.opensi.util.openoffice.OooStyleCellule;
import org.opensi.util.tools.DateTime;


public class GenererBalanceOpenoffice extends Action {


	Connection con;
	String chemin;

	File fichierCalc;
	String baseDossier;

	CreateurOpenOffice dieu;
	OooStyleCellule enteteColonneStyle;
	OooStyleCellule ligneTotalStyle;
	OooStyleCellule titreStyle;
	OooStyleCellule styleStandard;


	public boolean serverSide() { return true; }

	public boolean service(Session s, ServletRequest r, Object info) throws Exception {


		chemin = s.getAppConfiguration().get("opensi.absdir") ;
		con = s.getConnection(null);

		String base = s.getCookie().get("BaseExo");
		baseDossier = s.getCookie().get("BaseDossier");

		GenerationOoo(r, base);
		String nomFichier = r.getParameter("fichierSxc");

		fichierCalc = dieu.genererDocument(nomFichier);
		fichierCalc.deleteOnExit();

		s.closeConnection(con, null);

		return true;

	} // fin service


	/**
	 * Rcupration des donnes grace  des requtes SQL
	 **/
	private void GenerationOoo(ServletRequest r, String base) throws SQLException {

		ResultSet resultatReq;

		//Rcupration de tous les paramtres

		String type = r.getParameter("Type");
		String periode = r.getParameter("Periode");
		String dateDebut = r.getParameter("Date_Debut");
		String dateFin = r.getParameter("Date_Fin");
		String edition = r.getParameter("Edition");
		String cpteDebut = r.getParameter("Cpte_Debut");
		String cpteFin = r.getParameter("Cpte_Fin");
		String edCpte = r.getParameter("Ed_Cpte");

		int cpteDebutInt=10000000;
		int cpteFinInt=99999999;

		String reqBD="";
		String whereReq=" (s.Total_Credit<>0 OR s.Total_Debit<>0) and c.Numero_Compte=s.Numero_Compte "; //on affiche jamais les compte pour lesquel credit=debit=0
		String fromReq=" "+base+".SOLDE_COMPTE s,"+ baseDossier +".COMPTE c ";
		String selectReq="";
		String groupByReq="";

		//pour la requete par priode
		String typeCompteCond="";
		String limitNumCompte="";

		boolean enleverSoldesNuls=false;
		boolean lesTotaux=false;
		boolean comptesGeneraux=true;


		//LES CONDITIONS SIMPLES:

		/*sold ou non ?*/
		if (edCpte.equalsIgnoreCase("N")) {
			//T=tous, N= que les non soldes (solde<>0)
			enleverSoldesNuls=true;
		}

		/*trie sur le numero des compte*/
		if (cpteDebut!=null && cpteFin!=null && edition.equalsIgnoreCase("P"))
		{
			whereReq+=" AND c.Numero_Compte>'"+cpteDebut+"' AND c.Numero_Compte<'"+cpteFin+"' ";
			limitNumCompte+=" AND c.Numero_Compte>'"+cpteDebut+"' AND c.Numero_Compte<'"+cpteFin+"' ";
		}

		/*Faut les toto ??*/
		if (edition.equalsIgnoreCase("T"))
		{
			lesTotaux=true;
		}

		/* Traitrement du type de balance: Client, Fournisseur, Generale ou Globale*/

		if (type.equalsIgnoreCase("F")||type.equalsIgnoreCase("C"))comptesGeneraux=false;

		if (type.equalsIgnoreCase("F")||type.equalsIgnoreCase("C")||type.equalsIgnoreCase("G"))
		{
			whereReq+=" AND c.Type_Compte='"+type+"' ";
			typeCompteCond=" AND c.Type_Compte='"+type+"' ";
		}
		else if (type.equalsIgnoreCase("T"))
		{
			whereReq+=" AND c.Type_Compte='G' ";
			typeCompteCond=" AND c.Type_Compte='G' ";
		}


		/*Traitement de la priode: exercice courant ou date  date*/

		if (periode.equalsIgnoreCase("dd"))
		{//c'est de date  date, il faut les chercher dans la table OPERATION
			//la requete change totalement



			reqBD="";

			if (comptesGeneraux)reqBD+="(";
			reqBD+="SELECT sum(o.Montant_D) as debit, sum(o.Montant_C) as credit, c.Numero_Compte as compte, c.Intitule as libelle ";
			reqBD+="FROM "+base+".OPERATION o ,"+base+".SOLDE_COMPTE s,"+ baseDossier+".COMPTE c  ";
			reqBD+="WHERE  (s.Total_Credit<>0 OR s.Total_Debit<>0) "+typeCompteCond+"  AND o.Numero_Compte=c.Numero_Compte AND s.Numero_Compte=c.Numero_Compte ";
			reqBD+=limitNumCompte;
			reqBD+="AND o.Date_Op<="+transformerDateEnMilis(dateFin)+" AND o.Date_Op>="+transformerDateEnMilis(dateDebut)+" GROUP BY (c.Numero_Compte)";

			if (comptesGeneraux)
			{
				reqBD+=") UNION (";
				reqBD+="SELECT sum(o.Montant_D) as debit, sum(o.Montant_C) as credit, '41100000' as compte, 'CLIENT' as libelle ";
				reqBD+="FROM "+base+".OPERATION o ,"+baseDossier+".COMPTE c  ";
				reqBD+="WHERE  c.Type_Compte='C'  AND o.Numero_Compte=c.Numero_Compte AND o.Date_Op<="+transformerDateEnMilis(dateFin)+" AND o.Date_Op>="+transformerDateEnMilis(dateDebut)+" ";
				reqBD+=limitNumCompte;
				reqBD+="GROUP BY (c.Type_Compte)";
				reqBD+=") UNION (";
				reqBD+="SELECT sum(o.Montant_D) as debit, sum(o.Montant_C) as credit, '40100000' as compte,'FOURNISSEUR' as libelle  ";
				reqBD+="FROM "+base+".OPERATION o ,"+baseDossier+".COMPTE c   ";
				reqBD+="WHERE  c.Type_Compte='F'  AND o.Numero_Compte=c.Numero_Compte AND o.Date_Op<="+transformerDateEnMilis(dateFin)+" AND o.Date_Op>="+transformerDateEnMilis(dateDebut)+" ";
				reqBD+=limitNumCompte;
				reqBD+="GROUP BY (c.Type_Compte))";
			}
			reqBD+="order by compte ";


		}
		else if (periode.equalsIgnoreCase("ec"))
		{

			selectReq="c.Numero_Compte as compte, c.Intitule as libelle, s.Total_Credit as credit,s.Total_Debit as debit ";

			reqBD="SELECT "+selectReq;
			reqBD+=" FROM "+fromReq+" WHERE "+whereReq+" "+groupByReq;
			reqBD+=" order by c.Numero_Compte";

		}
		else
		{
			selectReq="c.Numero_Compte as compte, c.Intitule as libelle, s.Total_Credit as credit,s.Total_Debit as debit ";
			reqBD="SELECT "+selectReq;
			reqBD+=" FROM "+fromReq+" WHERE "+whereReq+" "+groupByReq;
			reqBD+=" order by c.Numero_Compte";

			//on fait comme si c'tait ec
		}


		Statement stt = con.createStatement();
		resultatReq=stt.executeQuery(reqBD);

		preparerOoo();

		if (lesTotaux) {
			creerTableauTotaux(resultatReq, enleverSoldesNuls, cpteDebutInt, cpteFinInt);
		}
		else {
			creerTableauBalance(resultatReq, enleverSoldesNuls, cpteDebutInt, cpteFinInt);
		}
		resultatReq.close();

	}


	/**
	 * Prepare les styles pour Ooo et le crateur
	 **/
	private void preparerOoo() {

		dieu=new CreateurOpenOffice(chemin+"/openoffice");

		//dbit, crdit, solde... en gras et centrs
		enteteColonneStyle=dieu.creerNewStyleCellule();
		enteteColonneStyle.setGras(true);
		enteteColonneStyle.setAlignementHorizontal(OooStyleCellule.H_CENTRE);
		enteteColonneStyle.setTaillePolice(12);
		enteteColonneStyle.setCouleurFond("#c3d4e1");
		enteteColonneStyle.setBordure(true);
		enteteColonneStyle.setFormatNombre(OooStyleCellule.FORMAT_NOMBRE_FLOAT);

		// total: sur fond gris et en gras
		ligneTotalStyle=dieu.creerNewStyleCellule();
		ligneTotalStyle.setCouleurFond("#aaaaaa");
		ligneTotalStyle.setGras(true);
		ligneTotalStyle.setBordure(true);
		ligneTotalStyle.setFormatNombre(OooStyleCellule.FORMAT_NOMBRE_FLOAT);

		titreStyle=dieu.creerNewStyleCellule();
		titreStyle.setTaillePolice(14);
		titreStyle.setCouleurPolice("#00ffff");
		titreStyle.setAlignementHorizontal(OooStyleCellule.H_CENTRE);
		titreStyle.setCouleurFond("#000000");
		titreStyle.setBordure(true);
		titreStyle.setFormatNombre(OooStyleCellule.FORMAT_NOMBRE_FLOAT);

		styleStandard=dieu.creerNewStyleCellule();
		styleStandard.setBordure(true);
		styleStandard.setFormatNombre(OooStyleCellule.FORMAT_NOMBRE_FLOAT);
	}


	/**
	 * Gnre le tableau d'une balance normale = pas celle des totaux
	 **/
	private void creerTableauBalance(ResultSet resultatReq, boolean enleverSoldesNuls,int cpteDebut,int cpteFin) throws SQLException {

		OooCellule celCompte;
		OooCellule celLib;
		OooCellule celDebit;
		OooCellule celCredit;
		OooCellule celSolde;
		double fdebit;
		double fcredit;

		double totalCredit=0;
		double totalDebit=0;

		OooLigne ligneAEcrire;
		String lecompte=null;

		//Titre
		OooCellule titreCel=new OooCellule("Balance", titreStyle);
		titreCel.setFusion(1,5);
		ligneAEcrire=new OooLigne(titreCel, dieu.getStyleLigneParDefaut());
		dieu.ajouterLigne(ligneAEcrire);

		// Entte de titres
		celCompte=new OooCellule("Compte",enteteColonneStyle );
		celLib=new OooCellule("Libell",enteteColonneStyle);
		celDebit=new OooCellule("Dbit",enteteColonneStyle);
		celCredit=new OooCellule("Crdit",enteteColonneStyle);
		celSolde=new OooCellule("Solde",enteteColonneStyle);

		ligneAEcrire=new OooLigne(dieu.getStyleLigneParDefaut());

		ligneAEcrire.ajouterCellule(celCompte);
		ligneAEcrire.ajouterCellule(celLib);
		ligneAEcrire.ajouterCellule(celDebit);
		ligneAEcrire.ajouterCellule(celCredit);
		ligneAEcrire.ajouterCellule(celSolde);

		dieu.ajouterLigne(ligneAEcrire);


		//Et maintenant on gnre d'aprs les rsultats de la requte
		while (resultatReq.next()) {

			lecompte=resultatReq.getString("compte");

			celCompte=new OooCellule(lecompte, styleStandard);
			celLib=new OooCellule(resultatReq.getString("libelle"), styleStandard);

			fdebit=resultatReq.getDouble("debit");
			fcredit=resultatReq.getDouble("credit");

			if (!(enleverSoldesNuls && (fdebit-fcredit)==0))
			{//si on veut que les comptes non solds, on peut s'arrter l.
				celDebit=new OooCellule(fdebit, styleStandard);
				celCredit=new OooCellule(fcredit, styleStandard);
				celSolde=new OooCellule(fdebit-fcredit, styleStandard);

				ligneAEcrire=new OooLigne(dieu.getStyleLigneParDefaut());

				ligneAEcrire.ajouterCellule(celCompte);
				ligneAEcrire.ajouterCellule(celLib);
				ligneAEcrire.ajouterCellule(celDebit);
				ligneAEcrire.ajouterCellule(celCredit);
				ligneAEcrire.ajouterCellule(celSolde);

				dieu.ajouterLigne(ligneAEcrire);

				totalCredit+=fcredit;
				totalDebit+=fdebit;
			}
		}

		if (lecompte!=null)	{
			//On affiche le total:
			OooCellule vide=new OooCellule("", styleStandard);
			ligneAEcrire=new OooLigne(dieu.getStyleLigneParDefaut());
			ligneAEcrire.ajouterCellule(vide);
			ligneAEcrire.ajouterCellule(vide);
			ligneAEcrire.ajouterCellule(vide);
			ligneAEcrire.ajouterCellule(vide);
			ligneAEcrire.ajouterCellule(vide);
			dieu.ajouterLigne(ligneAEcrire);

			celCompte=new OooCellule("Total:",ligneTotalStyle);
			celLib=new OooCellule("",ligneTotalStyle);
			celDebit=new OooCellule(totalDebit,ligneTotalStyle);
			celCredit=new OooCellule(totalCredit,ligneTotalStyle);
			celSolde=new OooCellule(totalDebit-totalCredit,ligneTotalStyle);
			ligneAEcrire=new OooLigne(dieu.getStyleLigneParDefaut());
			ligneAEcrire.ajouterCellule(celCompte);
			ligneAEcrire.ajouterCellule(celLib);
			ligneAEcrire.ajouterCellule(celDebit);
			ligneAEcrire.ajouterCellule(celCredit);
			ligneAEcrire.ajouterCellule(celSolde);

			dieu.ajouterLigne(ligneAEcrire);
		}

		//agrandissement des colonnes
		dieu.changerLargeurColonne(1,7.0f);//libelle
		dieu.changerLargeurColonne(2,3.0f); //credit
		dieu.changerLargeurColonne(3,3.0f); //debit
		dieu.changerLargeurColonne(4,3.0f); //solde
	}


	/**
	 * Gnre le tableau des totaux
	 **/
	private void creerTableauTotaux(ResultSet resultatReq, boolean enleverSoldesNuls,int cpteDebut,int cpteFin) throws SQLException	{

		OooCellule celLib;
		OooCellule celDebit;
		OooCellule celCredit;
		OooCellule celSolde;
		OooLigne ligneAEcrire;

		double sommeDebit2c=0;
		double sommeCredit2c=0;
		double sommeDebit1c=0;
		double sommeCredit1c=0;

		int oldClasse1c; //1 chiffre
		int oldClasse2c; //2 chiffres
		String leCompte;

		//Titre
		OooCellule titreCel=new OooCellule("Balance: les totaux", titreStyle);
		titreCel.setFusion(1,4);
		ligneAEcrire=new OooLigne(titreCel,dieu.getStyleLigneParDefaut());
		dieu.ajouterLigne(ligneAEcrire);


		//Entte
		ligneAEcrire=new OooLigne(dieu.getStyleLigneParDefaut());

		ligneAEcrire.ajouterCellule(new OooCellule("Intitul du compte",enteteColonneStyle));
		ligneAEcrire.ajouterCellule(new OooCellule("Dbit",enteteColonneStyle));
		ligneAEcrire.ajouterCellule(new OooCellule("Crdit",enteteColonneStyle));
		ligneAEcrire.ajouterCellule(new OooCellule("Solde",enteteColonneStyle));

		dieu.ajouterLigne(ligneAEcrire);

		/*INIT*/
		resultatReq.next();//SQLException
		leCompte=resultatReq.getString("compte");//SQLException


		oldClasse1c=Integer.parseInt(leCompte.substring(0,1));
		oldClasse2c=Integer.parseInt(leCompte.substring(0,2));

		int memClasse2c=oldClasse2c;

		sommeDebit2c=resultatReq.getDouble("debit");//SQLException
		sommeCredit2c=resultatReq.getDouble("credit");//SQLException
		sommeDebit1c=resultatReq.getDouble("debit");//SQLException
		sommeCredit1c=resultatReq.getDouble("credit");//SQLException

		while (resultatReq.next()) {

			leCompte=resultatReq.getString("compte");


			if (Integer.parseInt(leCompte.substring(0,1))!=oldClasse1c)	{


				//Pour deux chiffre
				celLib=new OooCellule("Total classe "+oldClasse2c, styleStandard);
				celDebit=new OooCellule(sommeDebit2c, styleStandard);
				celCredit=new OooCellule(sommeCredit2c, styleStandard);
				celSolde=new OooCellule(sommeDebit2c-sommeCredit2c, styleStandard);

				if (!(enleverSoldesNuls&& (sommeDebit2c-sommeCredit2c)==0))
				{

					ligneAEcrire=new OooLigne(dieu.getStyleLigneParDefaut());

					ligneAEcrire.ajouterCellule(celLib);
					ligneAEcrire.ajouterCellule(celDebit);
					ligneAEcrire.ajouterCellule(celCredit);
					ligneAEcrire.ajouterCellule(celSolde);

					dieu.ajouterLigne(ligneAEcrire);
				}

				//Pour un chiffre
				celLib=new OooCellule("Total classe "+oldClasse1c, styleStandard);
				celDebit=new OooCellule(sommeDebit1c, styleStandard);
				celCredit=new OooCellule(sommeCredit1c, styleStandard);
				celSolde=new OooCellule(sommeDebit1c-sommeCredit1c, styleStandard);

				if (!(enleverSoldesNuls&& (sommeDebit1c-sommeCredit1c)==0))
				{
					ligneAEcrire=new OooLigne(dieu.getStyleLigneParDefaut());

					ligneAEcrire.ajouterCellule(celLib);
					ligneAEcrire.ajouterCellule(celDebit);
					ligneAEcrire.ajouterCellule(celCredit);
					ligneAEcrire.ajouterCellule(celSolde);

					dieu.ajouterLigne(ligneAEcrire);
				}


				oldClasse1c=Integer.parseInt(leCompte.substring(0,1));
				oldClasse2c=Integer.parseInt(leCompte.substring(0,2));

				sommeCredit1c=0;
				sommeDebit1c=0;
				sommeCredit2c=0;
				sommeDebit2c=0;
			}
			else if (Integer.parseInt(leCompte.substring(0,2))!=oldClasse2c) {

				celLib=new OooCellule("Total classe "+oldClasse2c, styleStandard);
				celDebit=new OooCellule(sommeDebit2c, styleStandard);
				celCredit=new OooCellule(sommeCredit2c, styleStandard);
				celSolde=new OooCellule(sommeDebit2c-sommeCredit2c, styleStandard);

				ligneAEcrire=new OooLigne(dieu.getStyleLigneParDefaut());

				if (!(enleverSoldesNuls&& (sommeDebit2c-sommeCredit2c)==0))	{

					ligneAEcrire.ajouterCellule(celLib);
					ligneAEcrire.ajouterCellule(celDebit);
					ligneAEcrire.ajouterCellule(celCredit);
					ligneAEcrire.ajouterCellule(celSolde);

					dieu.ajouterLigne(ligneAEcrire);
				}

				oldClasse2c=Integer.parseInt(leCompte.substring(0,2));
				sommeCredit2c=0;
				sommeDebit2c=0;
			}

			if (!(enleverSoldesNuls&& (sommeDebit2c-sommeCredit2c)==0))	{
				sommeCredit1c+=resultatReq.getDouble("credit");//SQLException
				sommeDebit1c+=resultatReq.getDouble("debit");//SQLException

				sommeCredit2c+=resultatReq.getDouble("credit");//SQLException
				sommeDebit2c+=resultatReq.getDouble("debit");//SQLException
			}
		}


		//Manque les deux derniers totaux, sauf si y a qu'un total

		if(memClasse2c!=oldClasse2c) {
			//Pour deux chiffre
			celLib=new OooCellule("Total classe "+oldClasse2c, styleStandard);
			celDebit=new OooCellule(sommeDebit2c, styleStandard);
			celCredit=new OooCellule(sommeCredit2c, styleStandard);
			celSolde=new OooCellule(sommeDebit2c-sommeCredit2c, styleStandard);

			if (!(enleverSoldesNuls&& (sommeDebit2c-sommeCredit2c)==0)) {

				ligneAEcrire=new OooLigne(dieu.getStyleLigneParDefaut());

				ligneAEcrire.ajouterCellule(celLib);
				ligneAEcrire.ajouterCellule(celDebit);
				ligneAEcrire.ajouterCellule(celCredit);
				ligneAEcrire.ajouterCellule(celSolde);

				dieu.ajouterLigne(ligneAEcrire);
			}
		}


		//Pour un chiffre
		celLib=new OooCellule("Total classe "+oldClasse1c, styleStandard);
		celDebit=new OooCellule(sommeDebit1c, styleStandard);
		celCredit=new OooCellule(sommeCredit1c, styleStandard);
		celSolde=new OooCellule(sommeDebit1c-sommeCredit1c, styleStandard);

		if (!(enleverSoldesNuls&& (sommeDebit1c-sommeCredit1c)==0)) {
			ligneAEcrire=new OooLigne(dieu.getStyleLigneParDefaut());

			ligneAEcrire.ajouterCellule(celLib);
			ligneAEcrire.ajouterCellule(celDebit);
			ligneAEcrire.ajouterCellule(celCredit);
			ligneAEcrire.ajouterCellule(celSolde);


			dieu.ajouterLigne(ligneAEcrire);
		}

		//agrandissement des colonnes

		dieu.changerLargeurColonne(0,5.0f); //total classe x
		dieu.changerLargeurColonne(1,3.0f); //credit
		dieu.changerLargeurColonne(2,3.0f); //debit
		dieu.changerLargeurColonne(3,3.0f); //solde
	}


	/**
	 * Transforme une datede type 12/01/05 en milisecondes
	 **/
	private long transformerDateEnMilis(String date) {

		return DateTime.parseDate(date, "dd/MM/yy");
	}

}
