package org.opensi.compta.actions.transferts;


import org.opensi.util.tools.DataCheck;


public class CheckCompta {

	
	private ErrorLog elog;
	private boolean useLog = false;
	
	
	private int line = 0;
	
	
	private long debutExercice;
	private long finExercice;
	private long periodeDebutExercice;
	

	public CheckCompta(long debutExercice, long finExercice, long periodeDebutExercice) {
	
		this.debutExercice = debutExercice;
		this.finExercice = finExercice;
		this.periodeDebutExercice = periodeDebutExercice;
	}

	/*public CheckCompta(ErrorLog elog) {
		
		this.elog = elog;
	}*/
	
	
	public void setErrorLog(ErrorLog elog) {
	
		this.elog = elog;
		
		useLog = !(elog==null);
	}
	

	
	public boolean checkCodeJournal(String codeJournal) {	
		
		if (!DataCheck.isAlphaNum(codeJournal)) {
			
			putError("Code journal incorrect");
			return false;
		}
		
		return true;		
	}
	
	
	public boolean checkPeriode(long periode) {
		
		if (periode == -1 || !DataCheck.isPeriode(periode)) {
			
			putError("Date d'criture incorrecte");
			return false;
		}
		else if (periode > finExercice || periode < periodeDebutExercice) {
		
			putError("Date d'criture hors exercice");
			return false;
		}
		
		return true;
	}
	
	
	public boolean checkTypeCompte(String type) {
		
		if (!DataCheck.isTypeCompte(type)) {
		
			putError("Type de compte incorrect");
			return false;
		}
		
		return true;
	}
	
	
	public boolean checkIntituleCompte(String intitule) {
		
		if (DataCheck.isEmpty(intitule)) {
		
			putWarn("Intitul de compte vide");
			return false;
		}
		
		return true;
	}		
		
		
	public boolean checkNumeroCompte(String numero, String type) {
		
		if (type.equals("G") && !DataCheck.isCpteGen(numero)) {
		
			putError("Compte gnral incorrect");
			return false;
		}
		else if (!type.equals("G") && !DataCheck.isCpteTiers(numero)) {
			
			putError("Compte de tiers incorrect");
			return false;
		}
		
		return true;
	}
	
	public boolean checkNumeroCompte(String numero) {
	
		if (!DataCheck.isCpteGen(numero) && !DataCheck.isCpteTiers(numero)) {
		
			putError("Numro de compte incorrect");
			return false;
		}
		
		return true;
	}
	
	
	public boolean checkMontantOp(int montant) {
	
		if (montant==0) {
		
			putError("Montant d'opration nul");
			return false;
		}
	
		return true;
	}
	
	
	public boolean checkLibelleOp(String libelle) {
	
		if (DataCheck.isEmpty(libelle)) {
		
			putWarn("Libell d'opration vide");
			return false;
		}
	
		return true;
	}
	
	
	public boolean checkDateOp(long date) {
	
		if (!DataCheck.isDateOp(date)) {
		
			putError("Date d'opration incorrecte");
			return false;
		}
		else if (date > finExercice) {
		
			putError("Date d'opration ultrieure  la fin de l'exercice");
			return false;
		}
	
		return true;
	}
	

	public boolean checkDate(long date) {
	
		if (!DataCheck.isDateOp(date)) {
		
			putError("Date d'opration incorrecte");
			return false;
		}
		else if (date < debutExercice) {
		
			putError("Date d'opration infrieure au dbut de l'exercice");
			return false;
		}
		else if (date > finExercice) {
		
			putError("Date d'opration ultrieure  la fin de l'exercice");
			return false;
		}
	
		return true;
	}


	public boolean checkEmpty(String valeur,String text) {
	
		if (DataCheck.isEmpty(valeur)) {
		
			putError(text);
			return false;
		}
	
		return true;
	}
	
	
	public void setLine(int line) {
	
		this.line = line;
	}
	
	
	public void incLine() {
	
		line += 1;
	}
	
	
	private void putError(String error) {
		
		if (useLog) {
			elog.addError(line, error);
		}
		else {
			System.out.println("Erreur ligne "+ line +"\t --> "+ error);
		}
	}
	
	private void putWarn(String warn) {
	
		if (useLog) {
			elog.addWarn(line, warn);
		}
		else {
			System.out.println("Warning ligne "+ line +"\t --> "+ warn);
		}
	}
	
	
} // fin CheckCompta
