package org.opensi.compta.actions.transferts;


import java.util.ArrayList;


public class EcritureOxf {


	private String codeJournal;
	private long dateEcriture;
	
	private ArrayList<OperationOxf> operations = new ArrayList<OperationOxf>();


	public EcritureOxf(String codeJournal, long dateEcriture) {
	
		this.codeJournal = codeJournal;
		this.dateEcriture = dateEcriture;	
	}
	
	
	public String getCodeJournal() { return codeJournal; }
	public long getDateEcriture() { return dateEcriture; }
	
	
	public void addOp(OperationOxf operationOxf) {
	
		operations.add(operationOxf);
	}
	
	public OperationOxf getOp(int index) {
	
		return operations.get(index);
	}
	
	
	public int getSize() {
		
		return operations.size();
	}
	
	
	public boolean isStable() {
		
		int debit = 0;
		int credit = 0;
		
		for (int i=0; i<operations.size(); i++) {
			debit += getOp(i).getMontantD();
			credit += getOp(i).getMontantC();
		}
		
		if (debit!=credit) {
			System.out.println("CJ: "+ codeJournal +" Date : "+ dateEcriture +" Debit : "+ debit +" Credit : "+ credit);
		}
		
		return debit==credit;
	}


} // fin EcritureOxf
