/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 *   Import de donnes comptables OpenSi
 */

package org.opensi.compta.actions.transferts;


import org.xml.sax.XMLReader;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import org.xml.sax.helpers.XMLReaderFactory;


public class ImportOpenSi extends ImportCompta {


	public ImportOpenSi(String s_, String base, String fichierImport, String ecraser, String journal) {
		
		super(s_, base, fichierImport, ecraser, journal);
	}


	public void importer() throws Exception {	
		
		try {

			String vendorParserClass = "org.apache.xerces.parsers.SAXParser";
			String oxfURI = fichier;			

			XMLReader oxfReader = XMLReaderFactory.createXMLReader(vendorParserClass);

			OxfHandler oxfHandler = new OxfHandler(cc, ecritures, comptes);

			oxfReader.setContentHandler(oxfHandler);
			oxfReader.setErrorHandler(oxfHandler);

			InputSource source = new InputSource(oxfURI);

			oxfReader.parse(source);			

		}
		catch(SAXException saxe) {
			System.out.println("Erreur saxe :"+ saxe.getMessage());
			saxe.printStackTrace();
		}
	}
	

} // fin ImportOpenSi



