/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/
  
/**
 *  Gnration d'une criture d' nouveaux temporaires 
 */

package org.opensi.compta.exercice;


import java.sql.*;

import org.experlog.openeas.api.ServletRequest;
import org.experlog.openeas.api.Action;
import org.experlog.openeas.api.Session;


public class GenANouveauxTemporaires extends Action {


  public boolean serverSide() { return true; }

  public boolean service(Session s, ServletRequest r, Object info) throws Exception {


		Connection con = s.getConnection(null);
		
		String baseN1 = r.getParameter("BaseN1");
		String baseN2 = r.getParameter("BaseN2");
		long dateANouveau = Long.parseLong(r.getParameter("DateANouveau"));
			
		ANouveauxFactory anf = new ANouveauxFactory(con, baseN1, baseN2, s.getCookie().get("BaseDossier"), dateANouveau, true);
		
		anf.insertEcriture();
		
		s.closeConnection(con, null);
		
		return true;			
	}
	
} // fin GenANouveauxTemporaires











