/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


package org.opensi.compta.persist;


import java.util.Hashtable;
import java.sql.*;


public class EcrituresManager {


	private static EcrituresManager ecrituresManager;
	
	
	private Hashtable<String, EcrituresSet> listeES = new Hashtable<String, EcrituresSet>();
 

  private EcrituresManager() {}


  public static EcrituresManager getInstance() {    
    
		if (ecrituresManager == null) {	
			ecrituresManager = new EcrituresManager();
    }
    return ecrituresManager;
  }
	
	
	public EcrituresSet getEcrituresSet(String session, String base) throws SQLException {
		
		String idUnique = session + base; // identifiant pour l'ecritureSet
		
    if (listeES.containsKey(idUnique)) {
     	return listeES.get(idUnique);
    }
		else {		
			EcrituresSet ecrituresSet = new EcrituresSet(session);
      listeES.put(idUnique, ecrituresSet);
			return ecrituresSet;
		}
	}

	
} // fin EcrituresManager
