/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

package org.opensi.facturation;


import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;

import org.experlog.openeas.api.Session;


public class CalculStock {

	private Connection con;
	private String base;
	private Session s;	
	private PreparedStatement psListeArt;
	private PreparedStatement psListeCom;
	private PreparedStatement psListeArtCom;
	private PreparedStatement psListeArtComHorsStock;
	private Double valeur [];
	private double stock;
	private double total;
	private double horsStock;
	private int comWebId;
	               
	private String reqListeArt;
	private String reqListeCom;
	private String reqListeArtCom;
	private String reqListeArtComHorsStock;

	private boolean calculStockReserve;

	private HashMap <String, Double> listeArt  = new HashMap<String, Double>(1000);
	private HashMap <Integer, Double[]> listeCom  = new HashMap<Integer, Double[]>(500);
	private String reqComposants;
	private PreparedStatement psCompStock;

	public CalculStock(String s_, int dispo) {
		try {

			s = Session.findClient(s_);
			con = s.getConnection(null);
			base = s.getCookie().get("BaseDossier");
			this.calculStockReserve=(dispo==1);
			init();

		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public CalculStock(Session s, int dispo) {
		try {

			con = s.getConnection(null);
			base = s.getCookie().get("BaseDossier");
			this.calculStockReserve=(dispo==1);
			init();

		} catch(Exception e) {
			e.printStackTrace();
		}
	}

	private void init() {
		try {
			reqComposants = "select ArticleComp_Id, Quantite, coalesce(Stock_Init+Entrees-Sorties,0) as reel from "+ base +".FICHE_ARTICLE a, "+ base +".COMPOSANT_ARTICLE c left join "+ base +".STOCKS_ARTICLE sa on sa.Article_Id=c.ArticleComp_Id where a.Article_Id=c.Article_Id and a.Composition='F' and a.Article_Id=?";   

			
			reqListeArt = "select distinct sa.Article_Id,coalesce(Stock_Init+Entrees-Sorties,0) as reel from "+ base +".COMMANDE_WEB cw join "+ base +".ARTICLE_COMMANDE_WEB acw on cw.Com_Web_Id=acw.Com_Web_Id";
			reqListeArt += " left join "+base +".STOCKS_ARTICLE sa on sa.Article_Id=acw.Article_Id where acw.Type_Ligne='S' and Statut_Commande='C'";   

			psListeArt = con.prepareStatement(reqListeArt);

			ResultSet rsetli = psListeArt.executeQuery();
			while (rsetli.next()) {
				ajoutliste(rsetli.getString("Article_Id"), rsetli.getDouble("reel"));
			}

			reqListeArtCom = "select sa.Article_Id,if((coalesce(sum(acw.Quantite),0)- qr.BL)>0,(coalesce(sum(acw.Quantite),0)- qr.BL),0) as Quantite" +
			" from "+base +".STOCKS_ARTICLE sa join "+base +".ARTICLE_COMMANDE_WEB acw on sa.Article_Id=acw.Article_Id" +
			" join (select acw2.Article_Id,coalesce(sum(if(bl2.Etat='V', abl2.Quantite, 0)),0) as BL from  "+base +".ARTICLE_COMMANDE_WEB acw2" +
			" left join "+base +".ARTICLE_BON_LIVRAISON abl2 on acw2.Detail_Id=abl2.Ref_Ligne_Web left join "+base +".BON_LIVRAISON bl2 on abl2.Bon_Id=bl2.Bon_Id" +
			" where acw2.Com_Web_Id =? and Type_Ligne='S' group by acw2.Article_Id) as qr on qr.Article_Id=acw.Article_Id" +
			" where acw.Com_Web_Id =? and Type_Ligne='S' group by sa.Article_Id";

			psListeArtCom = con.prepareStatement(reqListeArtCom);
			
			reqListeArtComHorsStock = "select Com_Web_Id,coalesce(sum(acw.Quantite-qr.BL),0) as Quantite" +
			" from "+base +".ARTICLE_COMMANDE_WEB acw" +
			" join (select acw2.Detail_Id,coalesce(sum(if(bl2.Etat='V', abl2.Quantite, 0)),0) as BL from  "+base +".ARTICLE_COMMANDE_WEB acw2" +
			" left join "+base +".ARTICLE_BON_LIVRAISON abl2 on acw2.Detail_Id=abl2.Ref_Ligne_Web left join "+base +".BON_LIVRAISON bl2 on abl2.Bon_Id=bl2.Bon_Id" +
			" where acw2.Com_Web_Id =? and Type_Ligne='I' group by acw2.Detail_Id) as qr on qr.Detail_Id=acw.Detail_Id" +
			" where acw.Com_Web_Id =? and Type_Ligne='I' group by Com_Web_Id";

			psListeArtComHorsStock = con.prepareStatement(reqListeArtComHorsStock);
						
			reqListeCom = "select Com_Web_Id from "+base +".COMMANDE_WEB where Statut_Commande='C' order by Date_Validation";
			psListeCom = con.prepareStatement(reqListeCom);
			ResultSet rsetcom = psListeCom.executeQuery();
			while (rsetcom.next()) {
				comWebId = rsetcom.getInt("Com_Web_Id");
				valeur=new Double[3];
				stock=0;
				total=0;
				horsStock=0;
				psListeArtCom.setInt(1, comWebId);
				psListeArtCom.setInt(2, comWebId);
				ResultSet rsetArtcom = psListeArtCom.executeQuery();
				while (rsetArtcom.next()) {
					String article_id = rsetArtcom.getString("Article_Id");
					calcul(rsetArtcom,article_id,1);
				}
				valeur[0]= stock;
				valeur[1]= total;
				
				psListeArtComHorsStock.setInt(1, comWebId);
				psListeArtComHorsStock.setInt(2, comWebId);
				ResultSet rsetArtcomHorsStock = psListeArtComHorsStock.executeQuery();
				while (rsetArtcomHorsStock.next()) {
					horsStock = rsetArtcomHorsStock.getDouble("Quantite");
				}

				valeur[2]= horsStock;
				listeCom.put(comWebId, valeur);
			}

		} catch(Exception e) {
			e.printStackTrace();
		}
	}

	public void ajoutliste(String article_id, double reel) {
		try {
			psCompStock = con.prepareStatement(reqComposants);
			psCompStock.setString(1, article_id);
			ResultSet rset = psCompStock.executeQuery();
			if (rset.next()) {
				do {			
					ajoutliste(rset.getString("ArticleComp_Id"),rset.getDouble("reel"));
				}	
				while (rset.next());
			}
			else {
				listeArt.put(article_id,reel);
			}
			
		} catch(Exception e) {
			e.printStackTrace();
		}
	}

	
	public void calcul(ResultSet rsetArtcom, String article_id, double multiple) {
		try {
			PreparedStatement psComp = con.prepareStatement(reqComposants);
			psComp.setString(1, article_id);
			ResultSet rset = psComp.executeQuery();
			if (rset.next()) {
				do {			
					calcul(rsetArtcom,rset.getString("ArticleComp_Id"),rset.getDouble("Quantite"));
				}	
				while (rset.next());
			}
			else {

				double reel = listeArt.get(article_id);
				double alivrer = rsetArtcom.getDouble("Quantite")*multiple;
				total+=alivrer;
				double ajout=(reel>0)?((reel<=alivrer && reel>0)?reel:alivrer):0;
				stock+=ajout;
				if (calculStockReserve) {
					listeArt.put(article_id,reel-ajout);
				}	
			}
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
		
	public double stock(int Com_Web_Id) {
		try {
			return listeCom.containsKey(Com_Web_Id)?listeCom.get(Com_Web_Id)[0]:0;
		} catch(Exception e) {
			e.printStackTrace();
			return 0.0;
		}
	}

	public double total(int Com_Web_Id) {
		try {
			return listeCom.containsKey(Com_Web_Id)?listeCom.get(Com_Web_Id)[1]:0;
		} catch(Exception e) {
			e.printStackTrace();
			return 0.0;
		}
	}
	
	public double horsstock(int Com_Web_Id) {
		try {
			return listeCom.containsKey(Com_Web_Id)?listeCom.get(Com_Web_Id)[2]:0;
		} catch(Exception e) {
			e.printStackTrace();
			return 0.0;
		}
	}
	
	protected void finalize() {
		try {
			if (s!=null) {
				s.closeConnection(con, null);
			}
		}
		catch(SQLException e) {
			e.printStackTrace();
		}
	}	


} // fin StockManager

