/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

package org.opensi.facturation.actions.comweb;



import java.sql.*;

import org.experlog.openeas.api.Session;
import org.opensi.util.tools.DateTime;


public class Historique {
	
	private Connection con;
	private String base;
	
	private Session s;	

	private PreparedStatement psHist;
	private String login;
	private int comWebId;
	private long dateHist;
	
	
	
	public Historique(String s_, int comWebId) {
		try {
	
			s = Session.findClient(s_);
			this.con = s.getConnection(null);
			this.base = s.getCookie().get("BaseDossier");
			this.login = s.getCookie().get("User");
			this.comWebId = comWebId;
			this.dateHist = (new DateTime()).getTimeInMillis();
			init();
			
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public Historique(Connection con,String nom_base,String login, int comWebId) {
		try {
	
			this.con = con;
			this.base = nom_base;
			this.login = login;
			this.comWebId = comWebId;
			this.dateHist = (new DateTime()).getTimeInMillis();
		init();
			
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public Historique(Connection con,String nom_base,String login, int comWebId,long dateHist) {
		try {
			
			this.dateHist = dateHist;
			this.con = con;
			this.base = nom_base;
			this.login = login;
			this.comWebId = comWebId;
			init();
			
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	private void init() {
		try {
			
			psHist = con.prepareStatement("insert into "+ base +".HISTORIQUE_ARTICLE_COMMANDE_WEB (Com_Web_Id,Date,Login,Detail_Id,Article_Id,Libelle)" +
					" values ("+this.comWebId+","+dateHist+",'"+this.login+"',?,?,?)");
		
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void addHist(int detailId,String articleId, String libelle) {
		try {
			psHist.setInt(1,detailId);
			psHist.setString(2,articleId);
			psHist.setString(3,libelle);
			psHist.executeUpdate();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	

} // fin StockManager

