/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

package org.opensi.facturation.actions.comweb;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;

import org.experlog.openeas.api.Action;
import org.experlog.openeas.api.ServletRequest;
import org.experlog.openeas.api.Session;
import org.opensi.facturation.StockManager;
import org.opensi.util.tools.DateTime;


public class ValiderModCommande extends Action {

	private Connection con;
	private String base;
	private int comWebId;
	private StockManager stockManager;
	private Historique historique;
	private String login;
	private String statut="";

	public boolean serverSide() { return true; }

	public boolean service(Session s, ServletRequest r, Object info) throws Exception {

		try {

			base = s.getCookie().get("BaseDossier");
			login = s.getCookie().get("Login");
			con = s.getConnection(null);
			comWebId = Integer.parseInt(r.getParameter("Com_Web_Id"));
			long dateHist = (new DateTime()).getTimeInMillis();

			stockManager = new StockManager(con,base);
			historique = new Historique(con,base,login,comWebId,dateHist);


			Statement stt = con.createStatement();

			String reqBL = "select Statut_Commande from "+ base +".COMMANDE_WEB where Com_Web_Id="+comWebId;
			ResultSet rset;
			
			rset = stt.executeQuery(reqBL);
			
			if (rset.next()) {
				this.statut = rset.getString("Statut_Commande");
			}
		
			String upArticleMod = "update "+ base +".ARTICLE_COMMANDE_WEB_MOD acwm, "+ base +".TAUX_TVA t " +
			"set acwm.Taux_TVA=t.Taux_TVA where acwm.Code_TVA=t.Code_TVA and Date=0 and Com_Web_Id="+comWebId;

			stt.executeUpdate(upArticleMod);
			
			String histArticle = "insert into "+ base +".ARTICLE_COMMANDE_WEB_MOD" +
					" (Date,Detail_Id,Com_Web_Id, Rank, Article_Id, Article_Web_Id, Type_Ligne, Designation, Quantite, Prix, Ristourne, Code_TVA, Commentaire, Commentaire_Avant,Libelle, Code_Stats, Nb_Pieces, Unite)" +
					" select "+dateHist+",Detail_Id,Com_Web_Id, Rank, Article_Id, Article_Web_Id, Type_Ligne, Designation, Quantite, Prix, Ristourne, Code_TVA, Commentaire, Commentaire_Avant,Libelle, Code_Stats, Nb_Pieces, Unite" +
					" from "+ base +".ARTICLE_COMMANDE_WEB where Com_Web_Id="+comWebId;

			String deleteArticle = "delete from  "+ base +".ARTICLE_COMMANDE_WEB " +
			" where Com_Web_Id="+comWebId;
			
			String deleteArticleMod = "delete from  "+ base +".ARTICLE_COMMANDE_WEB_MOD " +
			" where Date=0 and Com_Web_Id="+comWebId;

			String newArticle = "insert into "+ base +".ARTICLE_COMMANDE_WEB " +
			" (Detail_Id,Com_Web_Id,Rank,Article_Id,Type_Ligne,Designation,Quantite,Prix,Ristourne,Code_TVA,Taux_TVA,Commentaire,Commentaire_Avant,Libelle, Code_Stats, Unite, Nb_Pieces)" +
			" select if(Detail_Id>0,Detail_Id,0) as Detail_Id,"+comWebId+",Rank,Article_Id,Type_Ligne, Designation, Quantite,Prix,Ristourne,Code_TVA,Taux_TVA,Commentaire,Commentaire_Avant,Libelle, Code_Stats, Unite, Nb_Pieces " +
			" from  "+ base +".ARTICLE_COMMANDE_WEB_MOD where Date=0 and Com_Web_Id="+comWebId;

			String majCom = "update "+ base +".COMMANDE_WEB set Modification=0 where Com_Web_Id="+comWebId;

			PreparedStatement psNew = con.prepareStatement(newArticle);

			String reqNew = "select * from "+ base +".ARTICLE_COMMANDE_WEB_MOD acwm left join "+ base +".ARTICLE_COMMANDE_WEB acw "+
			" on acwm.Detail_Id=acw.Detail_Id and acwm.Com_Web_Id=acw.Com_Web_Id where Date=0 and acw.Article_Id is null and acwm.Com_Web_Id="+comWebId+" order by acw.Rank";

			String reqDel = "select * from "+ base +".ARTICLE_COMMANDE_WEB acw left join "+ base +".ARTICLE_COMMANDE_WEB_MOD acwm "+
			" on acwm.Detail_Id=acw.Detail_Id and acwm.Com_Web_Id=acw.Com_Web_Id and Date=0 where acwm.Article_Id is null and acw.Com_Web_Id="+comWebId;

			String reqUp = "select * from "+ base +".ARTICLE_COMMANDE_WEB_MOD acwm, "+ base +".ARTICLE_COMMANDE_WEB acw "+
			" where Date=0 and acwm.Detail_Id=acw.Detail_Id and acwm.Com_Web_Id=acw.Com_Web_Id and acwm.Com_Web_Id="+comWebId;

			rset = stt.executeQuery(reqDel);
			while (rset.next()) {
				int detail_id=rset.getInt("acw.Detail_Id");
				if (statut.equals("C")) {
					stockManager.decComClients(rset.getString("acw.Article_Id"), rset.getFloat("acw.Quantite"));
				}
				historique.addHist(detail_id, rset.getString("acw.Article_Id"), "suppression de l'article "+rset.getString("acw.Article_Id"));
			}

			rset = stt.executeQuery(reqNew);
			while (rset.next()) {
				int detail_id=rset.getInt("acwm.Detail_Id");
				if (statut.equals("C")) {
					stockManager.incComClients(rset.getString("acwm.Article_Id"), rset.getFloat("acwm.Quantite"));
				}
				historique.addHist(detail_id, rset.getString("acwm.Article_Id"), "ajout de l'article "+rset.getString("acwm.Article_Id"));
			}
			psNew.executeBatch();

			rset = stt.executeQuery(reqUp);
			while (rset.next()) {
				int detail_id=rset.getInt("acw.Detail_Id");
				String type_ligne=rset.getString("acw.Type_Ligne");
				String article_id=rset.getString("acw.Article_Id");
				String designation=rset.getString("acw.Designation");
				float quantite=rset.getFloat("acw.Quantite");
				float prix=rset.getFloat("acw.Prix");
				float ristourne=rset.getFloat("acw.Ristourne");
				int code_tva=rset.getInt("acw.Code_TVA");
				float taux_tva=rset.getFloat("acw.taux_TVA");
				String commentaire=rset.getString("acw.Commentaire");
				String commentaire_avant=rset.getString("acw.Commentaire_Avant");
				String libelle=rset.getString("acw.Libelle");
				String code_stats=rset.getString("acw.Code_Stats");
				float nb_pieces=rset.getFloat("acw.Nb_Pieces");
				String unite=rset.getString("acw.Unite");

				String article_id_mod=rset.getString("acwm.Article_Id");
				String designation_mod=rset.getString("acwm.Designation");
				float quantite_mod=rset.getFloat("acwm.Quantite");
				float prix_mod=rset.getFloat("acwm.Prix");
				float ristourne_mod=rset.getFloat("acwm.Ristourne");
				int code_tva_mod=rset.getInt("acwm.Code_TVA");
				float taux_tva_mod=rset.getFloat("acwm.taux_TVA");
				String commentaire_mod=rset.getString("acwm.Commentaire");
				String commentaire_avant_mod=rset.getString("acwm.Commentaire_Avant");
				String libelle_mod=rset.getString("acwm.Libelle");
				String code_stats_mod=rset.getString("acwm.Code_Stats");
				float nb_pieces_mod=rset.getFloat("acwm.Nb_Pieces");
				String unite_mod=rset.getString("acwm.Unite");

				if (type_ligne.equals("I")) {
					if (!article_id.equals(article_id_mod)) {
						historique.addHist(detail_id, article_id_mod, "modification de la rfrence de l'article '"+article_id_mod+"' : "+article_id+" -> "+article_id_mod);
					}
					if (!designation.equals(designation_mod)) {
						historique.addHist(detail_id, article_id_mod, "modification de la dsignation de l'article '"+article_id_mod+"' : "+designation+" -> "+designation_mod);
					}
					if (quantite!=quantite_mod) {
						historique.addHist(detail_id, article_id_mod, "modification de la quantit de l'article '"+article_id_mod+"' : "+quantite+" -> "+quantite_mod);
					}		
				}
				else if (quantite!=quantite_mod) {
					if (statut.equals("C")) {
						if (quantite<quantite_mod) {
							stockManager.incComClients(article_id_mod, (quantite_mod-quantite));
						}
						else {
							stockManager.decComClients(article_id_mod, (quantite-quantite_mod));
						}
					}
					historique.addHist(detail_id, article_id_mod, "modification de la quantit de l'article '"+article_id_mod+"' : "+quantite+" -> "+quantite_mod);
				}
				if (prix!=prix_mod) {
					historique.addHist(detail_id, article_id_mod, "modification du prix de l'article '"+article_id_mod+"' : "+prix+" -> "+prix_mod);
				}				
				if (ristourne!=ristourne_mod) {
					historique.addHist(detail_id, article_id_mod, "modification de la ristourne de l'article '"+article_id_mod+"' : "+ristourne+" -> "+ristourne_mod);
				}				
				if (code_tva!=code_tva_mod) {
					historique.addHist(detail_id, article_id_mod, "modification du code de tva de l'article '"+article_id_mod+"' : "+code_tva+" -> "+code_tva_mod);
				}			
				if (taux_tva!=taux_tva_mod) {
					historique.addHist(detail_id, article_id_mod, "modification du taux de tva de l'article '"+article_id_mod+"' : "+taux_tva+" -> "+taux_tva_mod);
				}	
				if (!commentaire.equals(commentaire_mod)) {
					historique.addHist(detail_id, article_id_mod, "modification du commentaire de l'article '"+article_id_mod+"' : "+commentaire+" -> "+commentaire_mod);
				}
				if (!commentaire_avant.equals(commentaire_avant_mod)) {
					historique.addHist(detail_id, article_id_mod, "modification du commentaire avant de l'article '"+article_id_mod+"' : "+commentaire_avant+" -> "+commentaire_avant_mod);
				}
				if (!libelle.equals(libelle_mod)) {
					historique.addHist(detail_id, article_id_mod, "modification du libelle de l'article '"+article_id_mod+"' : "+libelle+" -> "+libelle_mod);
				}
				if (!code_stats.equals(code_stats_mod)) {
					historique.addHist(detail_id, article_id_mod, "modification du code stats de l'article '"+article_id_mod+"' : "+code_stats+" -> "+code_stats_mod);
				}
				if (nb_pieces!=nb_pieces_mod) {
					historique.addHist(detail_id, article_id_mod, "modification du nb de pices de l'article '"+article_id_mod+"' : "+nb_pieces+" -> "+nb_pieces_mod);
				}
				if (!unite.equals(unite_mod)) {
					historique.addHist(detail_id, article_id_mod, "modification de l'unit de l'article '"+article_id_mod+"' : "+unite+" -> "+unite_mod);
				}
			}

			stt.executeUpdate(majCom);
			stt.executeUpdate(histArticle);
			stt.executeUpdate(deleteArticle);
			stt.executeUpdate(newArticle);
			stt.executeUpdate(deleteArticleMod);
			return true;
		}
		catch(Exception e) {
			e.printStackTrace();
			return false;
		}
	}
	

} // fin ValiderModCommande

