/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 * Gnration d'un avoir
 */

package org.opensi.facturation.actions.documents;


import org.experlog.openeas.api.ServletRequest;
import org.experlog.openeas.api.Action;
import org.experlog.openeas.api.Session;

import org.opensi.util.pdf.GlobalDocument;

import org.opensi.facturation.actions.documents.modeles.AvoirStd;
import org.opensi.facturation.actions.documents.modeles.DataAvoir;


public class GenAvoir extends Action {


  public boolean serverSide() { return true; }

  public boolean service(Session s, ServletRequest r, Object info) throws Exception {
	
		String fichierPdf = r.getParameter("Document_Id") +".pdf";
		String absdir = s.getAppConfiguration().get("opensi.absdir");
		
		String repPdf = absdir +"/pdf/";
		String repTemp = repPdf;
		
		boolean apercu = (r.getParameter("Apercu") != null);
		long dateAvoir = apercu ? Long.parseLong(r.getParameter("Date_Avoir")) : 0;
		
		GlobalDocument gd = new GlobalDocument(repPdf, fichierPdf);
		
		boolean multi = r.getParameter("MultiEx")!=null;
		
		AvoirStd avoir = new AvoirStd(repTemp, new DataAvoir(s, r.getParameter("Avoir_Id"), apercu, dateAvoir));
		avoir.setMultiEx(multi);
	
		gd.addInternal(avoir);
		
		gd.close(GlobalDocument.ON_EXIT);
	
		return true;
		
	} // fin service


} // fin GenAvoir
