/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 * Gnration d'un devis
 */

package org.opensi.facturation.actions.documents;


import org.experlog.openeas.api.ServletRequest;
import org.experlog.openeas.api.Action;
import org.experlog.openeas.api.Session;

import org.opensi.util.pdf.GlobalDocument;

import org.opensi.facturation.actions.documents.modeles.DevisStd;
import org.opensi.facturation.actions.documents.modeles.DataDevis;


public class GenDevis extends Action {


  public boolean serverSide() { return true; }

  public boolean service(Session s, ServletRequest r, Object info) throws Exception {
	
		String fichierPdf = "devis_"+ r.getParameter("Id_Devis") +".pdf";
		String absdir = s.getAppConfiguration().get("opensi.absdir");
		
		String repPdf = absdir +"/pdf/";
		String repTemp = repPdf;
		
		GlobalDocument gd = new GlobalDocument(repPdf, fichierPdf);
		
		DevisStd devis = new DevisStd(repTemp, new DataDevis(s, r.getParameter("Devis_Id")));
		devis.setAffTotaux(r.getParameter("SansTotaux")==null);
		if (r.getParameter("Marque")!=null)
			devis.setAffMarque(r.getParameter("Marque").equalsIgnoreCase("true"));

		gd.addInternal(devis);		
		
		gd.close(GlobalDocument.ON_EXIT);
	
		return true;
		
	} // fin service


} // fin GenDevis
