/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 * Gnration des expditions par lot (BL + BP et/ou facture)
 */

package org.opensi.facturation.actions.documents;


import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;

import org.experlog.openeas.api.ServletRequest;
import org.experlog.openeas.api.Action;
import org.experlog.openeas.api.Session;

import org.opensi.util.pdf.GlobalDocument;

import org.opensi.facturation.actions.documents.modeles.BonLivraisonStd;
import org.opensi.facturation.actions.documents.modeles.BonPreparationStd;
import org.opensi.facturation.actions.documents.modeles.DataBonLivraison;
import org.opensi.facturation.actions.documents.modeles.DataBonPreparation;
import org.opensi.facturation.actions.documents.modeles.FactureStd;
import org.opensi.facturation.actions.documents.modeles.DataFacture;


public class GenExpeditionLot extends Action {


  public boolean serverSide() { return true; }

  public boolean service(Session s, ServletRequest r, Object info) throws Exception {
	
		String fichierPdf = r.getParameter("FichierPdf");
		String absdir = s.getAppConfiguration().get("opensi.absdir");
		
		String repPdf = absdir +"/pdf/";
		String repTemp = repPdf;
		
		Connection con = s.getConnection(null);
		Statement stt = con.createStatement();
		String base = s.getCookie().get("BaseDossier");
		String[] editions;
		
		boolean blChiffre = false;
		String reqBLChiffre = "select BL_Chiffre from PARAM_DOSSIER where Dossier_Id='"+ s.getCookie().get("Dossier_Id")+"'";
		ResultSet rset = stt.executeQuery(reqBLChiffre);
		if (rset.next()) {
			blChiffre = (rset.getInt("BL_Chiffre")==1);
		}
		rset.close();
		
		GlobalDocument gd = new GlobalDocument(repPdf, fichierPdf);
		if (r.getParameter("Date_Reedition")!=null) {
			long date_reedition = Long.parseLong(r.getParameter("Date_Reedition"));
			
			String liste_editions = "";
			// on recherche pour chaque bl dit  cette date : si il y a un bp associ, et une facture
			String reqEdition = "select bl.Bon_Id, bl.Edition_BP, if(isnull(f.Facture_Id),0,1) as Edition_Fact from "+ base +".BON_LIVRAISON bl";
			reqEdition += " left join "+ base +".FACTURE f on bl.Facture_Id=f.Facture_Id and bl.Date_Edition_Lot=f.Date_Edition_Lot";
			reqEdition += " where bl.Date_Edition_Lot="+ date_reedition;
			ResultSet rsEdition = stt.executeQuery(reqEdition);
			while (rsEdition.next()) {
				liste_editions += rsEdition.getString("Bon_Id") + ",";
				liste_editions += rsEdition.getString("Edition_BP") + ",";
				liste_editions += rsEdition.getString("Edition_Fact") + ",";
			}
			rsEdition.close();
			
			editions = liste_editions.split(",");
		
		} else {
			editions = r.getParameter("Liste_Editions_Docs").split(",");
		}
		
		int i=0;
		String bonId = "";
		boolean editerBP = false;
		boolean editerFacture = false;
		for (int z=0;z<editions.length;z++) {
		
			switch (i) {
				case 0:
					bonId = editions[z];
					break;
				case 1:
					editerBP = (editions[z].equals("1"));
					break;
				case 2:
					editerFacture = (editions[z].equals("1"));
					break;
			}
			i++;
			if (i==3) {
				BonLivraisonStd bonLivraison = new BonLivraisonStd(repTemp, new DataBonLivraison(s, bonId));
				bonLivraison.setBonChiffre(blChiffre);
				gd.addInternal(bonLivraison);
				
				if (editerBP) {
					BonPreparationStd bonPreparation = new BonPreparationStd(repTemp, new DataBonPreparation(s, bonId));
					gd.addInternal(bonPreparation);
				}
				
				if (editerFacture) {
					
					String reqNumFacture = "select Facture_Id from "+ base +".BON_LIVRAISON";
					reqNumFacture += " where Bon_Id="+ bonId;
					String numFacture = "";
					ResultSet rsNumFacture = stt.executeQuery(reqNumFacture);
					if (rsNumFacture.next()) {
						numFacture=rsNumFacture.getString("Facture_Id");
					}
					rsNumFacture.close();
					
					FactureStd facture = new FactureStd(repTemp, new DataFacture(s, numFacture));
					gd.addInternal(facture);
				}
				
				i=0;
			}
		}
		
		stt.close();
		s.closeConnection(con, null);
		
		gd.close(GlobalDocument.ON_EXIT);
	
		return true;
		
	} // fin service


} // fin GenExpeditionLot
