/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 * Donnes ncessaires  l'dition d'un avoir standard
 */

package org.opensi.facturation.actions.documents.modeles;


import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.util.ArrayList;

import org.experlog.openeas.api.Session;
import org.opensi.util.tools.Arrondi;
import org.opensi.util.tools.StringUtils;


public class DataAvoir {


	private DecimalFormatSymbols dfs2 = new DecimalFormatSymbols();
	
	private DecimalFormat numFormatQte = new DecimalFormat("0.##");
	// les lignes de la facture
	protected ArrayList<LigneAvoir> lignes = new ArrayList<LigneAvoir>(10);
	


	// coordonnes socit mettrice

	protected String raisonSociale;
	protected String adresse;
	protected String compAdresse;
	protected String adresse3;	
	protected String codePostal;
	protected String ville;
	protected String tel;
	protected String fax;
	protected String email;
	protected String web;
	
	protected double capital;
	protected String typeSociete;
	protected String tvaIntra;
	protected String rcs;
	protected String siren;
	
	// coordonnes du destinataire
	
	protected String clientId;
	protected String raisonSocialeDest;
	protected String adresseDest;
	protected String compAdresseDest;
	protected String adresseDest3;
	protected String codePostalDest;
	protected String villeDest;
	protected String paysDest;
	
	
	private String codePays;
	
	// coordonnes de livraison
	
	protected String denominationLiv;
	protected String adresse1Liv;
	protected String adresse2Liv;
	protected String adresse3Liv;
	protected String codePostalLiv;
	protected String villeLiv;
	protected String paysLiv;


	protected String codePaysLiv;
	protected String numTvaClient = "";
	
	// infos facture
	
	protected String numeroAvoir;
	protected String interlocuteur = "";
	protected String interlocuteurLiv = "";
	protected boolean zoneUE=false;
	protected String comFin = "";
	protected String mentions = "";
	protected String codeFournisseur;
	protected String urlLogo = "";
	protected String urlApercu = "";
	
	protected long dateAvoir;
	
	protected double tRemise = 0;
	protected double tEscompte = 0;
	protected double mRemise = 0;
	protected double mEscompte = 0;
	protected double fraisPort = 0;
	protected double montantBase = 0;
	protected double totalBase = 0;
	protected double totalTVA = 0;
	protected double montantTTC = 0;
	protected double netAPayer = 0;
	protected double tauxTvaPort = 0;

	protected double montantBaseInd;
	protected double mRemiseInd;
	protected double fraisPortInd = 0;
	protected double totalBaseInd = 0;
	protected double totalTVAInd = 0;
	protected double montantTTCInd = 0;
	protected double netAPayerInd = 0;
	protected double mEscompteInd = 0;
	protected double acompteInd = 0;
	
	protected double tauxInd = 0;

	
	protected boolean logoAdr;	
	protected boolean sansarticles = false;
	protected boolean coul = false;
	protected boolean tail = false;
	protected boolean unite = false;
	protected boolean nbPieces = false;
	protected boolean numLot = false;
	protected boolean datePeremption = false;
	protected boolean editionTTC = false;
	protected boolean rist = false;
	
	protected boolean assujetti;
	protected boolean TVALiv;
	protected String typePays;
	
	protected boolean imprimerAdrLiv;
	protected int nbex;
	protected boolean apercu;
	
	protected String regimeTVA = "G";
	protected boolean exonerationTVA = false;
	
	protected ArrayList<VentilTVA> vtvas = new ArrayList<VentilTVA>(2);
	
	private Arrondi r = new Arrondi(2);

	
	
	/**
	 * Constructeur appel par dfaut
	 */
	public DataAvoir(Session s, String avoirId) {
		this(s, avoirId, false, 0);
	}
	
	
	public DataAvoir(Session s, String avoirId, boolean apercu, long dateAvoir) {	
		try {
		
			Connection con = s.getConnection(null);
			Statement stt = con.createStatement();
			
			String dossierId = s.getCookie().get("Dossier_Id");
			String base = s.getCookie().get("BaseDossier");
			
			this.urlLogo = s.getAppConfiguration().get("opensi.absdir") +"/logos/"+ dossierId +".jpg";
			this.urlApercu = s.getAppConfiguration().get("opensi.absdir") +"/images/apercu.jpg";
			this.apercu = apercu;
      
			ResultSet rset;
			
			dfs2.setDecimalSeparator('.');
			numFormatQte.setDecimalFormatSymbols(dfs2);
			
      
			// coordonnes de l'entreprise facturante
      
			String reqFacturante = "select Ville_RCS, Num_TVA_Intra, Type_Societe, Montant_Capital, Num_SIRET, Raison_Sociale, Adresse, Comp_Adresse, Code_Postal, Ville, Telephone, Fax, Email, Site_Web from DOSSIER where Dossier_Id='"+ dossierId +"'";
			
			rset = stt.executeQuery(reqFacturante);
			
			rset.next();
			
			this.raisonSociale = rset.getString("Raison_Sociale");
			this.adresse = rset.getString("Adresse");
			this.compAdresse = rset.getString("Comp_Adresse");
			this.adresse3 = "";
			this.codePostal = rset.getString("Code_Postal");
			this.ville = rset.getString("Ville");
			this.tel = rset.getString("Telephone");
			this.fax = rset.getString("Fax");
			this.email = rset.getString("Email");
			this.web = rset.getString("Site_Web");
			
			this.siren = formatSiren(rset.getString("Num_SIRET"));
			this.typeSociete = rset.getString("Type_Societe");
			this.capital = rset.getDouble("Montant_Capital");
			this.tvaIntra = rset.getString("Num_TVA_Intra");
			this.rcs = rset.getString("Ville_RCS");		
			
			rset.close();
			
			
			// Elments de l'avoir
			
			String reqAvoir = "select a.*, c1.Civ_Courte as Civ_Courte_Fact, c2.Civ_Courte as Civ_Courte_Liv, p1.Nom_FR as Pays, p2.Nom_FR as Pays_Liv, p2.Zone_UE, p2.Type_Pays from "+ base +".AVOIR a, CIVILITE c1, CIVILITE c2, PAYS p1, PAYS p2";
			reqAvoir += " where c1.Civ_Id=a.Civ_Inter and c2.Civ_Id=a.Civ_Inter_Liv and a.Code_Pays=p1.Code_Pays and a.Code_Pays_Liv=p2.Code_Pays and a.Avoir_Id="+ avoirId;
			
			rset = stt.executeQuery(reqAvoir);
			
			rset.next();
			
			this.numeroAvoir = rset.getString("Num_Entier");
			this.dateAvoir = this.apercu ? dateAvoir : rset.getLong("Date_Avoir");
			this.tEscompte = rset.getDouble("Escompte");
			this.tRemise = rset.getDouble("Remise");
			this.fraisPort = rset.getDouble("Frais_Port");
			this.tauxTvaPort = rset.getDouble("Taux_TVA_Port");
			
			this.raisonSocialeDest = rset.getString("Raison_Sociale");
			this.adresseDest = rset.getString("Adresse_Fact");
			this.compAdresseDest = rset.getString("Comp_Adresse_Fact");
			this.adresseDest3 = rset.getString("Adresse_3_Fact");
			this.codePostalDest = rset.getString("CP_Fact");
			this.villeDest = rset.getString("Ville_Fact");
			this.paysDest = rset.getString("Pays");
			this.codePays = rset.getString("Code_Pays");
			this.denominationLiv = rset.getString("Denomination_Liv");
			this.adresse1Liv = rset.getString("Adresse_1_Liv");
			this.adresse2Liv = rset.getString("Adresse_2_Liv");
			this.adresse3Liv = rset.getString("Adresse_3_Liv");
			this.codePostalLiv = rset.getString("Code_Postal_Liv");
			this.villeLiv = rset.getString("Ville_Liv");
			this.paysLiv = rset.getString("Pays_Liv");
			this.codePaysLiv = rset.getString("Code_Pays_Liv");
			this.clientId = rset.getString("Client_Id");
			this.numTvaClient = rset.getString("Num_TVA_Intra");
			this.zoneUE = (rset.getInt("Zone_UE")==1);
			this.assujetti = rset.getInt("Assujetti_TVA")==1;
			this.TVALiv = rset.getInt("TVA_Liv")==1;
			this.typePays = rset.getString("Type_Pays");
			this.editionTTC = rset.getInt("Edition_TTC")==1;
			this.regimeTVA = rset.getString("Regime_TVA");

			this.tauxInd=rset.getDouble("Taux_Indicatif");
						
			if (rset.getString("Nom_Inter").equals("")) {
				this.interlocuteur = "";
			}
			else {
				this.interlocuteur = rset.getString("Civ_Courte_Fact") +" "+ rset.getString("Nom_Inter").toUpperCase() + " " + rset.getString("Prenom_Inter");
			}
			
			if (rset.getString("Nom_Inter_Liv").equals("")) {
				this.interlocuteurLiv = "";
			}
			else {
				this.interlocuteurLiv = rset.getString("Civ_Courte_Liv") +" "+ rset.getString("Nom_Inter_Liv").toUpperCase() + " " + rset.getString("Prenom_Inter_Liv");
			}
			
			
			if (rset.getInt("Imp_Com")==1 && rset.getString("Commentaires").length()>0) {
				this.comFin = "\n"+ rset.getString("Commentaires");
			}
			this.mentions = "\n\n"+ rset.getString("Mentions");
			
			rset.close();
			
			this.exonerationTVA = this.regimeTVA.equals("E") || (this.regimeTVA.equals("G") && !this.zoneUE);

			// Paramtres dossier
      
			String reqCom = "select Com_Fact, Logo_Adr, Imprimer_Adr_Liv from PARAM_DOSSIER where Dossier_Id='"+ dossierId +"'";
			
			rset = stt.executeQuery(reqCom);
			
			rset.next();
			
			logoAdr = rset.getInt("Logo_Adr")==1;
			
			if (rset.getString("Com_Fact").length()>0) {
				this.comFin += "\n\n"+rset.getString("Com_Fact");
			}
			
			this.imprimerAdrLiv = (rset.getInt("Imprimer_Adr_Liv")==1 || !this.codePaysLiv.equals("FR"));
			
			rset.close();
			
			// modification des coordonnes de l'entreprise facturante si code_pays reli a un site_id dans PARAM_PAYS_WEB
      
			String reqParamPaysWeb = "select * from "+ base +".SITE s,"+ base +".PARAM_PAYS_WEB ppw where ppw.Site_Id=s.Site_Id and ppw.Code_Pays='"+ this.codePays +"'";
			
			rset = stt.executeQuery(reqParamPaysWeb);
			
			if (rset.next()) {
			
				this.raisonSociale = rset.getString("Denomination");
				this.adresse = rset.getString("Adresse_1");
				this.compAdresse = rset.getString("Adresse_2");
				this.adresse3 = rset.getString("Adresse_3");
				this.codePostal = rset.getString("Code_Postal");
				this.ville = rset.getString("Ville");
				this.tel = rset.getString("Tel");
				this.fax = rset.getString("Fax");
				this.email = rset.getString("Email");
			
			}
			rset.close();


			// ventilation des TVA		
				
			String reqVTvas = "select a.Taux_TVA, sum(a.Prix * a.Quantite * (1-a.Ristourne/100)) as Base_Montant "
				 + "from "+ base +".ARTICLE_AVOIR a, "+ base +".TAUX_TVA t where Avoir_Id="+ avoirId +" and a.Code_TVA=t.Code_TVA group by a.Taux_TVA order by a.Taux_TVA";

			rset = stt.executeQuery(reqVTvas);
			
			while (rset.next()) {
			
				double tauxTva = rset.getDouble("Taux_TVA");
				
				if (editionTTC) {									
					double montantTVA = (rset.getDouble("Base_Montant") * (1-tRemise/100) * (tauxTva/100) / (tauxTva/100+1));					
					totalTVA += montantTVA;					
					vtvas.add(new VentilTVA(rset.getDouble("Base_Montant") * (1-tRemise/100) - montantTVA, tauxTva));
				}
				else {
					vtvas.add(new VentilTVA(rset.getDouble("Base_Montant") * (1-tRemise/100), tauxTva));				
					totalTVA += ((tauxTva/100) * rset.getDouble("Base_Montant") * (1-tRemise/100));
				}
			}
			
			rset.close();
			
			
			// TVA NPR
			
			String reqTvaNpr = "select t.Taux_NPR, sum(a.Prix * a.Quantite * (1-a.Ristourne/100)) as Base_Montant "
				+ "from "+ base +".ARTICLE_AVOIR a, "+ base +".TAUX_TVA t where Avoir_Id="+ avoirId +" and t.Code_TVA=a.Code_TVA and t.Taux_NPR>0 group by t.Code_TVA order by t.Taux_NPR";
			
			rset = stt.executeQuery(reqTvaNpr);
			
			while (rset.next()) {
				VentilTVA vtva = new VentilTVA(rset.getDouble("Base_Montant") * (1-tRemise/100), rset.getDouble("Taux_NPR"));
				vtva.setNPR(true);
				vtvas.add(vtva);				
			}
						
			
			
			// nombre d'exemplaires  sortir et donnes fiche client
       
			if (clientId.equals("")) {
				this.comFin += "\n\n";
				this.nbex = 1;
				this.codeFournisseur = "";
			}
			else {

				String reqEx = "select Nb_Ex, Com_Fact, Code_Fournisseur from "+ base +".FICHE_CLIENT where Client_Id='"+ clientId +"'";
				rset = stt.executeQuery(reqEx);
			
				if (rset.next()) {
					if (rset.getString("Com_Fact").length()>0) {
						this.comFin += "\n\n"+rset.getString("Com_Fact");
					}
					this.nbex = rset.getInt("Nb_Ex") + 1;
					this.codeFournisseur = rset.getString("Code_Fournisseur");
				}
				else {
					this.comFin += "\n\n";
					this.nbex = 1;
					this.codeFournisseur = "";
				}			
				rset.close();
			}
			
			     
      
			// selection des articles appartenant  la facture
			
			String reqArticles = "select * from "+ base +".ARTICLE_AVOIR where Avoir_Id="+ avoirId;
			rset = stt.executeQuery(reqArticles);
			
			
			String reqInfosSup = "select Couleur, Taille, Descrip_1, Descrip_2, Imp_Nom_Facture, Imp_Desc1_Facture, Imp_Desc2_Facture "
												 + "from "+ base +".FICHE_ARTICLE where Article_Id=?";
			
			PreparedStatement psInfosSup = con.prepareStatement(reqInfosSup);
			
			
			String reqNomenclature = "select n.ArticleComp_Id, n.Quantite, f.Designation "
														 + "from "+ base +".FICHE_ARTICLE f,"+ base +".COMPOSANT_ARTICLE n where f.Article_Id=n.ArticleComp_Id and n.Article_Id=?";
			
			PreparedStatement psNomenclature = con.prepareStatement(reqNomenclature);
					
			
			while (rset.next()) {
				
				String commentaireAvant = rset.getString("Commentaire_Avant");				
				
				if (commentaireAvant.length()>0) {
				
					String tabCom[] = commentaireAvant.split("\n");
					
					for (int i=0; i<tabCom.length; i++) {
					
						LigneAvoir la = new LigneAvoir();
						la.setType('C');
						la.setDesignation(tabCom[i]);
						la.setSousTotal(montantBase);
						lignes.add(la);
					}
				}
				
				LigneAvoir la = new LigneAvoir();
        
				String libelle = rset.getString("Libelle");
				
				if (libelle.length()>0) {
					libelle = "\n"+ libelle;
				}			
				
				la.setReference(rset.getString("Reference"));
				la.setDesignation(rset.getString("Designation") + libelle);
				la.setQuantite(rset.getDouble("Quantite"));
				la.setPrixUnitaire(rset.getDouble("Prix"));
				la.setRistourne(rset.getDouble("Ristourne"));
				la.setUnite(rset.getString("Unite"));
				la.setNumLot(rset.getString("Num_Lot"));
				la.setNbPieces(rset.getInt("Nb_Pieces"));
				la.setDatePeremption(rset.getLong("Date_Peremption"));
				la.setType('A');
				la.setPrixIndicatif(rset.getDouble("Prix")*tauxInd);

				if (la.ristourne!=0) rist = true;
				if (!la.unite.equals("U")) unite = true;
				if (!la.num_lot.equals("")) numLot = true;
				if (la.nb_pieces != 0) nbPieces = true;
				if (la.date_peremption != 0) datePeremption = true;

				la.setMontant(la.prixUnitaire * la.quantite * (1-la.ristourne/100));
				
				montantBase += la.montant;
				
				la.setSousTotal(montantBase);
				
				lignes.add(la);
				
				String commentaireApres = rset.getString("Commentaire");				
				
				if (commentaireApres.length()>0) {
				
					String tabCom[] = commentaireApres.split("\n");
					
					for (int i=0; i<tabCom.length; i++) {
					
						LigneAvoir lc = new LigneAvoir();
						lc.setType('C');
						lc.setDesignation(tabCom[i]);
						lc.setSousTotal(montantBase);
						lignes.add(lc);
					}
				}
				
				
				if (rset.getString("Type_Ligne").equalsIgnoreCase("S")) {					
				
					// rcupration infos supplmentaires si existent
					psInfosSup.setString(1, la.reference);
					ResultSet rsIS = psInfosSup.executeQuery();

					if (rsIS.next()) {

						la.setCouleur(rsIS.getString("Couleur"));
						la.setTaille(rsIS.getString("Taille"));

						if (rsIS.getString("Couleur").length()>0) {
							coul = true;
						}

						if (rsIS.getString("Taille").length()>0) {
							tail = true;
						}
						
						if (rsIS.getInt("Imp_Desc1_Facture")==1) {
							la.setDetail_1(StringUtils.removeHtmlTags(rsIS.getString("Descrip_1")));
						}
						if (rsIS.getInt("Imp_Desc2_Facture")==1) {
							la.setDetail_2(StringUtils.removeHtmlTags(rsIS.getString("Descrip_2")));
						}

						// gestion de la nomenclature
						if (rsIS.getInt("Imp_Nom_Facture")==1)	{

							psNomenclature.setString(1, la.reference);
							ResultSet rsN = psNomenclature.executeQuery();

							while (rsN.next()) {
								LigneAvoir ln = new LigneAvoir();

								ln.setReference(rsN.getString("ArticleComp_Id"));
								ln.setDesignation(rsN.getString("Designation"));
								ln.setQuantite(rsN.getDouble("Quantite"));
								ln.setType('N');
								ln.setSousTotal(montantBase);			

								lignes.add(ln);
							}

							rsN.close();
						}
						
					}
					rsIS.close();								
				}				
			}
			if (getNbLignes()==0 && fraisPort>0) {
				sansarticles = true;
				LigneAvoir lf = new LigneAvoir();
		        					
				lf.setReference("");
				lf.setDesignation("Frais De Livraison");
				lf.setQuantite(1);
				lf.setPrixUnitaire(fraisPort);
				lf.setRistourne(0);
				lf.setType('A');
				if (lf.ristourne!=0) rist = true;
				if (!lf.unite.equals("U")) unite = true;
				if (!lf.num_lot.equals("")) numLot = true;
				if (lf.nb_pieces != 0) nbPieces = true;
				if (lf.date_peremption != 0) datePeremption = true;
				
				lf.setMontant(lf.prixUnitaire * lf.quantite * (1-lf.ristourne/100));
				
				montantBase += lf.montant;
				
				lf.setSousTotal(montantBase);
				lignes.add(lf);
				
			}
			
			double frais = ((sansarticles)?0:fraisPort);
			mRemise = montantBase * tRemise/100;
			totalBase = montantBase + frais - mRemise;
		
			if (editionTTC) {
				totalTVA = totalTVA + frais * (tauxTvaPort/100) / (tauxTvaPort/100+1);
			}
			else {
				totalTVA = totalTVA + frais * tauxTvaPort/100;
			}
			
			montantTTC = (editionTTC?totalBase:totalBase + totalTVA);
			mEscompte = r.round(montantTTC * tEscompte/100);
			netAPayer = montantTTC - mEscompte;
			
			montantBaseInd=montantBase*tauxInd;
			mRemiseInd=mRemise*tauxInd;
			fraisPortInd=fraisPort*tauxInd;
			totalBaseInd=totalBase*tauxInd;
			totalTVAInd=totalTVA*tauxInd;
			montantTTCInd=montantTTC*tauxInd;
			netAPayerInd=netAPayer*tauxInd;
			mEscompteInd=mEscompte*tauxInd;

			rset.close();
			stt.close();			
			s.closeConnection(con, null);
			
		} catch(Exception e) {
			e.printStackTrace();
		}	
	}
	
	
	
	public double calcSousTotal(int derniereLigne) {
	
		if (derniereLigne<0) 
			return 0;
		return lignes.get(derniereLigne).sousTotal;		
	}	
	
	
	public int getNbLignes() {
		return lignes.size();
	}
	
	
	public int getNbEx() {	
		return nbex;
	}
	
	
	public String formatSiren(String siret) {
		if (siret.length()>=9) {
			return siret.substring(0,3) +" "+ siret.substring(3,6) +" "+ siret.substring(6,9);
		}
		return siret;
	}
	
	
} // fin DataAvoir
