/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 * Donnes ncessaires  l'dition d'une commande client standard
 */

package org.opensi.facturation.actions.documents.modeles;


import java.sql.*;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.util.ArrayList;

import org.experlog.openeas.api.Session;
import org.opensi.util.tools.Arrondi;
import org.opensi.util.tools.StringUtils;


public class DataCommandeClient {


	private DecimalFormatSymbols dfs2 = new DecimalFormatSymbols();
	
	private DecimalFormat numFormatQte = new DecimalFormat("0.##");



	// les lignes de la facture
	protected ArrayList<LigneCommandeClient> lignes = new ArrayList<LigneCommandeClient>(10);
	


	// coordonnes socit mettrice

	protected String raisonSociale;
	protected String adresse;
	protected String compAdresse;
	protected String codePostal;
	protected String ville;
	protected String tel;
	protected String fax;
	protected String email;
	protected String web;
	
	protected double capital;
	protected String typeSociete;
	protected String tvaIntra;
	protected String rcs;
	protected String siren;
	
	// coordonnes du destinataire
	
	protected String clientId;
	protected String raisonSocialeDest;
	protected String adresseDest;
	protected String compAdresseDest;
	protected String adresseDest3;
	protected String codePostalDest;
	protected String villeDest;
	protected String paysDest;
	
	// coordonnes de livraison
	
	protected String nomLiv;
	protected String adresseLiv;
	protected String compAdresseLiv;
	protected String adresseLiv3;
	protected String cpLiv;
	protected String villeLiv;
	protected String paysLiv;
	
	
	// infos facture
	
	protected String refCommande;
	protected String responsable = "";
	protected String interlocuteur = "";
	protected String interTel = "";
	protected String interFax = "";
	protected String interMail = "";
	protected String interlocuteurLiv = "";
	protected String interTelLiv = "";
	protected String interFaxLiv = "";
	protected String interMailLiv = "";
	protected String comFin = "";
	protected String mentions = "";
	protected String refAffaire;
	protected boolean zoneUE=false;
	
	protected long dateCommande;
	protected long delai;
	
	protected double tRemise = 0;
	protected double tEscompte = 0;
	protected double mRemise = 0;
	protected double mEscompte = 0;
	protected double acompte = 0;
	protected double fraisPort = 0;
	protected double montantBase = 0;
	protected double totalBase = 0;
	protected double totalTVA = 0;
	protected double montantTTC = 0;
	protected double netAPayer = 0;
	protected double tauxTvaPort = 0;
	
	protected boolean editionTTC = false;
	protected boolean rist = false;
	protected boolean coul = false;
	protected boolean tail = false;
	protected boolean unite = false;
	protected boolean nbPieces = false;
	protected boolean numLot = false;
	protected boolean datePeremption = false;
	protected boolean codeStats = false;
	protected boolean logoAdr;
	protected String urlLogo = "";
	protected boolean comWeb;
	
	protected int nbex;
	
	protected  boolean of = false;
	
	protected String regimeTVA = "G";
	protected boolean exonerationTVA = false;
		

	protected ArrayList<VentilTVA> vtvas = new ArrayList<VentilTVA>(2);
	
	private Arrondi r = new Arrondi(2);
	
	
	
	public DataCommandeClient(Session s, String comId, boolean comWeb, boolean of) {	
		try {
		
			Connection con = s.getConnection(null);
			Statement stt = con.createStatement();
			Statement stt2 = con.createStatement();
			Statement stt3 = con.createStatement();
			
			String dossierId = s.getCookie().get("Dossier_Id");
			String base = s.getCookie().get("BaseDossier");
			
			this.urlLogo = s.getAppConfiguration().get("opensi.absdir") +"/logos/"+ dossierId +".jpg";
      
			this.of = of;
			this.comWeb = comWeb;
			
			ResultSet rset;
			
			dfs2.setDecimalSeparator('.');
			numFormatQte.setDecimalFormatSymbols(dfs2);
			
      
			// coordonnes de l'entreprise facturante
      
      String reqFacturante = "select Ville_RCS, Num_TVA_Intra, Type_Societe, Montant_Capital, Num_SIRET, Raison_Sociale, Adresse, Comp_Adresse, Code_Postal, Ville, Telephone, Fax, Email, Site_Web from DOSSIER where Dossier_Id='"+ dossierId +"'";
			
			rset = stt.executeQuery(reqFacturante);
			
			rset.next();
			
			this.raisonSociale = rset.getString("Raison_Sociale");
			this.adresse = rset.getString("Adresse");
			this.compAdresse = rset.getString("Comp_Adresse");
			this.codePostal = rset.getString("Code_Postal");
			this.ville = rset.getString("Ville");
			this.tel = rset.getString("Telephone");
			this.fax = rset.getString("Fax");
			this.email = rset.getString("Email");
			this.web = rset.getString("Site_Web");
			
			this.siren = formatSiren(rset.getString("Num_SIRET"));
			this.typeSociete = rset.getString("Type_Societe");
			this.capital = rset.getDouble("Montant_Capital");
			this.tvaIntra = rset.getString("Num_TVA_Intra");
			this.rcs = rset.getString("Ville_RCS");		
			
			rset.close();
			
			
			// Elments de la commande			
			
			String reqCom;
			
			if (comWeb) {
				reqCom = "select Date_Commande as Date_Com, Com_Site_Id as Ref_Com, Escompte, Remise, Frais_Port, Acompte, Nom_Site, 0 as Delai ";
				reqCom += "from "+ base +".COMMANDE_WEB c left join "+ base +".SITE_WEB s on s.Site_Id=c.Site_Id where Com_Web_Id="+ comId;				
			}
			else {
				reqCom = "select Date_Com, Ref_Com, Escompte, Remise, Frais_Port, Delai, Acompte from "+ base +".COM_CLIENT where Com_Id="+ comId;
			}
			
			rset = stt.executeQuery(reqCom);
			rset.next();
			this.refCommande = rset.getString("Ref_Com");
			this.dateCommande = rset.getLong("Date_Com");
			this.tEscompte = rset.getDouble("Escompte");
			this.tRemise = rset.getDouble("Remise");
			this.acompte = rset.getDouble("Acompte");
			this.fraisPort = rset.getDouble("Frais_Port");
			this.delai = rset.getLong("Delai");
			rset.close();
			
			// affaire
			
			String reqAffaire;
			

			if (comWeb) {
				reqAffaire = "select c.Taux_TVA_Port,c.Client_Web_Id as Client_Id,c.Societe_Client as Raison_Sociale,c.Civ_Inter as Civ, c.Nom_Inter as Nom,c.Prenom_Inter as Prenom,";
				reqAffaire += " c.Adresse_Client_1 as Adresse_Fact,c.Adresse_Client_2 as Comp_Adresse_Fact,c.Adresse_Client_3 as Adresse_3_Fact,c.CP_Client as CP_Fact,";
				reqAffaire += " c.Ville_Client as Ville_Fact, p1.Nom_FR as Pays_Factu,";
				reqAffaire += " c.Societe_Liv, c.Civ_Inter_Liv, c.Nom_Inter_Liv, c.Prenom_Inter_Liv, c.Adresse_Liv_1 as Adresse_Liv,c.Adresse_Liv_2 as Comp_Adresse_Liv,c.Adresse_Liv_3 as Adresse_3_Liv,";
				reqAffaire += " c.CP_Liv, c.Ville_Liv, p2.Nom_FR as Pays_Livr, c.Commentaire as Com_Com, c.Mentions, c.Edition_TTC, c.Com_Site_Id as Num_Entier,'' as Util_R,1 as Imp_Com_Com, p2.Zone_UE, c.Regime_TVA";
				reqAffaire += " from "+ base +".COMMANDE_WEB c, PAYS p1, PAYS p2";
				reqAffaire += " where c.Code_Pays=p1.Code_Pays and c.Code_Pays_Liv=p2.Code_Pays and c.Com_Web_Id="+ comId;
			}
			else {
				reqAffaire = "select c.Taux_TVA_Port, p1.Zone_UE, p1.Nom_FR as Pays_Livr, p2.Nom_FR as Pays_Factu, a.*, c.Imp_Com as Imp_Com_Com, c.Commentaires as Com_Com, c.Mentions, c.Edition_TTC, c.Regime_TVA ";
				reqAffaire += "from "+ base +".AFFAIRE a, PAYS p1, PAYS p2, "+ base +".COM_CLIENT c where a.Affaire_Id=c.Affaire_Id and a.Code_Pays_Liv=p1.Code_Pays and a.Code_Pays=p2.Code_Pays and c.Com_Id="+ comId;
			}
			
			rset = stt.executeQuery(reqAffaire);
			rset.next();

			// coordonnes de l'entreprise facture

			if (comWeb) {
				this.raisonSocialeDest = rset.getString("Raison_Sociale");
				this.nomLiv = rset.getString("Societe_Liv");
				this.refAffaire = "";
			}
			else {
				this.raisonSocialeDest = rset.getString("Raison_Sociale");
				this.nomLiv = rset.getString("Nom_Liv");
				this.refAffaire = rset.getString("Num_Entier");
			}
			this.zoneUE = (rset.getInt("Zone_UE")==1);
			this.regimeTVA = rset.getString("Regime_TVA");
			
			this.adresseDest = rset.getString("Adresse_Fact");
			this.compAdresseDest = rset.getString("Comp_Adresse_Fact");
			this.adresseDest3 = rset.getString("Adresse_3_Fact");
			this.codePostalDest = rset.getString("CP_Fact");
			this.villeDest = rset.getString("Ville_Fact");
			this.paysDest = rset.getString("Pays_Factu");			

			this.adresseLiv = rset.getString("Adresse_Liv");
			this.compAdresseLiv = rset.getString("Comp_Adresse_Liv");
			this.adresseLiv3 = rset.getString("Adresse_3_Liv");
			this.cpLiv = rset.getString("CP_Liv");
			this.villeLiv = rset.getString("Ville_Liv");
			this.paysLiv = rset.getString("Pays_Livr");

			this.tauxTvaPort = rset.getDouble("Taux_TVA_Port");
			this.editionTTC = rset.getInt("Edition_TTC")==1;
			this.clientId = rset.getString("Client_Id");

			String utilR = rset.getString("Util_R");

			if (rset.getInt("Imp_Com_Com")==1 && rset.getString("Com_Com").length()>0) {
				this.comFin = "\n"+ rset.getString("Com_Com");
			}
			this.mentions = "\n\n"+ rset.getString("Mentions");

			rset.close();
			
			this.exonerationTVA = this.regimeTVA.equals("E") || (this.regimeTVA.equals("G") && !this.zoneUE);
			
			
			String reqInter="";
			// interlocuteur
			if (comWeb) {
				reqInter = "select c1.Civ_Courte as Civ_Inter,Nom_Inter, Prenom_Inter, Tel_Inter, Fax_Inter, Email_Inter," +
						" c2.Civ_Courte as Civ_Inter_Liv,Nom_Inter_Liv, Prenom_Inter_Liv, Tel_Inter_Liv, Fax_Inter_Liv, Email_Inter_Liv" +
						" from "+ base +".COMMANDE_WEB com, CIVILITE c1 , CIVILITE c2" +
						" where c1.Civ_Id=Civ_Inter and c2.Civ_Id=Civ_Inter_liv and Com_Web_Id="+ comId;
			}
			else {
				reqInter = "select c1.Civ_Courte as Civ_Inter,Nom_Inter, Prenom_Inter, Tel_Inter, Fax_Inter, Email_Inter," +
				" c2.Civ_Courte as Civ_Inter_Liv,Nom_Inter_Liv, Prenom_Inter_Liv, Tel_Inter_Liv, Fax_Inter_Liv, Email_Inter_Liv" +
				" from "+ base +".AFFAIRE a, "+ base +".COM_CLIENT c, CIVILITE c1 , CIVILITE c2" +
				" where a.Affaire_Id=c.Affaire_Id and c1.Civ_Id=Civ_Inter and c2.Civ_Id=Civ_Inter_liv and c.Com_Id="+ comId;
			}
			rset = stt.executeQuery(reqInter);

			if (rset.next()) {

				this.interlocuteur = (rset.getString("Civ_Inter") +" "+ rset.getString("Nom_Inter").toUpperCase() +" "+ rset.getString("Prenom_Inter")).trim();
				this.interFax = rset.getString("Fax_Inter");
				this.interTel = rset.getString("Tel_Inter");
				this.interMail = rset.getString("Email_Inter");

				this.interlocuteurLiv = (rset.getString("Civ_Inter_Liv") +" "+ rset.getString("Nom_Inter_Liv").toUpperCase() +" "+ rset.getString("Prenom_Inter_Liv")).trim();
				this.interFaxLiv = rset.getString("Fax_Inter_Liv");
				this.interTelLiv = rset.getString("Tel_Inter_Liv");
				this.interMailLiv = rset.getString("Email_Inter_Liv");
			}
			
			rset.close();
			
			
			
			// Paramtres dossier

      String reqLogo = "select Logo_Adr from PARAM_DOSSIER where Dossier_Id='"+ dossierId +"'";

			rset = stt.executeQuery(reqLogo);

			rset.next();

			logoAdr = rset.getInt("Logo_Adr")==1;

			rset.close();
			
			
			// responsable entreprise
			
			if (!utilR.equals("")) {

				String reqResp = "select Civ_Courte, Nom, Prenom from UTILISATEUR, CIVILITE where Civ_Id=Civilite and Utilisateur_Id="+ Integer.parseInt(utilR);
	
				rset = stt.executeQuery(reqResp);
	
				if (rset.next()) {
					this.responsable = rset.getString("Civ_Courte") +" "+ rset.getString("Nom").toUpperCase() +" "+ rset.getString("Prenom");
				}
				
				rset.close();
			}
			
					
			
			// ventilation des TVA		
				
			String reqVTvas = "select a.Taux_TVA, sum(a.Prix * a.Quantite * (1-a.Ristourne/100)) as Base_Montant ";
			
			if (comWeb)
				reqVTvas += "from "+ base +".ARTICLE_COMMANDE_WEB a, "+ base +".TAUX_TVA t where Com_Web_Id="+ comId;
			else
				reqVTvas += "from "+ base +".ARTICLE_COM_CLIENT a, "+ base +".TAUX_TVA t where Com_Id="+ comId;
										 
			reqVTvas += " and a.Code_TVA=t.Code_TVA group by a.Taux_TVA order by a.Taux_TVA";
			
			rset = stt.executeQuery(reqVTvas);
			
			while (rset.next()) {
			
				double tauxTva = rset.getDouble("Taux_TVA");
			
				if (editionTTC) {									
					double montantTVA = (rset.getDouble("Base_Montant") * (1-tRemise/100) * (tauxTva/100) / (tauxTva/100+1));					
					totalTVA += montantTVA;					
					vtvas.add(new VentilTVA(rset.getDouble("Base_Montant") * (1-tRemise/100) - montantTVA, tauxTva));
				}
				else {
					vtvas.add(new VentilTVA(rset.getDouble("Base_Montant") * (1-tRemise/100), tauxTva));				
					totalTVA += ((tauxTva/100) * rset.getDouble("Base_Montant") * (1-tRemise/100));
				}
			}
			
			rset.close();
			
			
			// TVA NPR
			
			String reqTvaNpr = "select t.Taux_NPR, sum(a.Prix * a.Quantite * (1-a.Ristourne/100)) as Base_Montant ";
			
			if (comWeb)
				reqTvaNpr += "from "+ base +".ARTICLE_COMMANDE_WEB a, "+ base +".TAUX_TVA t where Com_Web_Id="+ comId;
			else
				reqTvaNpr += "from "+ base +".ARTICLE_COM_CLIENT a, "+ base +".TAUX_TVA t where Com_Id="+ comId;											
											
			reqTvaNpr += " and t.Code_TVA=a.Code_TVA and t.Taux_NPR>0 group by t.Code_TVA order by t.Taux_NPR";
			
			rset = stt.executeQuery(reqTvaNpr);
			
			while (rset.next()) {
				VentilTVA vtva = new VentilTVA(rset.getDouble("Base_Montant") * (1-tRemise/100), rset.getDouble("Taux_NPR"));
				vtva.setNPR(true);
				vtvas.add(vtva);				
			}
			
      
      
			// selection des articles appartenant  la facture
			
			
			String reqArticles;
			
			if (comWeb) {
				reqArticles = "select Article_Id as Reference,Prix,Designation,Quantite,Ristourne,Type_Ligne,Code_TVA,Commentaire,Commentaire_avant,Libelle,Unite,Nb_Pieces,'' as Num_Lot,0 as Date_Peremption,Code_Stats from "+ base +".ARTICLE_COMMANDE_WEB where Com_Web_Id="+ comId;
			}
			else {
				reqArticles = "select * from "+ base +".ARTICLE_COM_CLIENT where Com_Id="+ comId;
			}		
			
			rset = stt.executeQuery(reqArticles);
			
			
			String doc = of?"OF":"Devis";
			
			String reqInfosSup = "select Couleur, Taille, Descrip_1, Descrip_2, Imp_Nom_"+ doc +" as Imp_Nom, Imp_Desc1_"+ doc +" as Imp_Desc1, Imp_Desc2_"+ doc +" as Imp_Desc2 "
												 + "from "+ base +".FICHE_ARTICLE where Article_Id=?";
			
			PreparedStatement psInfosSup = con.prepareStatement(reqInfosSup);
			
			
			String reqNomenclature = "select n.ArticleComp_Id, n.Quantite, f.Designation "
														 + "from "+ base +".FICHE_ARTICLE f,"+ base +".COMPOSANT_ARTICLE n where f.Article_Id=n.ArticleComp_Id and n.Article_Id=?";
			
			PreparedStatement psNomenclature = con.prepareStatement(reqNomenclature);
					
			
			while (rset.next()) {
				
				String commentaireAvant = rset.getString("Commentaire_Avant");				
				
				if (commentaireAvant.length()>0) {
				
					String tabCom[] = commentaireAvant.split("\n");
					
					for (int i=0; i<tabCom.length; i++) {
					
						LigneCommandeClient lcc = new LigneCommandeClient();
						lcc.setType('C');
						lcc.setDesignation(tabCom[i]);
						lcc.setSousTotal(montantBase);
						lignes.add(lcc);
					}
				}
				
				LigneCommandeClient lc = new LigneCommandeClient();
        
				String libelle = rset.getString("Libelle");
				
				if (libelle.length()>0) {
					libelle = "\n"+ libelle;
				}			
				
				lc.setReference(rset.getString("Reference"));
				lc.setDesignation(rset.getString("Designation") + libelle);
				lc.setQuantite(rset.getDouble("Quantite"));
				lc.setPrixUnitaire(rset.getDouble("Prix"));
				lc.setRistourne(rset.getDouble("Ristourne"));
				lc.setUnite(rset.getString("Unite"));
				lc.setNumLot(rset.getString("Num_Lot"));
				lc.setNbPieces(rset.getInt("Nb_Pieces"));
				lc.setDatePeremption(rset.getLong("Date_Peremption"));
				lc.setCodeStats(rset.getString("Code_Stats"));
				
				lc.setType('A');				
				
				if (lc.ristourne!=0) rist = true;
				if (!lc.unite.equals("U")) unite = true;
				if (!lc.num_lot.equals("")) numLot = true;
				if (lc.nb_pieces != 0) nbPieces = true;
				if (lc.date_peremption != 0) datePeremption = true;
				if (!lc.code_stats.equals("")) codeStats = true;
				
				lc.setMontant(lc.prixUnitaire * lc.quantite * (1-lc.ristourne/100));
				
				montantBase += lc.montant;
				
				lc.setSousTotal(montantBase);
				
				lignes.add(lc);
				
				String commentaireApres = rset.getString("Commentaire");				
				
				if (commentaireApres.length()>0) {
				
					String tabCom[] = commentaireApres.split("\n");
					
					for (int i=0; i<tabCom.length; i++) {
					
						LigneCommandeClient ld = new LigneCommandeClient();
						ld.setType('C');
						ld.setDesignation(tabCom[i]);
						ld.setSousTotal(montantBase);
						lignes.add(ld);
					}
				}
				
				
				if (rset.getString("Type_Ligne").equalsIgnoreCase("S")) {					
				
					// rcupration infos supplmentaires si existent
					psInfosSup.setString(1, lc.reference);
					ResultSet rsIS = psInfosSup.executeQuery();

					if (rsIS.next()) {

						lc.setCouleur(rsIS.getString("Couleur"));
						lc.setTaille(rsIS.getString("Taille"));

						if (rsIS.getString("Couleur").length()>0) {
							coul = true;
						}

						if (rsIS.getString("Taille").length()>0) {
							tail = true;
						}
						
						if (rsIS.getInt("Imp_Desc1")==1) {
							lc.setDetail_1(StringUtils.removeHtmlTags(rsIS.getString("Descrip_1")));
						}
						if (rsIS.getInt("Imp_Desc2")==1) {
							lc.setDetail_2(StringUtils.removeHtmlTags(rsIS.getString("Descrip_2")));
						}

						// gestion de la nomenclature
						if (rsIS.getInt("Imp_Nom")==1)	{

							psNomenclature.setString(1, lc.reference);
							ResultSet rsN = psNomenclature.executeQuery();

							while (rsN.next()) {
								LigneCommandeClient ln = new LigneCommandeClient();

								ln.setReference(rsN.getString("ArticleComp_Id"));
								ln.setDesignation(rsN.getString("Designation"));
								ln.setQuantite(rsN.getDouble("Quantite"));
								ln.setType('N');
								ln.setSousTotal(montantBase);			

								lignes.add(ln);
							}

							rsN.close();
						}
						
					}
					rsIS.close();								
				}				
			}
			
			
			mRemise = montantBase * tRemise/100;
			totalBase = montantBase + fraisPort - mRemise;
			
			if (editionTTC) {
				totalTVA = totalTVA + fraisPort * (tauxTvaPort/100) / (tauxTvaPort/100+1);
			}
			else {
				totalTVA = totalTVA + fraisPort * tauxTvaPort/100;
			}
			
			montantTTC = (editionTTC?totalBase:totalBase + totalTVA);
			mEscompte = r.round(montantTTC * tEscompte/100);
			netAPayer = montantTTC - mEscompte - acompte;
			
			
			rset.close();
			stt.close();			
			s.closeConnection(con, null);
			
		} catch(Exception e) {
			e.printStackTrace();
		}	
	}
	
	
	
	public double calcSousTotal(int derniereLigne) {
	
		if (derniereLigne<0) 
			return 0;
		else {
			return lignes.get(derniereLigne).sousTotal;
		}		
	}	
	
	
	public int getNbLignes() {
		return lignes.size();
	}
	
	
	public int getNbEx() {	
		return nbex;
	}
	
	
	public String formatSiren(String siret) {
		if (siret.length()>=9) {
			return siret.substring(0,3) +" "+ siret.substring(3,6) +" "+ siret.substring(6,9);
		}
		else {
			return siret;
		}
	}
	
	
} // fin DataCommandeClient
