/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 * Donnes ncessaires  l'dition d'une commande fournisseur standard
 */

package org.opensi.facturation.actions.documents.modeles;


import java.sql.*;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.util.ArrayList;

import org.experlog.openeas.api.Session;
import org.opensi.util.tools.Arrondi;
import org.opensi.util.tools.StringUtils;


public class DataCommandeFournisseur {


	private DecimalFormatSymbols dfs2 = new DecimalFormatSymbols();
	
	private DecimalFormat numFormatQte = new DecimalFormat("0.##");


	// les lignes de la commande
	protected ArrayList<LigneCommandeFournisseur> lignes = new ArrayList<LigneCommandeFournisseur>(10);
	


	// coordonnes socit mettrice

	protected String raisonSociale;
	protected String adresse;
	protected String compAdresse;
	protected String codePostal;
	protected String ville;
	protected String tel;
	protected String fax;
	protected String email;
	protected String web;
	
	protected double capital;
	protected String typeSociete;
	protected String tvaIntra;
	protected String rcs;
	protected String siren;
	
	// coordonnes du destinataire
	
	protected String fournisseurId;
	protected String raisonSocialeDest;
	protected String adresseDest;
	protected String compAdresseDest;
	protected String adresseDest3;
	protected String codePostalDest;
	protected String villeDest;
	protected String paysDest;
	
	// coordonnes de livraison
	
	protected String raisonSocialeLiv;
	protected String adresseLiv;
	protected String compAdresseLiv;
	protected String adresseLiv3;
	protected String codePostalLiv;
	protected String villeLiv;
	protected String paysLiv;
	
	// infos commande
	
	protected String numeroCommande;
	protected String interlocuteur = "";
	protected String interTel = "";
	protected String interFax = "";
	protected String interMail = "";
	protected String responsable;
	protected String typeVente;
	protected String modeReglement;
	protected String comFin = "";
	protected String mentions = "";
	protected String codeClient;
	protected String typeAchat;
	
	protected long dateCommande;
	
	protected double tRemise = 0;
	protected double tEscompte = 0;
	protected double mRemise = 0;
	protected double mEscompte = 0;
	protected double acompte = 0;
	protected double fraisPort = 0;
	protected double montantBase = 0;
	protected double totalBase = 0;
	protected double totalTVA = 0;
	protected double montantTTC = 0;
	protected double netAPayer = 0;
	protected double tauxTvaPort = 0;
	
	protected boolean rist = false;
	protected boolean coul = false;
	protected boolean tail = false;
	protected boolean unite = false;
	protected boolean nbPieces = false;
	protected boolean logoAdr;
	protected String urlLogo = "";	

	protected ArrayList<VentilTVA> vtvas = new ArrayList<VentilTVA>(2);
	
	private Arrondi r = new Arrondi(2);
	
	
	
	public DataCommandeFournisseur(Session s, String commandeId) {	
		try {
		
			Connection con = s.getConnection(null);
			Statement stt = con.createStatement();
			
			String dossierId = s.getCookie().get("Dossier_Id");
			String base = s.getCookie().get("BaseDossier");
			
			this.urlLogo = s.getAppConfiguration().get("opensi.absdir") +"/logos/"+ dossierId +".jpg";
      
			ResultSet rset;
			
			dfs2.setDecimalSeparator('.');
			numFormatQte.setDecimalFormatSymbols(dfs2);
			
      
			// coordonnes de l'entreprise facturante
      
			String reqFacturante = "select Ville_RCS, Num_TVA_Intra, Type_Societe, Montant_Capital, Num_SIRET, Raison_Sociale, Adresse, Comp_Adresse, Code_Postal, Ville, Telephone, Fax, Email, Site_Web from DOSSIER where Dossier_Id='"+ dossierId +"'";
			
			rset = stt.executeQuery(reqFacturante);
			
			rset.next();
			
			this.raisonSociale = rset.getString("Raison_Sociale");
			this.adresse = rset.getString("Adresse");
			this.compAdresse = rset.getString("Comp_Adresse");
			this.codePostal = rset.getString("Code_Postal");
			this.ville = rset.getString("Ville");
			this.tel = rset.getString("Telephone");
			this.fax = rset.getString("Fax");
			this.email = rset.getString("Email");
			this.web = rset.getString("Site_Web");
			
			this.siren = formatSiren(rset.getString("Num_SIRET"));
			this.typeSociete = rset.getString("Type_Societe");
			this.capital = rset.getDouble("Montant_Capital");
			this.tvaIntra = rset.getString("Num_TVA_Intra");
			this.rcs = rset.getString("Ville_RCS");		
			
			rset.close();
			
			
			// Elments de la commande
			
			String reqCommande = "select c.Num_Entier, c.Date_Commande, c.Escompte, c.Acompte, c.Remise, c.Frais_Port, c.Type_Achat,";
			reqCommande += " c.Nom_Liv, c.Adresse_Liv, c.Comp_Adresse_Liv, c.Adresse_3_Liv, c.CP_Liv, c.Ville_Liv, p1.Nom_FR as Pays_Liv,";
			reqCommande += " c.Raison_Sociale, c.Adresse, c.Comp_Adresse, c.Adresse_3, c.Code_Postal, c.Ville, p2.Nom_FR as Pays,";
			reqCommande += " c.Fournisseur_Id, c.Commentaires, c.Imp_Com, c.Mentions from "+ base +".COMMANDE c, PAYS p1, PAYS p2";
			reqCommande += " where c.Code_Pays_Liv=p1.Code_Pays and c.Code_Pays=p2.Code_Pays and c.Commande_Id="+ commandeId;
			
			rset = stt.executeQuery(reqCommande);
			
			rset.next();
			
			this.numeroCommande = rset.getString("Num_Entier");
			this.dateCommande = rset.getLong("Date_Commande");
			this.tEscompte = rset.getDouble("Escompte");
			this.acompte = rset.getDouble("Acompte");
			this.tRemise = rset.getDouble("Remise");
			this.fraisPort = rset.getDouble("Frais_Port");			
			this.typeAchat = rset.getString("Type_Achat");
			
			this.raisonSocialeLiv = rset.getString("Nom_Liv");
			this.adresseLiv = rset.getString("Adresse_Liv");	
			this.compAdresseLiv = rset.getString("Comp_Adresse_Liv");	
			this.adresseLiv3 = rset.getString("Adresse_3_Liv");	
			this.codePostalLiv = rset.getString("CP_Liv");	
			this.villeLiv = rset.getString("Ville_Liv");	
			this.paysLiv = rset.getString("Pays_Liv");
			
			this.raisonSocialeDest = rset.getString("Raison_Sociale");
			this.adresseDest = rset.getString("Adresse");
			this.compAdresseDest = rset.getString("Comp_Adresse");
			this.adresseDest3 = rset.getString("Adresse_3");
			this.codePostalDest = rset.getString("Code_Postal");
			this.villeDest = rset.getString("Ville");
			this.paysDest = rset.getString("Pays");
			
			this.fournisseurId = rset.getString("Fournisseur_Id");
			
			if (rset.getInt("Imp_Com")==1 && rset.getString("Commentaires").length()>0) {
				this.comFin = "\n"+ rset.getString("Commentaires");
			}
			this.mentions = "\n" + rset.getString("Mentions");
			
			rset.close();
			
			
			// commande

      String reqFacturee = "select c.Util_C, civ.Civ_Courte, c.Nom_Inter, c.Prenom_Inter, c.Tel_Inter, c.Fax_Inter, c.Email_Inter, i.Code_Client ";
			reqFacturee += "from "+ base +".COMMANDE c, "+ base +".FICHE_FOURNISSEUR i, CIVILITE civ ";
			reqFacturee += "where c.Fournisseur_Id=i.Fournisseur_Id and c.Civ_Inter=civ.Civ_Id and c.Commande_Id="+ commandeId;

			rset = stt.executeQuery(reqFacturee);

			rset.next();			
			
			this.codeClient = rset.getString("Code_Client");			

			int utilR = rset.getInt("Util_C");

			this.interlocuteur = rset.getString("Civ_Courte") +" "+ rset.getString("Nom_Inter").toUpperCase() +" "+ rset.getString("Prenom_Inter");
			this.interFax = rset.getString("Fax_Inter");
			this.interTel = rset.getString("Tel_Inter");
			this.interMail = rset.getString("Email_Inter");
			
			rset.close();

			// responsable entreprise

			String reqResp = "select Civ_Courte, Nom, Prenom from UTILISATEUR, CIVILITE where Civ_Id=Civ_Courte and Utilisateur_Id="+ utilR;

			rset = stt.executeQuery(reqResp);

			rset.next();

			this.responsable = rset.getString("Civ_Courte") +" "+ rset.getString("Nom").toUpperCase() +" "+ rset.getString("Prenom");

			rset.close();			
			      
			
			// Paramtres dossier
      
			String reqCom = "select Logo_Adr from PARAM_DOSSIER where Dossier_Id='"+ dossierId +"'";
			
			rset = stt.executeQuery(reqCom);
			
			rset.next();
			
			logoAdr = rset.getInt("Logo_Adr")==1;
			
			rset.close();
					
			
			
			// ventilation des TVA		
				
			String reqVTvas = "select a.Taux_TVA, sum(a.Prix * a.Quantite * (1-a.Ristourne/100)) as Base_Montant "
										 + "from "+ base +".ARTICLE_COMMANDE a, "+ base +".TAUX_TVA t where Commande_Id="+ commandeId +" and a.Code_TVA=t.Code_TVA group by a.Taux_TVA order by a.Taux_TVA";
			
			rset = stt.executeQuery(reqVTvas);
			
			while (rset.next()) {
			
				double tauxTva = rset.getDouble("Taux_TVA");
			
				vtvas.add(new VentilTVA(rset.getDouble("Base_Montant") * (1-tRemise/100), tauxTva));				
				totalTVA += ((tauxTva/100) * rset.getDouble("Base_Montant") * (1-tRemise/100));
			}
			
			rset.close();
			
			
			// TVA NPR
			
			String reqTvaNpr = "select t.Taux_NPR, sum(a.Prix * a.Quantite * (1-a.Ristourne/100)) as Base_Montant "
											+ "from "+ base +".ARTICLE_COMMANDE a, "+ base +".TAUX_TVA t where Commande_Id="+ commandeId +" and t.Code_TVA=a.Code_TVA and t.Taux_NPR>0 group by t.Code_TVA order by t.Taux_NPR";
			
			rset = stt.executeQuery(reqTvaNpr);
			
			while (rset.next()) {
				VentilTVA vtva = new VentilTVA(rset.getDouble("Base_Montant") * (1-tRemise/100), rset.getDouble("Taux_NPR"));
				vtva.setNPR(true);
				vtvas.add(vtva);				
			}
			
			
			// selection des articles appartenant  la commande
			
			String reqArticles = "select * from "+ base +".ARTICLE_COMMANDE where Commande_Id="+ commandeId;
			rset = stt.executeQuery(reqArticles);
			
			
			String reqInfosSup = "select Couleur, Taille, Descrip_1, Descrip_2, Imp_Nom_BCF, Imp_Desc1_BCF, Imp_Desc2_BCF "
												 + "from "+ base +".FICHE_ARTICLE where Article_Id=?";
			
			PreparedStatement psInfosSup = con.prepareStatement(reqInfosSup);
			
			
			String reqNomenclature = "select n.ArticleComp_Id, n.Quantite, f.Designation "
														 + "from "+ base +".FICHE_ARTICLE f,"+ base +".COMPOSANT_ARTICLE n where f.Article_Id=n.ArticleComp_Id and n.Article_Id=?";
			
			PreparedStatement psNomenclature = con.prepareStatement(reqNomenclature);
					
			
			while (rset.next()) {
				
				String commentaireAvant = rset.getString("Commentaire_Avant");				
				
				if (commentaireAvant.length()>0) {
				
					String tabCom[] = commentaireAvant.split("\n");
					
					for (int i=0; i<tabCom.length; i++) {
					
						LigneCommandeFournisseur la = new LigneCommandeFournisseur();
						la.setType('C');
						la.setDesignation(tabCom[i]);
						la.setSousTotal(montantBase);
						lignes.add(la);
					}
				}
				
				LigneCommandeFournisseur lc = new LigneCommandeFournisseur();		
				
				lc.setReference(rset.getString("Ref_Fournisseur"));
				lc.setDesignation(rset.getString("Designation"));
				lc.setQuantite(rset.getDouble("Quantite"));
				lc.setUnite(rset.getString("Unite"));
				lc.setNbPieces(rset.getInt("Nb_Pieces"));
				lc.setPrixUnitaire(rset.getDouble("Prix"));
				lc.setRistourne(rset.getDouble("Ristourne"));
				lc.setType('A');				
				
				if (lc.ristourne!=0) rist = true;
				if (!lc.unite.equals("U")) unite = true;
				if (lc.nb_pieces != 0) nbPieces = true;
				
				lc.setMontant(lc.prixUnitaire * lc.quantite * (1-lc.ristourne/100));
				
				montantBase += lc.montant;
				
				lc.setSousTotal(montantBase);
				
				lignes.add(lc);
				
				String commentaireApres = rset.getString("Commentaire");				
				
				if (commentaireApres.length()>0) {
				
					String tabCom[] = commentaireApres.split("\n");
					
					for (int i=0; i<tabCom.length; i++) {
					
						LigneCommandeFournisseur ld = new LigneCommandeFournisseur();
						ld.setType('C');
						ld.setDesignation(tabCom[i]);
						ld.setSousTotal(montantBase);
						lignes.add(ld);
					}
				}
				
				
				if (rset.getString("Type_Ligne").equalsIgnoreCase("S")) {					
				
					// rcupration infos supplmentaires si existent
					psInfosSup.setString(1, rset.getString("Reference"));
					ResultSet rsIS = psInfosSup.executeQuery();

					if (rsIS.next()) {

						lc.setCouleur(rsIS.getString("Couleur"));
						lc.setTaille(rsIS.getString("Taille"));

						if (rsIS.getString("Couleur").length()>0) {
							coul = true;
						}

						if (rsIS.getString("Taille").length()>0) {
							tail = true;
						}
						
						if (rsIS.getInt("Imp_Desc1_BCF")==1) {
							lc.setDetail_1(StringUtils.removeHtmlTags(rsIS.getString("Descrip_1")));
						}
						if (rsIS.getInt("Imp_Desc2_BCF")==1) {
							lc.setDetail_2(StringUtils.removeHtmlTags(rsIS.getString("Descrip_2")));
						}

						// gestion de la nomenclature
						if (rsIS.getInt("Imp_Nom_BCF")==1)	{

							psNomenclature.setString(1, rset.getString("Reference"));
							ResultSet rsN = psNomenclature.executeQuery();

							while (rsN.next()) {
								LigneCommandeFournisseur ln = new LigneCommandeFournisseur();

								ln.setReference(rsN.getString("ArticleComp_Id"));
								ln.setDesignation(rsN.getString("Designation"));
								ln.setQuantite(rsN.getDouble("Quantite"));
								ln.setType('N');
								ln.setSousTotal(montantBase);			

								lignes.add(ln);
							}

							rsN.close();
						}
						
					}
					rsIS.close();								
				}				
			}
			
			mRemise = montantBase * tRemise/100;
			totalBase = montantBase + fraisPort - mRemise;
			
			if (typeAchat.equalsIgnoreCase("N")) {		
				String reqTvaFr = "select Taux_TVA from "+ base +".TAUX_TVA where Normal=1 and Code_Pays='FR'";
				rset = stt.executeQuery(reqTvaFr);
				if (rset.next()) {
					tauxTvaPort=rset.getDouble("Taux_TVA");
				}
				totalTVA = totalTVA + fraisPort * tauxTvaPort/100;
			}			
			
			montantTTC = totalBase + totalTVA;
			mEscompte = r.round(montantTTC * tEscompte/100);
			netAPayer = montantTTC - mEscompte - acompte;
			
			
      rset.close();
			stt.close();			
			s.closeConnection(con, null);
			
		} catch(Exception e) {
			e.printStackTrace();
		}	
	}
	
	
	
	public double calcSousTotal(int derniereLigne) {
	
		if (derniereLigne<0) 
			return 0;
		else {
			return lignes.get(derniereLigne).sousTotal;
		}		
	}	
	
	
	public int getNbLignes() {
		return lignes.size();
	}
	
	
	public String formatSiren(String siret) {
		if (siret.length()>=9) {
			return siret.substring(0,3) +" "+ siret.substring(3,6) +" "+ siret.substring(6,9);
		}
		else {
			return siret;
		}
	}
	
	
} // fin DataCommandeFournisseur
