/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 * Donnes ncessaires  l'dition d'un devis standard
 */

package org.opensi.facturation.actions.documents.modeles;


import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;

import org.experlog.openeas.api.Session;
import org.opensi.util.tools.Arrondi;
import org.opensi.util.tools.StringUtils;


public class DataDevis {


	// les lignes du devis
	protected ArrayList<LigneDevis> lignes = new ArrayList<LigneDevis>(10);
	


	// coordonnes socit mettrice

	protected String raisonSociale;
	protected String adresse;
	protected String compAdresse;
	protected String codePostal;
	protected String ville;
	protected String tel;
	protected String fax;
	protected String email;
	protected String web;
	
	protected double capital;
	protected String typeSociete;
	protected String tvaIntra;
	protected String rcs;
	protected String siren;
	
	// coordonnes du destinataire
	
	protected String clientId;
	protected String raisonSocialeDest;
	protected String adresseDest;
	protected String compAdresseDest;
	protected String adresseDest3;
	protected String codePostalDest;
	protected String villeDest;
	protected String paysDest;
	
	// coordonnes de livraison
	
	protected String denominationLiv;
	protected String adresse1Liv;
	protected String adresse2Liv;
	protected String adresse3Liv;
	protected String codePostalLiv;
	protected String villeLiv;
	protected String codePaysLiv;
	protected String paysLiv;
	
	// infos devis	
	
	protected String numeroDevis;	
	protected String responsable = "";
	protected String interlocuteur = "";
	protected String interTel = "";
	protected String interFax = "";
	protected String interMail = "";
	protected String interlocuteurLiv = "";
	protected String interTelLiv = "";
	protected String interFaxLiv = "";
	protected String interMailLiv = "";
	protected boolean zoneUE=false;
	protected String regimeTVA = "G";
	
	protected long dateDevis;
	protected long dateExp;	
	
	protected double tRemise = 0;
	protected double tEscompte = 0;
	protected double mRemise = 0;
	protected double mEscompte = 0;
	protected double acompte = 0;
	protected double fraisPort = 0;
	protected double montantBase = 0;
	protected double totalBase = 0;
	protected double totalTVA = 0;
	protected double montantTTC = 0;
	protected double netAPayer = 0;
	protected double tauxTvaPort = 0;
	protected String numTvaClient = "";
	
	protected boolean editionTTC = false;
	protected boolean exonerationTVA = false;
	
	protected boolean rist = false;
	protected boolean coul = false;
	protected boolean tail = false;
	protected boolean unite = false;
	protected boolean nbPieces = false;
	protected boolean numLot = false;
	protected boolean datePeremption = false;
	protected boolean logoAdr;
	protected String urlLogo = "";
	
	protected String comFin = "";
	protected String mentions = "";
	
	protected ArrayList<VentilTVA> vtvas = new ArrayList<VentilTVA>(2);
	
	
	private Arrondi r = new Arrondi(2);
	
	protected boolean imprimerAdrLiv;
	
	
	
	public DataDevis(Session s, String devisId) {	
		try {
		
			Connection con = s.getConnection(null);
			Statement stt = con.createStatement();
      
			
			String base = s.getCookie().get("BaseDossier");
			String dossierId = s.getCookie().get("Dossier_Id");
			
			this.urlLogo = s.getAppConfiguration().get("opensi.absdir") +"/logos/"+ dossierId +".jpg";
      
			ResultSet rset;
			
      
			// coordonnes de l'entreprise facturante
      
			String reqFacturante = "select Ville_RCS, Num_TVA_Intra, Type_Societe, Montant_Capital, Num_SIRET, Raison_Sociale, Adresse, Comp_Adresse, Code_Postal, Ville, Telephone, Fax, Email, Site_Web from DOSSIER where Dossier_Id='"+ dossierId +"'";
			
			rset = stt.executeQuery(reqFacturante);
			
			rset.next();
			
			this.raisonSociale = rset.getString("Raison_Sociale");
			this.adresse = rset.getString("Adresse");
			this.compAdresse = rset.getString("Comp_Adresse");
			this.codePostal = rset.getString("Code_Postal");
			this.ville = rset.getString("Ville");
			this.tel = rset.getString("Telephone");
			this.fax = rset.getString("Fax");
			this.email = rset.getString("Email");
			this.web = rset.getString("Site_Web");
			
			this.siren = formatSiren(rset.getString("Num_SIRET"));
			this.typeSociete = rset.getString("Type_Societe");
			this.capital = rset.getDouble("Montant_Capital");
			this.tvaIntra = rset.getString("Num_TVA_Intra");
			this.rcs = rset.getString("Ville_RCS");
			
			rset.close();
			
			
			// Elments du devis
			
			String reqDevis = "select d.*, c1.Civ_Courte as Civ_Courte_Fact, c2.Civ_Courte as Civ_Courte_Liv, p1.Nom_FR, p2.Nom_FR as Pays_Liv, p2.Zone_UE from "+ base +".DEVIS d, CIVILITE c1, CIVILITE c2, PAYS p1, PAYS p2";
			reqDevis += " where c1.Civ_Id=d.Civ_Inter and c2.Civ_Id=d.Civ_Inter_Liv and d.Code_Pays=p1.Code_Pays and d.Code_Pays_Liv=p2.Code_Pays and d.Devis_Id="+ devisId;
			
			rset = stt.executeQuery(reqDevis);
			
			rset.next();
			
			this.numeroDevis = rset.getString("Num_Entier");
			this.dateDevis = rset.getLong("Date_Devis");
			this.tEscompte = rset.getDouble("Escompte");
			this.acompte = rset.getDouble("Acompte");
			this.tRemise = rset.getDouble("Remise");
			this.fraisPort = rset.getDouble("Frais_Port");
			this.dateExp = rset.getLong("Date_Exp");
			
			this.raisonSocialeDest = rset.getString("Raison_Sociale");
			this.adresseDest = rset.getString("Adresse");
			this.compAdresseDest = rset.getString("Comp_Adresse");
			this.adresseDest3 = rset.getString("Adresse_3");
			this.codePostalDest = rset.getString("Code_Postal");
			this.villeDest = rset.getString("Ville");
			this.paysDest = rset.getString("Nom_FR");
			this.denominationLiv = rset.getString("Denomination_Liv");
			this.adresse1Liv = rset.getString("Adresse_1_Liv");
			this.adresse2Liv = rset.getString("Adresse_2_Liv");
			this.adresse3Liv = rset.getString("Adresse_3_Liv");
			this.codePostalLiv = rset.getString("Code_Postal_Liv");
			this.villeLiv = rset.getString("Ville_Liv");
			this.codePaysLiv = rset.getString("Code_Pays_Liv");
			this.paysLiv = rset.getString("Pays_Liv");
			
			this.clientId = rset.getString("Client_Id");
			this.zoneUE = (rset.getInt("Zone_UE")==1);
			this.regimeTVA = rset.getString("Regime_TVA");
			this.tauxTvaPort = rset.getDouble("Taux_TVA_Port");
			this.numTvaClient = rset.getString("Num_TVA_Intra");
			this.editionTTC = rset.getInt("Edition_TTC")==1;
				
			this.interlocuteur = rset.getString("Civ_Courte_Fact") +" "+ rset.getString("Nom_Inter").toUpperCase() +" "+ rset.getString("Prenom_Inter");
			this.interFax = rset.getString("Fax_Inter");
			this.interTel = rset.getString("Tel_Inter");
			this.interMail = rset.getString("Email_Inter");
			
			this.interlocuteurLiv = rset.getString("Civ_Courte_Liv") +" "+ rset.getString("Nom_Inter_Liv").toUpperCase() +" "+ rset.getString("Prenom_Inter_Liv");
			this.interFaxLiv = rset.getString("Fax_Inter_Liv");
			this.interTelLiv = rset.getString("Tel_Inter_Liv");
			this.interMailLiv = rset.getString("Email_Inter_Liv");
			
			int utilR = rset.getInt("Util_R");
			
			if (rset.getInt("Imp_Com")==1 && rset.getString("Commentaires").length()>0) {
				this.comFin = "\n"+ rset.getString("Commentaires");
			}
			this.mentions = "\n\n"+ rset.getString("Mentions");
			
			rset.close();
			
			this.exonerationTVA = this.regimeTVA.equals("E") || (this.regimeTVA.equals("G") && !this.zoneUE);
			
			// responsable entreprise
			
			String reqResp = "select Civ_Courte, Nom, Prenom from UTILISATEUR, CIVILITE where Civ_Id=Civilite and Utilisateur_Id="+ utilR;
			
			
			rset = stt.executeQuery(reqResp);
			
			if (rset.next()) {
			
				this.responsable = rset.getString("Civ_Courte") +" "+ rset.getString("Nom").toUpperCase() +" "+ rset.getString("Prenom");
			}
			
			rset.close();
			      
			
			// Paramtres dossier
      
			String reqCom = "select Com_Devis, Logo_Adr, Imprimer_Adr_Liv from PARAM_DOSSIER where Dossier_Id='"+ dossierId +"'";
			
			rset = stt.executeQuery(reqCom);
			
			rset.next();
			
			logoAdr = rset.getInt("Logo_Adr")==1;
			
			if (rset.getString("Com_Devis").length()>0) {
				this.comFin += "\n\n"+rset.getString("Com_Devis");
			}
			
			this.imprimerAdrLiv = (rset.getInt("Imprimer_Adr_Liv")==1 || !this.codePaysLiv.equals("FR"));
			
			rset.close();
			
			
			// ventilation des TVA		
				
			String reqVTvas = "select a.Taux_TVA, sum(a.Prix * a.Quantite * (1-a.Ristourne/100)) as Base_Montant "
										 + "from "+ base +".ARTICLE_DEVIS a, "+ base +".TAUX_TVA t where Devis_Id="+ devisId +" and a.Code_TVA=t.Code_TVA group by a.Taux_TVA order by a.Taux_TVA";
			
			rset = stt.executeQuery(reqVTvas);
			
			while (rset.next()) {
			
				double tauxTva = rset.getDouble("Taux_TVA");
			
				if (editionTTC) {									
					double montantTVA = (rset.getDouble("Base_Montant") * (1-tRemise/100) * (tauxTva/100) / (tauxTva/100+1));					
					totalTVA += montantTVA;					
					vtvas.add(new VentilTVA(rset.getDouble("Base_Montant") * (1-tRemise/100) - montantTVA, tauxTva));
				}
				else {
					vtvas.add(new VentilTVA(rset.getDouble("Base_Montant") * (1-tRemise/100), tauxTva));				
					totalTVA += ((tauxTva/100) * rset.getDouble("Base_Montant") * (1-tRemise/100));
				}
			}
			
			rset.close();
			
			
			// TVA NPR
			
			String reqTvaNpr = "select t.Taux_NPR, sum(a.Prix * a.Quantite * (1-a.Ristourne/100)) as Base_Montant "
											+ "from "+ base +".ARTICLE_DEVIS a, "+ base +".TAUX_TVA t where Devis_Id="+ devisId +" and t.Code_TVA=a.Code_TVA and t.Taux_NPR>0 group by t.Code_TVA order by t.Taux_NPR";
			
			rset = stt.executeQuery(reqTvaNpr);
			
			while (rset.next()) {
				VentilTVA vtva = new VentilTVA(rset.getDouble("Base_Montant") * (1-tRemise/100), rset.getDouble("Taux_NPR"));
				vtva.setNPR(true);
				vtvas.add(vtva);				
			}
				
      
      
      // selection des articles appartenant au devis
			  
			String reqArticles = "select * from "+ base +".ARTICLE_DEVIS where Devis_Id="+ devisId;
			rset = stt.executeQuery(reqArticles);

			
			String reqInfosSup = "select Couleur, Taille, Marque, Descrip_1, Descrip_2, Imp_Nom_Devis, Imp_Desc1_Devis, Imp_Desc2_Devis "
												 + "from "+ base +".FICHE_ARTICLE where Article_Id=?";
			
			PreparedStatement psInfosSup = con.prepareStatement(reqInfosSup);
			
			
			String reqNomenclature = "select n.ArticleComp_Id, n.Quantite, f.Designation "
														 + "from "+ base +".FICHE_ARTICLE f,"+ base +".COMPOSANT_ARTICLE n where f.Article_Id=n.ArticleComp_Id and n.Article_Id=?";
			
			PreparedStatement psNomenclature = con.prepareStatement(reqNomenclature);
					
			
			while (rset.next()) {
				
				String commentaireAvant = rset.getString("Commentaire_Avant");				
				
				if (commentaireAvant.length()>0) {
				
					String tabCom[] = commentaireAvant.split("\n");
					
					for (int i=0; i<tabCom.length; i++) {
					
						LigneDevis ld = new LigneDevis();
						ld.setType('C');
						ld.setDesignation(tabCom[i]);
						ld.setSousTotal(montantBase);
						lignes.add(ld);
					}
				}
				
				LigneDevis ld = new LigneDevis();
        
				String libelle = rset.getString("Libelle");
				
				if (libelle.length()>0) {
					libelle = "\n"+libelle;
				}			
				
				ld.setReference(rset.getString("Reference"));
				ld.setDesignation(rset.getString("Designation") + libelle);

				ld.setQuantite(rset.getDouble("Quantite"));
				ld.setPrixUnitaire(rset.getDouble("Prix"));
				ld.setRistourne(rset.getDouble("Ristourne"));
				ld.setUnite(rset.getString("Unite"));
				ld.setNumLot(rset.getString("Num_Lot"));
				ld.setNbPieces(rset.getInt("Nb_Pieces"));
				ld.setDatePeremption(rset.getLong("Date_Peremption"));
				ld.setType('A');				
				
				if (ld.ristourne!=0) rist = true;
				if (!ld.unite.equals("U")) unite = true;
				if (!ld.num_lot.equals("")) numLot = true;
				if (ld.nb_pieces != 0) nbPieces = true;
				if (ld.date_peremption != 0) datePeremption = true;
				
				ld.setMontant(ld.prixUnitaire * ld.quantite * (1-ld.ristourne/100));
				
				montantBase += ld.montant;
				
				ld.setSousTotal(montantBase);
				
				lignes.add(ld);
				
				
				String commentaireApres = rset.getString("Commentaire");				
				
				if (commentaireApres.length()>0) {
				
					String tabCom[] = commentaireApres.split("\n");
					
					for (int i=0; i<tabCom.length; i++) {
					
						LigneDevis lc = new LigneDevis();
						lc.setType('C');
						lc.setDesignation(tabCom[i]);
						lc.setSousTotal(montantBase);
						lignes.add(lc);
					}
				}
				
				
				if (rset.getString("Type_Ligne").equalsIgnoreCase("S")) {					
				
					// rcupration infos supplmentaires si existent
					psInfosSup.setString(1, ld.reference);
					ResultSet rsIS = psInfosSup.executeQuery();

					if (rsIS.next()) {

						ld.setCouleur(rsIS.getString("Couleur"));
						ld.setTaille(rsIS.getString("Taille"));
						
						if (rsIS.getString("Marque").length()>0) {
							ld.setMarque(rsIS.getString("Marque"));
						}
						if (rsIS.getString("Couleur").length()>0) {
							coul = true;
						}

						if (rsIS.getString("Taille").length()>0) {
							tail = true;
						}
						
						if (rsIS.getInt("Imp_Desc1_Devis")==1) {
							ld.setDetail_1(StringUtils.removeHtmlTags(rsIS.getString("Descrip_1")));
						}
						if (rsIS.getInt("Imp_Desc2_Devis")==1) {
							ld.setDetail_2(StringUtils.removeHtmlTags(rsIS.getString("Descrip_2")));
						}

						// gestion de la nomenclature
						if (rsIS.getInt("Imp_Nom_Devis")==1)	{

							psNomenclature.setString(1, ld.reference);
							ResultSet rsN = psNomenclature.executeQuery();

							while (rsN.next()) {
								LigneDevis ln = new LigneDevis();

								ln.setReference(rsN.getString("ArticleComp_Id"));
								ln.setDesignation(rsN.getString("Designation"));
								ln.setQuantite(rsN.getDouble("Quantite"));
								ln.setType('N');
								ln.setSousTotal(montantBase);			

								lignes.add(ln);
							}

							rsN.close();
						}
						
					}
					rsIS.close();								
				}				
			}
			
			
			mRemise = montantBase * tRemise/100;
			totalBase = montantBase + fraisPort - mRemise;
			
			if (editionTTC) {
				totalTVA = totalTVA + fraisPort * (tauxTvaPort/100) / (tauxTvaPort/100+1);
			}
			else {
				totalTVA = totalTVA + fraisPort * tauxTvaPort/100;
			}
			
			montantTTC = (editionTTC?totalBase:totalBase + totalTVA);
			mEscompte = r.round(montantTTC * tEscompte/100);
			netAPayer = montantTTC - mEscompte - acompte;
			
			
      rset.close();
			stt.close();			
			s.closeConnection(con, null);
			
		} catch(Exception e) {
			e.printStackTrace();
		}	
	}
	
	
	
	public double calcSousTotal(int derniereLigne) {
	
		if (derniereLigne<0) 
			return 0;
		return lignes.get(derniereLigne).sousTotal;		
	}
	
	
	
	public int getNbLignes() {
		return lignes.size();
	}
	
	
	public String formatSiren(String siret) {
		if (siret.length()>=9) {
			return siret.substring(0,3) +" "+ siret.substring(3,6) +" "+ siret.substring(6,9);
		}
		return siret;
	}
	
	

} // fin DataDevis
