/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 * Donnes ncessaires  l'dition d'un proforma standard
 */

package org.opensi.facturation.actions.documents.modeles;


import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.util.ArrayList;

import org.experlog.openeas.api.Session;
import org.opensi.util.tools.Arrondi;
import org.opensi.util.tools.StringUtils;


public class DataProforma {


	private DecimalFormatSymbols dfs2 = new DecimalFormatSymbols();
	
	private DecimalFormat numFormatQte = new DecimalFormat("0.##");



	// les lignes de la facture
	protected ArrayList<LigneFacture> lignes = new ArrayList<LigneFacture>(10);
	


	// coordonnes socit mettrice

	protected String raisonSociale;
	protected String adresse;
	protected String compAdresse;
	protected String codePostal;
	protected String ville;
	protected String tel;
	protected String fax;
	protected String email;
	protected String web;
	
	protected double capital;
	protected String typeSociete;
	protected String tvaIntra;
	protected String rcs;
	protected String siren;
	
	// coordonnes du destinataire
	
	protected String clientId;
	protected String raisonSocialeDest;
	protected String adresseDest;
	protected String compAdresseDest;
	protected String adresseDest3;
	protected String codePostalDest;
	protected String villeDest;
	protected String paysDest;
	
	// coordonnes de livraison
	
	protected String denominationLiv;
	protected String adresse1Liv;
	protected String adresse2Liv;
	protected String adresse3Liv;
	protected String codePostalLiv;
	protected String villeLiv;
	protected String paysLiv;
	
	protected String codePaysLiv;
	
	protected String numTvaClient = "";	
	
	// infos facture
	
	protected String numeroProforma;
	protected String interlocuteur = "";
	protected String interlocuteurLiv = "";
	protected boolean zoneUE=false;
	protected String modeReglement;
	protected String comFin = "";
	protected String mentions = "";
	protected String codeFournisseur;
	
	protected long dateProforma;
	protected long dateEcheance;
	
	protected double tRemise = 0;
	protected double tEscompte = 0;
	protected double mRemise = 0;
	protected double mEscompte = 0;
	protected double acompte = 0;
	protected double fraisPort = 0;
	protected double montantBase = 0;
	protected double totalBase = 0;
	protected double totalTVA = 0;
	protected double montantTTC = 0;
	protected double netAPayer = 0;
	protected double tauxTvaPort = 0;
	protected double ecoTaxe = 0;
	
	protected boolean editionTTC = false;
	protected boolean rist = false;
	protected boolean coul = false;
	protected boolean tail = false;
	protected boolean unite = false;
	protected boolean nbPieces = false;
	protected boolean numLot = false;
	protected boolean datePeremption = false;
	protected boolean logoAdr;
	protected String urlLogo = "";
	protected String urlApercu = "";
	
	protected String regimeTVA = "G";
	protected boolean exonerationTVA = false;
	
	protected int nbex;
	protected boolean imprimerAdrLiv;
	
	private int comWebId;
	

	protected ArrayList<VentilTVA> vtvas = new ArrayList<VentilTVA>(2);
	
	private Arrondi r = new Arrondi(2);
	
	
	public DataProforma(Session s, String proformaId) {	
		try {
		
			Connection con = s.getConnection(null);
			Statement stt = con.createStatement();
			
			String dossierId = s.getCookie().get("Dossier_Id");
			String base = s.getCookie().get("BaseDossier");
			
			this.urlLogo = s.getAppConfiguration().get("opensi.absdir") +"/logos/"+ dossierId +".jpg";
      
			ResultSet rset;
			
			dfs2.setDecimalSeparator('.');
			numFormatQte.setDecimalFormatSymbols(dfs2);
			
      
			// coordonnes de l'entreprise facturante
      
			String reqFacturante = "select Ville_RCS, Num_TVA_Intra, Type_Societe, Montant_Capital, Num_SIRET, Raison_Sociale, Adresse, Comp_Adresse, Code_Postal, Ville, Telephone, Fax, Email, Site_Web from DOSSIER where Dossier_Id='"+ dossierId +"'";
			
			rset = stt.executeQuery(reqFacturante);
			
			rset.next();
			
			this.raisonSociale = rset.getString("Raison_Sociale");
			this.adresse = rset.getString("Adresse");
			this.compAdresse = rset.getString("Comp_Adresse");
			this.codePostal = rset.getString("Code_Postal");
			this.ville = rset.getString("Ville");
			this.tel = rset.getString("Telephone");
			this.fax = rset.getString("Fax");
			this.email = rset.getString("Email");
			this.web = rset.getString("Site_Web");
			
			this.siren = formatSiren(rset.getString("Num_SIRET"));
			this.typeSociete = rset.getString("Type_Societe");
			this.capital = rset.getDouble("Montant_Capital");
			this.tvaIntra = rset.getString("Num_TVA_Intra");
			this.rcs = rset.getString("Ville_RCS");		
			
			rset.close();
			
			// Elments du proforma
			
			String reqProforma = "select pr.*, c1.Civ_Courte as Civ_Courte_Fact, c2.Civ_Courte as Civ_Courte_Liv, p1.Nom_FR, p2.Nom_FR as Pays_Liv, p2.Zone_UE from "+ base +".PROFORMA pr, CIVILITE c1, CIVILITE c2, PAYS p1, PAYS p2";
			reqProforma += " where c1.Civ_Id=pr.Civ_Inter and c2.Civ_Id=pr.Civ_Inter_Liv and pr.Code_Pays=p1.Code_Pays and pr.Code_Pays_Liv=p2.Code_Pays and pr.Proforma_Id="+ proformaId;
			
			rset = stt.executeQuery(reqProforma);
			
			rset.next();
			
			this.numeroProforma = rset.getString("Num_Entier");
			this.dateProforma = rset.getLong("Date_Proforma");
			this.tEscompte = rset.getDouble("Escompte");
			this.acompte = rset.getDouble("Acompte");
			this.tRemise = rset.getDouble("Remise");
			this.fraisPort = rset.getDouble("Frais_Port");
			this.dateEcheance = rset.getLong("Echeance");
			
			this.raisonSocialeDest = rset.getString("Raison_Sociale");
			this.adresseDest = rset.getString("Adresse");
			this.compAdresseDest = rset.getString("Comp_Adresse");
			this.adresseDest3 = rset.getString("Adresse_3");
			this.codePostalDest = rset.getString("Code_Postal");
			this.villeDest = rset.getString("Ville");
			this.paysDest = rset.getString("Nom_FR");
			this.denominationLiv = rset.getString("Denomination_Liv");
			this.adresse1Liv = rset.getString("Adresse_1_Liv");
			this.adresse2Liv = rset.getString("Adresse_2_Liv");
			this.adresse3Liv = rset.getString("Adresse_3_Liv");
			this.codePostalLiv = rset.getString("Code_Postal_Liv");
			this.villeLiv = rset.getString("Ville_Liv");
			this.paysLiv = rset.getString("Pays_Liv");
			this.codePaysLiv = rset.getString("Code_Pays_Liv");
			this.zoneUE = (rset.getInt("Zone_UE")==1);
			this.clientId = rset.getString("Client_Id");		
			this.comWebId= rset.getInt("Com_Web_Id");
			this.editionTTC = rset.getInt("Edition_TTC")==1;
			this.numTvaClient = rset.getString("Num_TVA_Intra");
			this.modeReglement = rset.getString("Mode_Reg");
			this.tauxTvaPort = rset.getDouble("Taux_TVA_Port");
			this.ecoTaxe = rset.getDouble("Eco_Taxe");
			this.regimeTVA = rset.getString("Regime_TVA");
			
			
			if (rset.getString("Nom_Inter").equals("")) {
				this.interlocuteur = "";
			}
			else {
				this.interlocuteur = rset.getString("Civ_Courte_Fact") +" "+ rset.getString("Nom_Inter").toUpperCase() + " " + rset.getString("Prenom_Inter");
			}
			
			if (rset.getString("Nom_Inter_Liv").equals("")) {
				this.interlocuteurLiv = "";
			}
			else {
				this.interlocuteurLiv = rset.getString("Civ_Courte_Liv") +" "+ rset.getString("Nom_Inter_Liv").toUpperCase() + " " + rset.getString("Prenom_Inter_Liv");
			}
			
			
			if (rset.getString("Commentaires").length()>0) {
				this.comFin = StringUtils.removeHtmlTags("\n"+ rset.getString("Commentaires"));
			}
			this.mentions = StringUtils.removeHtmlTags("\n\n"+ rset.getString("Mentions"));
			
			rset.close();
			
			this.exonerationTVA = this.regimeTVA.equals("E") || (this.regimeTVA.equals("G") && !this.zoneUE);
			      
			
			// Paramtres dossier
      
			String reqCom = "select Com_Fact, Logo_Adr, Imprimer_Adr_Liv from PARAM_DOSSIER where Dossier_Id='"+ dossierId +"'";
			
			rset = stt.executeQuery(reqCom);
			
			rset.next();
			
			logoAdr = rset.getInt("Logo_Adr")==1;
			
			if (rset.getString("Com_Fact").length()>0) {
				this.comFin += "\n\n"+rset.getString("Com_Fact");
			}
			
			this.imprimerAdrLiv = (rset.getInt("Imprimer_Adr_Liv")==1 || !this.codePaysLiv.equals("FR"));
			
			rset.close();
			
			// ventilation des TVA		
				
			String reqVTvas = "select a.Taux_TVA, sum(a.Prix * a.Quantite * (1-a.Ristourne/100)) as Base_Montant "
										 + "from "+ base +".ARTICLE_PROFORMA a, "+ base +".TAUX_TVA t where Proforma_Id="+ proformaId +" and a.Code_TVA=t.Code_TVA group by a.Taux_TVA order by a.Taux_TVA";
			
			rset = stt.executeQuery(reqVTvas);
			
			while (rset.next()) {
			
				double tauxTva = rset.getDouble("Taux_TVA");
			
				if (editionTTC) {									
					double montantTVA = (rset.getDouble("Base_Montant") * (1-tRemise/100) * (tauxTva/100) / (tauxTva/100+1));					
					totalTVA += montantTVA;					
					vtvas.add(new VentilTVA(rset.getDouble("Base_Montant") * (1-tRemise/100) - montantTVA, tauxTva));
				}
				else {
					vtvas.add(new VentilTVA(rset.getDouble("Base_Montant") * (1-tRemise/100), tauxTva));				
					totalTVA += ((tauxTva/100) * rset.getDouble("Base_Montant") * (1-tRemise/100));
				}
			}
			
			rset.close();
			
			
			// TVA NPR
			
			String reqTvaNpr = "select t.Taux_NPR, sum(a.Prix * a.Quantite * (1-a.Ristourne/100)) as Base_Montant "
											+ "from "+ base +".ARTICLE_PROFORMA a, "+ base +".TAUX_TVA t where Proforma_Id="+ proformaId +" and t.Code_TVA=a.Code_TVA and t.Taux_NPR>0 group by t.Code_TVA order by t.Taux_NPR";
			
			rset = stt.executeQuery(reqTvaNpr);
			
			while (rset.next()) {
				VentilTVA vtva = new VentilTVA(rset.getDouble("Base_Montant") * (1-tRemise/100), rset.getDouble("Taux_NPR"));
				vtva.setNPR(true);
				vtvas.add(vtva);				
			}
						
			
			// nombre d'exemplaires  sortir et donnes fiche client
       
			if (clientId.equals("")) {
				this.comFin += "\n\n";
				this.nbex = 1;
				this.codeFournisseur = "";
			}
			else {

				String reqEx = "select Nb_Ex, Com_Fact, Code_Fournisseur, Num_TVA_Intra from "+ base +".FICHE_CLIENT where Client_Id='"+ clientId +"'";
				rset = stt.executeQuery(reqEx);
			
				if (rset.next()) {
					if (rset.getString("Com_Fact").length()>0) {
						this.comFin += "\n\n"+rset.getString("Com_Fact");
					}
					this.nbex = rset.getInt("Nb_Ex") + 1;
					this.codeFournisseur = rset.getString("Code_Fournisseur");
				} else {
					this.comFin += "\n\n";
					this.nbex = 1;
					this.codeFournisseur = "";
				}			
				rset.close();
			}					
      
      
			// selection des articles appartenant  la facture
			
			String reqArticles = "select * from "+ base +".ARTICLE_PROFORMA where Proforma_Id="+ proformaId;
			rset = stt.executeQuery(reqArticles);
			
			
			String reqInfosSup = "select Couleur, Taille, Descrip_1, Descrip_2, Imp_Nom_Facture, Imp_Desc1_Facture, Imp_Desc2_Facture "
												 + "from "+ base +".FICHE_ARTICLE where Article_Id=?";
			
			PreparedStatement psInfosSup = con.prepareStatement(reqInfosSup);
			
			
			String reqNomenclature = "select n.ArticleComp_Id, n.Quantite, f.Designation "
														 + "from "+ base +".FICHE_ARTICLE f,"+ base +".COMPOSANT_ARTICLE n where f.Article_Id=n.ArticleComp_Id and n.Article_Id=?";
			
			PreparedStatement psNomenclature = con.prepareStatement(reqNomenclature);
					
			
			while (rset.next()) {
				
				String commentaireAvant = rset.getString("Commentaire_Avant");				
				
				if (commentaireAvant.length()>0) {
				
					String tabCom[] = commentaireAvant.split("\n");
					
					for (int i=0; i<tabCom.length; i++) {
					
						LigneFacture la = new LigneFacture();
						la.setType('C');
						la.setDesignation(tabCom[i]);
						la.setSousTotal(montantBase);
						lignes.add(la);
					}
				}
				
				LigneFacture lf = new LigneFacture();
        
				String libelle = rset.getString("Libelle");
				
				if (libelle.length()>0) {
					libelle = "\n"+ libelle;
				}			
				
				lf.setReference(rset.getString("Reference"));
				lf.setDesignation(rset.getString("Designation") + libelle);
				lf.setQuantite(rset.getDouble("Quantite"));
				lf.setPrixUnitaire(rset.getDouble("Prix"));
				lf.setRistourne(rset.getDouble("Ristourne"));
				lf.setUnite(rset.getString("Unite"));
				lf.setNumLot(rset.getString("Num_Lot"));
				lf.setNbPieces(rset.getInt("Nb_Pieces"));
				lf.setDatePeremption(rset.getLong("Date_Peremption"));
				lf.setType('A');				
				
				if (lf.ristourne!=0) rist = true;
				if (!lf.unite.equals("U")) unite = true;
				if (!lf.num_lot.equals("")) numLot = true;
				if (lf.nb_pieces != 0) nbPieces = true;
				if (lf.date_peremption != 0) datePeremption = true;
				
				lf.setMontant(lf.prixUnitaire * lf.quantite * (1-lf.ristourne/100));
				
				montantBase += lf.montant;
				
				lf.setSousTotal(montantBase);
				
				lignes.add(lf);

				String commentaireApres = rset.getString("Commentaire");				
				
				if (commentaireApres.length()>0) {
				
					String tabCom[] = commentaireApres.split("\n");
					
					for (int i=0; i<tabCom.length; i++) {
					
						LigneFacture lc = new LigneFacture();
						lc.setType('C');
						lc.setDesignation(tabCom[i]);
						lc.setSousTotal(montantBase);
						lignes.add(lc);
					}
				}
				
				
				if (rset.getString("Type_Ligne").equalsIgnoreCase("S")) {					
				
					// rcupration infos supplmentaires si existent
					psInfosSup.setString(1, lf.reference);
					ResultSet rsIS = psInfosSup.executeQuery();

					if (rsIS.next()) {

						lf.setCouleur(rsIS.getString("Couleur"));
						lf.setTaille(rsIS.getString("Taille"));

						if (rsIS.getString("Couleur").length()>0) {
							coul = true;
						}

						if (rsIS.getString("Taille").length()>0) {
							tail = true;
						}
						
						if (rsIS.getInt("Imp_Desc1_Facture")==1) {
							lf.setDetail_1(StringUtils.removeHtmlTags(rsIS.getString("Descrip_1")));
						}
						if (rsIS.getInt("Imp_Desc2_Facture")==1) {
							lf.setDetail_2(StringUtils.removeHtmlTags(rsIS.getString("Descrip_2")));
						}

						// gestion de la nomenclature
						if (rsIS.getInt("Imp_Nom_Facture")==1)	{

							psNomenclature.setString(1, lf.reference);
							ResultSet rsN = psNomenclature.executeQuery();

							while (rsN.next()) {
								LigneFacture ln = new LigneFacture();

								ln.setReference(rsN.getString("ArticleComp_Id"));
								ln.setDesignation(rsN.getString("Designation"));
								ln.setQuantite(rsN.getDouble("Quantite"));
								ln.setType('N');
								ln.setSousTotal(montantBase);			

								lignes.add(ln);
							}

							rsN.close();
						}
						
					}
					rsIS.close();								
				}				
			}
			
			
			mRemise = montantBase * tRemise/100;
			totalBase = montantBase + fraisPort - mRemise;
			
			if (editionTTC) {
				totalTVA = totalTVA + fraisPort * (tauxTvaPort/100) / (tauxTvaPort/100+1);
			}
			else {
				totalTVA = totalTVA + fraisPort * tauxTvaPort/100;
			}		
			
			montantTTC = (editionTTC?totalBase:totalBase + totalTVA);
			mEscompte = r.round(montantTTC * tEscompte/100);
			netAPayer = montantTTC - mEscompte - acompte;
			
			
			rset.close();
			stt.close();			
			s.closeConnection(con, null);
			
		} catch(Exception e) {
			e.printStackTrace();
		}	
	}
	
	
	
	public double calcSousTotal(int derniereLigne) {
	
		if (derniereLigne<0) 
			return 0;
		else {
			return lignes.get(derniereLigne).sousTotal;
		}		
	}	
	
	
	public int getNbLignes() {
		return lignes.size();
	}
	
	
	public int getNbEx() {	
		return nbex;
	}
	
	
	public String formatSiren(String siret) {
		if (siret.length()>=9) {
			return siret.substring(0,3) +" "+ siret.substring(3,6) +" "+ siret.substring(6,9);
		}
		else {
			return siret;
		}
	}
	
	
} // fin DataProforma
