/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 * Donnes ncessaires  l'dition d'un proforma standard
 */

package org.opensi.facturation.actions.documents.modeles;


import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;

import org.experlog.openeas.api.Session;
import org.opensi.util.tools.DateTime;

public class DataSuiviLot {	


	// coordonnes socit mettrice

	protected String raisonSociale;
	protected String adresse;
	protected String compAdresse;
	protected String codePostal;
	protected String ville;
	protected String tel;
	protected String fax;
	protected String email;
	protected String web;
	
	protected double capital;
	protected String typeSociete;
	protected String tvaIntra;
	protected String rcs;
	protected String siren;
	protected boolean logoAdr;
	protected String urlLogo = "";
	
	protected String numLot;
	protected String refArticle = "";
	protected String designationArticle = "";
	protected boolean nbPieces = false;
	
	protected ArrayList<LigneSuiviLot> lignes = new ArrayList<LigneSuiviLot>(10);
	
	
	public DataSuiviLot(Session s, String numLot) {	
		try {
		
			Connection con = s.getConnection(null);
			Statement stt = con.createStatement();
			
			String dossierId = s.getCookie().get("Dossier_Id");
			String base = s.getCookie().get("BaseDossier");
			this.urlLogo = s.getAppConfiguration().get("opensi.absdir") +"/logos/"+ dossierId +".jpg";
			this.numLot = numLot;
			
			
			// Paramtres dossier
		      
			String reqCom = "select Logo_Adr from PARAM_DOSSIER where Dossier_Id='"+ dossierId +"'";
			ResultSet rset = stt.executeQuery(reqCom);			
			rset.next();
			
			logoAdr = rset.getInt("Logo_Adr")==1;			
			
			rset.close();			
      
			// coordonnes de l'entreprise facturante
      
			String reqFacturante = "select Ville_RCS, Num_TVA_Intra, Type_Societe, Montant_Capital, Num_SIRET, Raison_Sociale, Adresse, Comp_Adresse, Code_Postal, Ville, Telephone, Fax, Email, Site_Web from DOSSIER where Dossier_Id='"+ dossierId +"'";
			rset = stt.executeQuery(reqFacturante);			
			rset.next();			
			this.raisonSociale = rset.getString("Raison_Sociale");
			this.adresse = rset.getString("Adresse");
			this.compAdresse = rset.getString("Comp_Adresse");
			this.codePostal = rset.getString("Code_Postal");
			this.ville = rset.getString("Ville");
			this.tel = rset.getString("Telephone");
			this.fax = rset.getString("Fax");
			this.email = rset.getString("Email");
			this.web = rset.getString("Site_Web");			
			this.siren = formatSiren(rset.getString("Num_SIRET"));
			this.typeSociete = rset.getString("Type_Societe");
			this.capital = rset.getDouble("Montant_Capital");
			this.tvaIntra = rset.getString("Num_TVA_Intra");
			this.rcs = rset.getString("Ville_RCS");			
			rset.close();
			
			// Recherche rf article et dsignation pour le num lot
			
			String reqRef = "select Reference, Designation from";
			reqRef += " (select ac.Reference, ac.Designation";
			reqRef += " from "+ base +".BON_LIVRAISON bl, "+ base +".ARTICLE_BON_LIVRAISON abl, "+ base +".ARTICLE_COM_CLIENT ac";
			reqRef += " where bl.Etat='V' and bl.Bon_Id=abl.Bon_Id and abl.Num_Lot='"+ this.numLot +"' and abl.Ref_Ligne=ac.Ligne_Id";
			reqRef += " union";
			reqRef += " select acw.Article_Id as Reference, acw.Designation";
			reqRef += " from "+ base +".BON_LIVRAISON bl, "+ base +".ARTICLE_BON_LIVRAISON abl, "+ base +".ARTICLE_COMMANDE_WEB acw";
			reqRef += " where bl.Etat='V' and bl.Bon_Id=abl.Bon_Id and abl.Num_Lot='"+ this.numLot +"' and abl.Ref_Ligne=acw.Detail_Id";
			reqRef += " union";
			reqRef += " select af.Reference, af.Designation";
			reqRef += " from "+ base +".FACTURE f, "+ base +".ARTICLE_FACTURE af";
			reqRef += " where f.Facture_Id=af.Facture_Id and af.Num_Lot='"+ this.numLot +"' and f.Directe=1 and f.Numero>0";
			reqRef += " union";
			reqRef += " select ac.Reference, ac.Designation";
			reqRef += " from "+ base +".BON_RECEPTION br, "+ base +".ARTICLE_BON_RECEPTION abr, "+ base +".ARTICLE_COMMANDE ac";
			reqRef += " where br.Etat='V' and br.BR_Id=abr.BR_Id and abr.Num_Lot='"+ this.numLot +"' and abr.Ref_Ligne=ac.Ligne_Id) t limit 1";
			rset = stt.executeQuery(reqRef);
			if (rset.next()) {
				this.refArticle = rset.getString("Reference");
				this.designationArticle = rset.getString("Designation");
			}
			
			// Infos des BL
			String reqBL = "select Nom_Liv, Adresse_Liv, Comp_Adresse_Liv, Adresse_3_Liv, CP_Liv, Ville_Liv, Code_Pays_Liv, sum(Quantite) as Qte_Livree, sum(Nb_Pieces) as Nb_Pieces, Civ_Courte, Nom_Inter_Liv, Prenom_Inter_Liv, Tel_Inter_Liv, Date_Liv as Date_Livraison from";
			reqBL += " (select bl.Nom_Liv, bl.Adresse_Liv, bl.Comp_Adresse_Liv, bl.Adresse_3_Liv, bl.CP_Liv, bl.Ville_Liv, bl.Code_Pays_Liv, abl.Quantite, abl.Nb_Pieces, c.Civ_Courte, bl.Nom_Inter_Liv, bl.Prenom_Inter_Liv, bl.Tel_Inter_Liv, bl.Date_Liv";
			reqBL += " from "+ base +".BON_LIVRAISON bl, "+ base +".ARTICLE_BON_LIVRAISON abl, CIVILITE c";
			reqBL += " where bl.Etat='V' and bl.Bon_Id=abl.Bon_Id and bl.Civ_Inter_Liv=c.Civ_Id and abl.Num_Lot='"+ numLot +"'";
			reqBL += " union all";
			reqBL += " select f.Denomination_Liv as Nom_Liv, f.Adresse_1_Liv as Adresse_Liv, f.Adresse_2_Liv as Comp_Adresse_Liv, f.Adresse_3_Liv, f.Code_Postal_Liv as CP_Liv, f.Ville_Liv, f.Code_Pays_Liv, af.Quantite, af.Nb_Pieces, c.Civ_Courte, f.Nom_Inter_Liv, f.Prenom_Inter_Liv, f.Tel_Inter_Liv, f.Date_Facture as Date_Liv";
			reqBL += " from "+ base +".FACTURE f, "+ base +".ARTICLE_FACTURE af, CIVILITE c";
			reqBL += " where f.Facture_Id=af.Facture_Id and f.Civ_Inter_Liv=c.Civ_Id and af.Num_Lot='"+ numLot +"' and f.Directe=1 and f.Numero>0) t";
			reqBL += " group by Nom_Liv, Adresse_Liv, Comp_Adresse_Liv, Adresse_3_Liv, CP_Liv, Ville_Liv, Code_Pays_Liv, Civ_Courte, Nom_Inter_Liv, Prenom_Inter_Liv, Tel_Inter_Liv, Date_Livraison";
			rset = stt.executeQuery(reqBL);
			
			while (rset.next()) {
				LigneSuiviLot ls = new LigneSuiviLot();
				
				String dateLivraison = DateTime.formatTime(rset.getLong("Date_Livraison"),"dd/MM/yyyy");
				
				ls.setType("BL");
				ls.setDenomination(rset.getString("Nom_Liv"));
				ls.setAdresse1(rset.getString("Adresse_Liv"));
				ls.setAdresse2(rset.getString("Comp_Adresse_Liv"));
				ls.setAdresse3(rset.getString("Adresse_3_Liv"));
				ls.setCodePostal(rset.getString("CP_Liv"));
				ls.setVille(rset.getString("Ville_Liv"));
				ls.setCodePays(rset.getString("Code_Pays_Liv"));
				ls.setInterlocuteur(rset.getString("Civ_Courte") + " " + rset.getString("Nom_Inter_Liv").toUpperCase() + " " + rset.getString("Prenom_Inter_Liv"));
				ls.setTelInter(rset.getString("Tel_Inter_Liv"));
				ls.setDate(dateLivraison);
				ls.setQte(rset.getDouble("Qte_Livree"));
				ls.setNbPieces(rset.getInt("Nb_Pieces"));
				
				if (ls.nbPieces != 0) { this.nbPieces = true; }
				
				this.lignes.add(ls);
			}
			rset.close();
			
			// Infos des BR			
			String reqBR = "select c.Raison_Sociale, c.Adresse, c.Comp_Adresse, c.Adresse_3, c.Code_Postal, c.Ville, c.Code_Pays, br.Date_BR as Date_Reception, sum(abr.Quantite) as Qte_Recep, sum(abr.Nb_Pieces) as Nb_Pieces";
			reqBR += " from "+ base +".BON_RECEPTION br, "+ base +".ARTICLE_BON_RECEPTION abr, "+ base +".COMMANDE c";
			reqBR += " where c.Commande_Id=br.Commande_Id and br.Etat='V' and br.BR_Id=abr.BR_Id and abr.Num_Lot='"+ numLot +"'";
			reqBR += " group by c.Raison_Sociale, c.Adresse, c.Comp_Adresse, c.Adresse_3, c.Code_Postal, c.Ville, c.Code_Pays, Date_Reception";
			rset = stt.executeQuery(reqBR);
			while (rset.next()) {
				LigneSuiviLot ls = new LigneSuiviLot();
				
				String dateReception = DateTime.formatTime(rset.getLong("Date_Reception"),"dd/MM/yyyy");
				
				ls.setType("BR");
				ls.setDenomination(rset.getString("Raison_Sociale"));
				ls.setAdresse1(rset.getString("Adresse"));
				ls.setAdresse2(rset.getString("Comp_Adresse"));
				ls.setAdresse3(rset.getString("Adresse_3"));
				ls.setCodePostal(rset.getString("Code_Postal"));
				ls.setVille(rset.getString("Ville"));
				ls.setCodePays(rset.getString("Code_Pays"));
				ls.setDate(dateReception);
				ls.setQte(rset.getDouble("Qte_Recep"));
				ls.setNbPieces(rset.getInt("Nb_Pieces"));
				
				if (ls.nbPieces != 0) { this.nbPieces = true; }
				
				this.lignes.add(ls);
			}
			rset.close();
			
			stt.close();			
			s.closeConnection(con, null);
			
		} catch(Exception e) {
			e.printStackTrace();
		}	
	}	
	
	public String formatSiren(String siret) {
		if (siret.length()>=9) {
			return siret.substring(0,3) +" "+ siret.substring(3,6) +" "+ siret.substring(6,9);
		}
		else {
			return siret;
		}
	}
	
	public int getNbLignes() {
		return lignes.size();
	}
	
	
} // fin DataSuiviLot
