/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 * Donnes ncessaires  l'dition d'un journal des ventes standard
 */

package org.opensi.facturation.actions.editions;


import java.sql.*;

import java.util.*;

import org.experlog.openeas.api.Session;

import org.opensi.util.tools.Arrondi;

import org.opensi.facturation.actions.editions.VentilTVA;



public class DataJournalVentes {


	// les lignes du journal
	protected ArrayList<LigneJournal> lignes = new ArrayList<LigneJournal>(10);
	
	// les lignes de dtail
	protected ArrayList<LigneDetailCompte> details = new ArrayList<LigneDetailCompte>(10);
	
	// ventilation des tvas
	protected LinkedHashMap<Double, VentilTVA> vtvasF = new LinkedHashMap<Double, VentilTVA>(2); // ventilation des tvas sur factures
	protected LinkedHashMap<Double, VentilTVA> vtvasA = new LinkedHashMap<Double, VentilTVA>(2); // ventilation des tvas sur avoirs
	protected LinkedHashMap<Double, VentilTVA> vtvasN = new LinkedHashMap<Double, VentilTVA>(2); // ventilation des tvas sur avoirs et factures cumuls

	// ventilation comptable des comptes clients
	protected TreeMap<String, LigneDetailCompte> hmVCC = new TreeMap<String, LigneDetailCompte>(new HashMap<String, LigneDetailCompte>(10));
	
	
	// entte

	protected String dossierId;
	protected String raisonSociale;
	protected String adresse;
	protected String compAdresse;
	protected String codePostal;
	protected String ville;
	protected String monnaie;
	
	protected long dateCourante = System.currentTimeMillis();
	protected long dateDebut;
	protected long dateFin;
	
	
	// informations totaux
	
	protected int nbFactures = 0;
	protected int nbAvoirs = 0;
	
	protected double montantATVA = 0;
	protected double montantFTVA = 0;
	protected double montantNTVA = 0;
	
	protected double montantAHT = 0;
	protected double montantFHT = 0;
	protected double montantNHT = 0;
	
	protected double montantATTC = 0;
	protected double montantFTTC = 0;
	protected double montantNTTC = 0;
	
		
	private Arrondi r = new Arrondi(2);
	
	
	
	public DataJournalVentes(Session s, long dateDebut, long dateFin) {	
		try {
		
			Connection con = s.getConnection(null);
			Statement stt = con.createStatement();
      
			String base = s.getCookie().get("BaseDossier");
			dossierId = s.getCookie().get("Dossier_Id");
      
			ResultSet rset;
			
			this.dateDebut = dateDebut;
			this.dateFin = dateFin;
			
      
			// coordonnes de l'entreprise facturante
      
      String reqDossier = "select Raison_Sociale, Adresse, Comp_Adresse, Code_Postal, Ville, Monnaie_Tenue from DOSSIER where Dossier_Id='"+ dossierId +"'";
			
			rset = stt.executeQuery(reqDossier);
			
			rset.next();
			
			this.raisonSociale = rset.getString("Raison_Sociale");
			this.adresse = rset.getString("Adresse");
			this.compAdresse = rset.getString("Comp_Adresse");
			this.codePostal = rset.getString("Code_Postal");
			this.ville = rset.getString("Ville");
			this.monnaie = rset.getString("Monnaie_Tenue");
			
			rset.close();

		  // taux de tva sur frais de port
			ResultSet rsTTP = stt.executeQuery("select Taux_TVA from "+ base +".TAUX_TVA where Code_TVA=4");
			rsTTP.next();
			double tauxTvaPort = rsTTP.getDouble("Taux_TVA");
			rsTTP.close();
		
		
			
			// ventilation des TVA sur factures
				
			/*String reqVTvasF = " select a.Taux_TVA, sum(a.Prix * a.Quantite * (1-a.Ristourne/100) * (1-f.Remise/100)) + if(a.Taux_TVA=Taux_TVA_Port, Frais_Port, 0) as Base_Montant, f.Escompte, f.Edition_TTC, f.Facture_Id"
										 	+" from "+ base +".FACTURE f,"+ base +".ARTICLE_FACTURE a, "+ base +".TAUX_TVA t"
										 	+" where f.Facture_Id=a.Facture_Id and a.Code_TVA=t.Code_TVA and (a.Taux_TVA>0 or t.Code_TVA=1)and f.Numero<>0 and f.Date_Facture>="+ dateDebut +" and f.Date_Facture<="+ dateFin
											+" group by f.Facture_Id, a.Taux_TVA order by a.Taux_TVA";*/
											
			
			String reqVTvasF = " select Taux_TVA, sum(Base_Montant) as Base_Montant, Escompte, Edition_TTC, Facture_Id from"
											+" ((select coalesce(a.Taux_TVA,0) as Taux_TVA, coalesce(sum(a.Prix * a.Quantite * (1-a.Ristourne/100) * (1-f.Remise/100)),0) as Base_Montant, f.Escompte, f.Edition_TTC, f.Facture_Id"
											+" from "+ base +".FACTURE f left join "+ base +".ARTICLE_FACTURE a on f.Facture_Id=a.Facture_Id, "+ base +".TAUX_TVA t"
											+" where a.Code_TVA=t.Code_TVA and (a.Taux_TVA>0 or t.Code_TVA=1)and f.Numero<>0"
											+" and f.Date_Facture>="+ dateDebut +" and f.Date_Facture<="+ dateFin
											+" group by f.Facture_Id, a.Taux_TVA order by a.Taux_TVA)"
											+" union"
											+" (select Taux_TVA_Port as Taux_TVA, Frais_Port as Base_Montant, Escompte, Edition_TTC, Facture_Id from "+ base +".FACTURE"
											+" where Numero<>0 and Date_Facture>="+ dateDebut +" and Date_Facture<="+ dateFin +"))"
											+" as P"
											+" group by Facture_Id, Taux_TVA order by Taux_TVA";
			
			
			rset = stt.executeQuery(reqVTvasF);
			
			while (rset.next()) {
			
				double tauxTVA = rset.getDouble("Taux_TVA");
				boolean editionTTC = (rset.getInt("Edition_TTC")==1);
				double baseMontant = rset.getDouble("Base_Montant");
				double tauxEscompte = rset.getDouble("Escompte");
				
				VentilTVA vtvaF = vtvasF.get(new Double(tauxTVA));
				
				if (vtvaF==null) {
					vtvasF.put(new Double(tauxTVA), new VentilTVA(tauxTVA, baseMontant, editionTTC, tauxEscompte));
					vtvasN.put(new Double(tauxTVA), new VentilTVA(tauxTVA, baseMontant, editionTTC, tauxEscompte));
				}
				else {
					VentilTVA vtvaN = vtvasN.get(new Double(tauxTVA));
				
					vtvaF.add(baseMontant, editionTTC, tauxEscompte);
					vtvaN.add(baseMontant, editionTTC, tauxEscompte);
				}	
			}
			
			rset.close();
			
			
			
			
			// ajout de la tva sur frais de port
			
			/*String reqTvaPort = " select Taux_TVA_Port, Edition_TTC, Frais_Port as Base_Montant from "+ base +".FACTURE where Numero<>0 and Date_Facture>="+ dateDebut +" and Date_Facture<="+ dateFin;
											
			rset = stt.executeQuery(reqTvaPort);
			
			while (rset.next()) {
			
				double tauxTVA = rset.getDouble("Taux_TVA_Port");
				boolean editionTTC = (rset.getInt("Edition_TTC")==1);
				double baseMontant = rset.getDouble("Base_Montant");
				
				VentilTVA vtvaF = vtvasF.get(new Double(tauxTVA));
				
				if (vtvaF==null) {
					vtvasF.put(new Double(tauxTVA), new VentilTVA(tauxTVA, baseMontant, editionTTC));
					vtvasN.put(new Double(tauxTVA), new VentilTVA(tauxTVA, baseMontant, editionTTC));
				}
				else {
					VentilTVA vtvaN = vtvasN.get(new Double(tauxTVA));
				
					vtvaF.add(baseMontant, editionTTC);
					vtvaN.add(baseMontant, editionTTC);
				}				
			}
			
			rset.close();*/
			
			
			
			// ventilation des TVA sur avoirs
				
			/*String reqVTvasA = " select a.Taux_TVA, sum(a.Prix * a.Quantite * (1-a.Ristourne/100) * (1-f.Remise/100)) + if(a.Taux_TVA=Taux_TVA_Port, Frais_Port, 0) as Base_Montant,f.Escompte, f.Edition_TTC, f.Avoir_Id"
										 	+" from "+ base +".AVOIR f,"+ base +".ARTICLE_AVOIR a, "+ base +".TAUX_TVA t"
										 	+" where f.Avoir_Id=a.Avoir_Id and a.Code_TVA=t.Code_TVA and (a.Taux_TVA>0 or t.Code_TVA=1) and f.Numero<>0 and f.Date_Avoir>="+ dateDebut +" and f.Date_Avoir<="+ dateFin
											+" group by f.Avoir_Id, a.Taux_TVA order by a.Taux_TVA";*/
											
											
			String reqVTvasA = " select Taux_TVA, sum(Base_Montant) as Base_Montant, Escompte, Edition_TTC, Avoir_Id from"
											+" ((select coalesce(a.Taux_TVA,0) as Taux_TVA, coalesce(sum(a.Prix * a.Quantite * (1-a.Ristourne/100) * (1-f.Remise/100)),0) as Base_Montant, f.Escompte, f.Edition_TTC, f.Avoir_Id"
											+" from "+ base +".AVOIR f left join "+ base +".ARTICLE_AVOIR a on f.Avoir_Id=a.Avoir_Id, "+ base +".TAUX_TVA t"
											+" where a.Code_TVA=t.Code_TVA and (a.Taux_TVA>0 or t.Code_TVA=1)and f.Numero<>0"
											+" and f.Date_Avoir>="+ dateDebut +" and f.Date_Avoir<="+ dateFin
											+" group by f.Avoir_Id, a.Taux_TVA order by a.Taux_TVA)"
											+" union"
											+" (select Taux_TVA_Port as Taux_TVA, Frais_Port as Base_Montant, Escompte, Edition_TTC, Avoir_Id from "+ base +".AVOIR"
											+" where Numero<>0 and Date_Avoir>="+ dateDebut +" and Date_Avoir<="+ dateFin +"))"
											+" as P"
											+" group by Avoir_Id, Taux_TVA order by Taux_TVA";
			
			rset = stt.executeQuery(reqVTvasA);
			
			while (rset.next()) {
			
				double tauxTVA = rset.getDouble("Taux_TVA");
				boolean editionTTC = (rset.getInt("Edition_TTC")==1);
				double baseMontant = rset.getDouble("Base_Montant");
				double tauxEscompte = rset.getDouble("Escompte");
				
				VentilTVA vtvaA = vtvasA.get(new Double(tauxTVA));
				
				if (vtvaA==null) {
					vtvasA.put(new Double(tauxTVA), new VentilTVA(tauxTVA, baseMontant, editionTTC, tauxEscompte));
				}
				else {
					vtvaA.add(baseMontant, editionTTC);
				}
				
				VentilTVA vtvaN = vtvasN.get(new Double(tauxTVA));
				
				if (vtvaN==null) {
					vtvasN.put(new Double(tauxTVA), new VentilTVA(tauxTVA, -baseMontant, editionTTC, tauxEscompte));
				}
				else {
					vtvaN.add(-baseMontant, editionTTC);
				}
			}
			
			rset.close();
			
			
			
			// ajout de la tva sur frais de port de l'avoir
			
		/*	String reqTvaPortAvoir = " select Taux_TVA_Port, Edition_TTC, Frais_Port as Base_Montant from "+ base +".AVOIR where Numero<>0 and Date_Avoir>="+ dateDebut +" and Date_Avoir<="+ dateFin;
											
			rset = stt.executeQuery(reqTvaPortAvoir);
			
			while (rset.next()) {
			
				double tauxTVA = rset.getDouble("Taux_TVA_Port");
				boolean editionTTC = (rset.getInt("Edition_TTC")==1);
				double baseMontant = rset.getDouble("Base_Montant");
				
				VentilTVA vtvaA = vtvasA.get(new Double(tauxTVA));
				
				if (vtvaA==null) {
					vtvasA.put(new Double(tauxTVA), new VentilTVA(tauxTVA, baseMontant, editionTTC));
					vtvasN.put(new Double(tauxTVA), new VentilTVA(tauxTVA, -baseMontant, editionTTC));
				}
				else {
					VentilTVA vtvaN = vtvasN.get(new Double(tauxTVA));
				
					vtvaA.add(baseMontant, editionTTC);
					vtvaN.add(-baseMontant, editionTTC);
				}				
			}
			
			rset.close();*/

			
			
			// TVA NPR
			
	/*		String reqTvaNpr = "select t.Taux_NPR, sum(a.Prix * a.Quantite * (1-a.Ristourne/100)) as Base_Montant "
											+ "from "+ base +".ARTICLE_FACTURE a, "+ base +".TAUX_TVA t where Devis_Id="+ devisId +" and t.Code_TVA=a.Code_TVA and t.Taux_NPR>0 group by t.Code_TVA order by t.Taux_NPR";
			
			rset = stt.executeQuery(reqTvaNpr);
			
			while (rset.next()) {
				VentilTVA vtva = new VentilTVA(rset.getDouble("Base_Montant") * (1-tRemise/100), rset.getDouble("Taux_NPR"));
				vtva.setNPR(true);
				vtvas.add(vtva);				
			}*/
				
 
 			
			Iterator li = vtvasN.keySet().iterator();

			while (li.hasNext()) {
		
				VentilTVA vtva = vtvasN.get((Double) li.next());
				
				this.montantNTVA += vtva.montantTVA;
				this.montantNHT += vtva.montantHT;
				this.montantNTTC += vtva.montantTTC;
			}
			li = vtvasF.keySet().iterator();

			while (li.hasNext()) {
		
				VentilTVA vtva = vtvasF.get((Double) li.next());
				
				this.montantFTVA += vtva.montantTVA;
				this.montantFHT += vtva.montantHT;
				this.montantFTTC += vtva.montantTTC;
			}
			
			li = vtvasA.keySet().iterator();

			while (li.hasNext()) {
		
				VentilTVA vtva = vtvasA.get((Double) li.next());
				
				this.montantATVA += vtva.montantTVA;
				this.montantAHT += vtva.montantHT;
				this.montantATTC += vtva.montantTTC;
			}
			
			
			// Compte clients divers
			
			String reqClientsDivers = "select Numero_Compte_Clients from PARAM_DOSSIER where Dossier_Id='"+ dossierId +"'";
			
			rset = stt.executeQuery(reqClientsDivers);
			
			rset.next();
			
			String clientsDivers = rset.getString("Numero_Compte_Clients");
			
			
			
			
			// Calcul des lignes du journal des ventes
			
			String reqFactures = "select 'F', f.Num_Entier as Num_Piece, f.Numero, f.Date_Facture as Date_Doc, f.Client_Id, f.Raison_Sociale, coalesce(fc.Numero_Compte, '"+ clientsDivers +"') as Numero_Compte, "
														+" f.Total_HT as Montant_HT, f.Montant_TTC * (1-f.Escompte/100) as Montant_TTC, f.Montant_TTC - f.Total_HT as Montant_TVA "
														+" from "+ base +".FACTURE f left join "+ base +".FICHE_CLIENT fc on fc.Client_Id=f.Client_Id"
														+" where f.Numero<>0 and Date_Facture>="+ dateDebut +" and Date_Facture<="+ dateFin
														+" union "
														+" select 'A', a.Num_Entier as Num_Piece, a.Numero, a.Date_Avoir as Date_Doc, a.Client_Id, a.Raison_Sociale, coalesce(fc.Numero_Compte, '"+ clientsDivers +"') as Numero_Compte, "
														+" -a.Total_HT as Montant_HT,-(a.Montant_TTC * (1-a.Escompte/100)) as Montant_TTC, -(a.Montant_TTC - a.Total_HT) as Montant_TVA "
														+" from "+ base +".AVOIR a left join "+ base +".FICHE_CLIENT fc on fc.Client_Id=a.Client_Id"
														+" where a.Numero<>0 and Date_Avoir>="+ dateDebut +" and Date_Avoir<="+ dateFin
														+" order by Date_Doc, Numero";
														
														
														
					
			rset = stt.executeQuery(reqFactures);
			
			double sousTotal = 0;			
			
			while(rset.next()) {
			
				LigneJournal lj = new LigneJournal();

				String typeDoc = rset.getString(1);

				lj.setDatePiece(rset.getLong("Date_Doc"));
				lj.setNumPiece(rset.getString("Num_Piece"));
				lj.setTiers(rset.getString("Raison_Sociale"));
				lj.setNumTiers(rset.getString("Client_Id"));
				lj.setNumCompte(rset.getString("Numero_Compte"));
				lj.setMontantHT(rset.getDouble("Montant_HT"));
				lj.setMontantTVA(rset.getDouble("Montant_TVA"));
				lj.setMontantTTC(rset.getDouble("Montant_TTC"));
				
				if (typeDoc.equals("F")) {
					nbFactures++;
					sousTotal += lj.montantTTC;
				} 
				else {
					nbAvoirs++;
					sousTotal += lj.montantTTC;
				}
				
				lj.setTotalProgressif(sousTotal);
				
				lignes.add(lj);
				
				LigneDetailCompte ldc = hmVCC.get(lj.numCompte);
				
				if (ldc==null) {
					hmVCC.put(lj.numCompte, new LigneDetailCompte(lj.numCompte, lj.tiers, lj.montantHT, lj.montantTTC));
				}
				else {
					ldc.add(lj.montantHT, lj.montantTTC);
				}
			}
			
			rset.close();	
			
			
			details = new ArrayList<LigneDetailCompte>(hmVCC.values());
			
			
			stt.close();			
			s.closeConnection(con, null);
			
		} catch(Exception e) {
			e.printStackTrace();
		}	
	}	
	
	
	public int getNbLignes() {
		return lignes.size();
	}	
	
	public int getNbLignesDetails() {
		return details.size();
	}	

} // fin DataJournalVentes
