/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 * Donnes ncessaires  l'dition d'une liste de clients
 */

package org.opensi.facturation.actions.editions;

import org.experlog.openeas.api.Session;
import java.text.SimpleDateFormat;
import java.sql.Connection;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.Date;
import java.util.ArrayList;

public class DataListeClients {

	// les lignes de la liste des clients
	protected ArrayList<LigneListeClients> lignes = new ArrayList<LigneListeClients>(10);
	
	protected String dossierId;
	protected String raisonSociale;
	protected String adresse;
	protected String compAdresse;
	protected String codePostal;
	protected String ville;
	protected String monnaie;
	protected String familleClient;
	protected String commercial;
	protected String tri1;
	protected String tri2;
	protected String tri3;
	protected String tarifsSpe;
	protected String dateCourante;
	protected String clientsDe = "";
	protected String criteres = "";
	protected boolean useCodeTarif;
	
	public DataListeClients(Session s, String familleClient, String commercial, String tri1, String tri2, String tri3, String tarifsSpe) {

		try {
			Connection con = s.getConnection(null);
			Statement stt = con.createStatement();
			
			String base = s.getCookie().get("BaseDossier");
			this.dossierId = s.getCookie().get("Dossier_Id");
			this.familleClient = familleClient;
			this.commercial = commercial;
			this.tri1 = tri1;
			this.tri2 = tri2;
			this.tri3 = tri3;
			this.tarifsSpe = tarifsSpe;
			
			SimpleDateFormat formatDate = new SimpleDateFormat("dd/MM/yyyy");
			this.dateCourante = formatDate.format(new Date(System.currentTimeMillis()));
			
			String reqLeDossier = "select d.Raison_Sociale, d.Adresse, d.Comp_Adresse, d.Code_Postal, d.Ville, d.Monnaie_Tenue, pd.Mode_Tarif from DOSSIER d, PARAM_DOSSIER pd where d.Dossier_Id='"+ dossierId+ "' and d.Dossier_Id=pd.Dossier_Id";
			ResultSet rset = stt.executeQuery(reqLeDossier);
			rset.next();
			this.raisonSociale = rset.getString("Raison_Sociale");
			this.adresse = rset.getString("Adresse");
			this.compAdresse = rset.getString("Comp_Adresse");
			this.codePostal = rset.getString("Code_Postal");
			this.ville = rset.getString("Ville");
			this.monnaie = rset.getString("Monnaie_Tenue");
			this.useCodeTarif = (rset.getString("Mode_Tarif").equals("G"));
			rset.close();
			
			String reqClients = "select Client_Id, Raison_Sociale, Adresse, Code_Postal, Ville, Tel_1, Famille, Code_Tarif from "+ base +".FICHE_CLIENT where Supprime=0";

			if (!familleClient.equals("")) {
				reqClients += " and Famille='"+ s.sqlEncode(familleClient) +"'";
				criteres += "Famille : "+ familleClient;
			}

			if (!commercial.equals("")) {
				reqClients += " and Util_R="+ Integer.parseInt(commercial);
				Statement sttCom = con.createStatement();
				ResultSet rsCom = sttCom.executeQuery("select Prenom, Nom from UTILISATEUR where Utilisateur_Id="+ Integer.parseInt(commercial));
				if (rsCom.next()) {
					clientsDe = " de "+ rsCom.getString("Prenom") +" "+ rsCom.getString("Nom");
				}
				sttCom.close();
			}

			if (tarifsSpe.equals("1")) {
				reqClients += " and Client_Id in (select distinct Client_Id from "+ base +".CLIENT_ARTICLE)";
				criteres += (!criteres.equals("")?" - ":"") +"Clients ayant des tarifs sp\u00E9cifiques";
			}

			reqClients += " order by "+ tri1;

			if (tri2.length()>0) reqClients += ","+ tri2;
			if (tri3.length()>0) reqClients += ","+ tri3;
			
			rset = stt.executeQuery(reqClients);

			while (rset.next()) {
				LigneListeClients llc = new LigneListeClients();

				llc.setFamille(rset.getString("Famille"));
				llc.setNumero(rset.getString("Client_Id"));
				llc.setClient(rset.getString("Raison_Sociale"));
				llc.setAdresse(rset.getString("Adresse"));
				llc.setCp(rset.getString("Code_Postal"));
				llc.setVille(rset.getString("Ville"));
				llc.setTel(rset.getString("Tel_1"));
				llc.setCodeTarif(rset.getInt("Code_Tarif"));

				lignes.add(llc);
			}
			
			rset.close();
			stt.close();
			s.closeConnection(con, null);
		}
		catch(Exception e) {
			e.printStackTrace();
		}			
	}
	
	public int getNbLignes() {
		return lignes.size();
	}


} // fin DataListeClients
