/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 * Donnes ncessaires  l'dition d'une liste de fournisseurs
 */

package org.opensi.facturation.actions.editions;

import org.experlog.openeas.api.Session;
import java.text.SimpleDateFormat;
import java.sql.Connection;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.Date;
import java.util.ArrayList;

public class DataListeFournisseurs {

	// les lignes de la liste des fournisseurs
	protected ArrayList<LigneListeFournisseurs> lignes = new ArrayList<LigneListeFournisseurs>(10);
	
	protected String dossierId;
	protected String raisonSociale;
	protected String adresse;
	protected String compAdresse;
	protected String codePostal;
	protected String ville;
	protected String dateCourante;
	protected String familleFournisseur;
	protected String tri1;
	protected String tri2;
	protected String tri3;
	protected String criteres = "";
	
	public DataListeFournisseurs(Session s, String familleFournisseur, String tri1, String tri2, String tri3) {

		try {
			Connection con = s.getConnection(null);
			Statement stt = con.createStatement();
			
			String base = s.getCookie().get("BaseDossier");
			this.dossierId = s.getCookie().get("Dossier_Id");
			
			this.familleFournisseur = familleFournisseur;
			this.tri1 = tri1;
			this.tri2 = tri2;
			this. tri3 = tri3;
			
			SimpleDateFormat formatDate = new SimpleDateFormat("dd/MM/yyyy");
			this.dateCourante = formatDate.format(new Date(System.currentTimeMillis()));
			
			String reqLeDossier = "select * from DOSSIER where Dossier_Id='"+ dossierId+ "'";
			
			ResultSet rset = stt.executeQuery(reqLeDossier);

			rset.next();

			this.raisonSociale = rset.getString("Raison_Sociale");
			this.adresse = rset.getString("Adresse");
			this.compAdresse = rset.getString("Comp_Adresse");
			this.codePostal = rset.getString("Code_Postal");
			this.ville = rset.getString("Ville");

			rset.close();
			
			String reqFournisseurs = "select Famille, Fournisseur_Id, Raison_Sociale, Adresse, Code_Postal, Ville, Tel_1 from "+ base +".FICHE_FOURNISSEUR where Supprime=0";

			if (!familleFournisseur.equals("")) {
				reqFournisseurs += " and Famille='"+ s.sqlEncode(familleFournisseur) +"'";
				criteres += "Famille : "+ familleFournisseur;
			}
			
			reqFournisseurs += " order by "+ tri1;

			if (tri2.length()>0) reqFournisseurs += ","+ tri2;
			if (tri3.length()>0) reqFournisseurs += ","+ tri3;
			
			rset = stt.executeQuery(reqFournisseurs);

			while (rset.next()) {
				LigneListeFournisseurs llf = new LigneListeFournisseurs();

				llf.setFamille(rset.getString("Famille"));
				llf.setNumero(rset.getString("Fournisseur_Id"));
				llf.setFournisseur(rset.getString("Raison_Sociale"));
				llf.setAdresse(rset.getString("Adresse"));
				llf.setCp(rset.getString("Code_Postal"));
				llf.setVille(rset.getString("Ville"));
				llf.setTel(rset.getString("Tel_1"));

				lignes.add(llf);
			}			
			
			rset.close();
			stt.close();
			s.closeConnection(con, null);
		}
		catch(Exception e) {
			e.printStackTrace();
		}			
	}
	
	public int getNbLignes() {
		return lignes.size();
	}


} // fin DataListeFournisseurs
