/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 * Donnes ncessaires  l'dition d'un palmars client
 */

package org.opensi.facturation.actions.editions;

import org.experlog.openeas.api.Session;
import java.text.SimpleDateFormat;
import java.sql.Connection;
import java.sql.Statement;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Date;
import java.util.ArrayList;


public class DataPalmaresClient {
	
	// les lignes du palmars client
	protected ArrayList<LignePalmaresClient> lignes = new ArrayList<LignePalmaresClient>(10);
	
	protected String dossierId;
	protected String raisonSociale;
	protected String adresse;
	protected String compAdresse;
	protected String codePostal;
	protected String ville;
	protected String monnaie;

	String familleClient;
	String commercial;
	String typeDetail;
	String tarifsSpe;
	protected String finPeriodeStr;
	protected String debutPeriodeStr;
	protected String dateCourante;
	protected String criteres = "";
	protected boolean detail;
	protected String titreDetail;
	protected String titreDetailCsv;
		
	
	public DataPalmaresClient(Session s, long debutPeriode, long finPeriode, String familleClient, String commercial, String typeDetail, String tarifsSpe) {
		
		try {
			Connection con = s.getConnection(null);
			Statement stt = con.createStatement();

			this.dossierId = s.getCookie().get("Dossier_Id");;
			String base = s.getCookie().get("BaseDossier");
			
			SimpleDateFormat formatDate = new SimpleDateFormat("dd/MM/yyyy");
			this.dateCourante = formatDate.format(new Date(System.currentTimeMillis()));
			this.finPeriodeStr = formatDate.format(new Date(finPeriode));
			this.debutPeriodeStr = formatDate.format(new Date(debutPeriode));
			this.familleClient = familleClient;
			this.commercial = commercial;
			this.typeDetail = typeDetail;
			this.tarifsSpe = tarifsSpe;
			this.detail = !typeDetail.equals("N");
			
			String reqLeDossier = "select * from DOSSIER where Dossier_Id='"+ dossierId+ "'";
			ResultSet rset = stt.executeQuery(reqLeDossier);
			rset.next();
			this.raisonSociale = rset.getString("Raison_Sociale");
			this.adresse = rset.getString("Adresse");
			this.compAdresse = rset.getString("Comp_Adresse");
			this.codePostal = rset.getString("Code_Postal");
			this.ville = rset.getString("Ville");
			this.monnaie = rset.getString("Monnaie_Tenue");
			rset.close();
			
			
			String ajoutCritereFacture = "";
			String ajoutCritereAvoir = "";

			if (!commercial.equals("")) {
				ajoutCritereFacture = " and f.Util_R="+ Integer.parseInt(commercial);
				ajoutCritereAvoir = " and a.Util_R="+ Integer.parseInt(commercial);
				Statement sttCom = con.createStatement();
				ResultSet rsCom = sttCom.executeQuery("select Prenom, Nom from UTILISATEUR where Utilisateur_Id="+ Integer.parseInt(commercial));
				if (rsCom.next()) {
					criteres += "Commercial : "+ rsCom.getString("Prenom") +" "+ rsCom.getString("Nom");
				}
				sttCom.close();
			}


			String reqClientCA = "select Client_Id, Raison_Sociale, coalesce(sum(CA_HT),0) as CA_HT,coalesce(sum(CA_TTC),0) as CA_TTC"
				+" from (select c.Client_Id, c.Raison_Sociale, coalesce(sum(f.Total_HT),0) as CA_HT,coalesce(sum(f.Montant_TTC * (1-f.Escompte/100)),0) as CA_TTC"
				+"  from "+ base +".FICHE_CLIENT c"
				+" left join "+ base +".FACTURE f on (c.Client_Id=f.Client_Id and f.Numero<>0 and f.Date_Facture<="+ finPeriode +" and f.Date_Facture>="+ debutPeriode + ajoutCritereFacture +")"
				+" where 1 ";

			if (!familleClient.equals("")) {
				reqClientCA += " and c.Famille='"+ s.sqlEncode(familleClient) +"'";
				if (criteres.length()>0) criteres += " - ";
				criteres += "Famille : "+ familleClient;
			}

			if (tarifsSpe.equals("1")) {
				reqClientCA += " and c.Client_Id in (select distinct Client_Id from "+ base +".CLIENT_ARTICLE)";
				criteres += (!criteres.equals("")?" - ":"") +"Clients ayant des tarifs sp\u00E9cifiques";
			}
			reqClientCA += " group by c.Client_Id, c.Raison_Sociale";

			reqClientCA += " union select c.Client_Id, c.Raison_Sociale, -coalesce(sum(a.Total_HT),0) as CA_HT,-coalesce(sum(a.Montant_TTC * (1-a.Escompte/100)),0) as CA_TTC"
			+"  from "+ base +".FICHE_CLIENT c"
			+" left join "+ base +".AVOIR a on (a.Client_Id=c.Client_Id and a.Numero<>0 and a.Date_Avoir<="+ finPeriode +" and a.Date_Avoir>="+ debutPeriode + ajoutCritereAvoir +")"
			+" where 1 ";

			
			if (!familleClient.equals("")) {
				reqClientCA += " and c.Famille='"+ s.sqlEncode(familleClient) +"'";
				if (criteres.length()>0) criteres += " - ";
				criteres += "Famille : "+ familleClient;
			}

			if (tarifsSpe.equals("1")) {
				reqClientCA += " and c.Client_Id in (select distinct Client_Id from "+ base +".CLIENT_ARTICLE)";
				criteres += (!criteres.equals("")?" - ":"") +"Clients ayant des tarifs sp\u00E9cifiques";
			}			
			reqClientCA += " group by c.Client_Id, c.Raison_Sociale) as PC"
					+" group by Client_Id, Raison_Sociale having CA_HT!=0 order by CA_HT desc";

			String reqDetail;
			if (this.typeDetail.equals("D")) {
				titreDetail = " date";
				titreDetailCsv = titreDetail;
				reqDetail =  " select AF.Date_Doc, sum(AF.CA_HT) as CA_HT from"
					+" ((select Date_Facture as Date_Doc, sum(Total_HT) as CA_HT from "+ base +".FACTURE where Client_Id=? and Date_Facture<="+ finPeriode +" and Date_Facture>="+ debutPeriode +" and Numero<>0 "+ ajoutCritereFacture +" group by Date_Doc)"
					+" union "
					+" (select Date_Avoir as Date_Doc, -sum(Total_HT) as CA_HT from "+ base +".AVOIR where Client_Id=? and Date_Avoir<="+ finPeriode +" and Date_Avoir>="+ debutPeriode +" and Numero<>0 "+ ajoutCritereAvoir +" group by Date_Doc)) as AF"
					+" group by AF.Date_Doc order by AF.Date_Doc";
			}
			else {
				String param;

				if (this.typeDetail.equals("F")) {
					param = "Famille";
					titreDetail = " famille d'article";
					titreDetailCsv = titreDetail;
				}
				else if (this.typeDetail.equals("A")) {
					param = "Article_Id";
					titreDetail = " article";
					titreDetailCsv = titreDetail;
				}
				else {
					param = "Famille, Sous_Famille";
					titreDetail = "\nfamille/sous-famille";
					titreDetailCsv = " famille/sous-famille";
				}

				reqDetail = " select TG.Groupe, sum(TG.CA_HT) as CA_HT from"
				 +" ((select coalesce(fa."+ param +",'') as Groupe, coalesce(if (f.Edition_TTC=0, coalesce(sum(af.Prix * af.Quantite * (1-af.Ristourne/100) * (1-f.Remise/100)),0), coalesce(sum((af.Prix * af.Quantite * (1-af.Ristourne/100) * (1-f.Remise/100)) / (1+af.Taux_TVA/100)),0)),0) as CA_HT"
				 +" from "+ base +".FACTURE f left join "+ base +".ARTICLE_FACTURE af on f.Facture_Id=af.Facture_Id, "+ base +".FICHE_ARTICLE fa"
				 +" where f.Numero<>0 and f.Client_Id=? and f.Date_Facture<="+ finPeriode +" and f.Date_Facture>="+ debutPeriode +" and fa.Article_Id=af.Reference "+ ajoutCritereFacture +" group by fa."+ param +" order by fa."+ param +")"
				 +" union "
				 +" (select coalesce(fa."+ param +",'') as Groupe, -coalesce(if (a.Edition_TTC=0, coalesce(sum(aa.Prix * aa.Quantite * (1-aa.Ristourne/100) * (1-a.Remise/100)),0), coalesce(sum((aa.Prix * aa.Quantite * (1-aa.Ristourne/100) * (1-a.Remise/100)) / (1+aa.Taux_TVA/100)), 0)),0) as CA_HT"
				 +" from "+ base +".AVOIR a left join "+ base +".ARTICLE_AVOIR aa on a.Avoir_Id=aa.Avoir_Id, "+ base +".FICHE_ARTICLE fa"
				 +" where a.Numero<>0 and a.Client_Id=? and a.Date_Avoir<="+ finPeriode +" and a.Date_Avoir>="+ debutPeriode +" and fa.Article_Id=aa.Reference "+ ajoutCritereAvoir +" group by fa."+ param +" order by fa."+ param +")) as TG"
				 +" group by TG.Groupe order by TG.Groupe";
			}
			
			PreparedStatement psDetail = con.prepareStatement(reqDetail);
			rset = stt.executeQuery(reqClientCA);
			while (rset.next()) {
				if (detail) {
					psDetail.setString(1, rset.getString("Client_Id"));
					psDetail.setString(2, rset.getString("Client_Id"));
					ResultSet rset2 = psDetail.executeQuery();
					String gp;

					if (rset2.next()) {
						LignePalmaresClient lp = new LignePalmaresClient();

						lp.setNumero(rset.getString("Client_Id"));
						lp.setClient(rset.getString("Raison_Sociale"));
						lp.setCaHT(rset.getDouble("CA_HT"));
						lp.setCaTTC(rset.getDouble("CA_TTC"));
						lp.setDetailSeulement(false); // on affichera une ligne complte
						
						if (this.typeDetail.equals("D")) {
							gp = formatDate.format(new Date(rset2.getLong("Date_Doc")));
						}
						else {
							gp = rset2.getString("Groupe");
						}
						lp.setGroupe(gp);
						lp.setHtGp(rset2.getDouble("CA_HT"));
						
						lignes.add(lp);
					}

					while (rset2.next()) {
						LignePalmaresClient lp = new LignePalmaresClient();

						lp.setNumero(rset.getString("Client_Id"));
						lp.setClient(rset.getString("Raison_Sociale"));
						lp.setCaHT(rset.getDouble("CA_HT"));
						lp.setCaTTC(rset.getDouble("CA_TTC"));
						lp.setDetailSeulement(true); // on n'affichera que les dtails
						
						if (this.typeDetail.equals("D")) {
							gp = formatDate.format(new Date(rset2.getLong("Date_Doc")));
						}
						else {
							gp = rset2.getString("Groupe");
						}
						lp.setGroupe(gp);
						lp.setHtGp(rset2.getDouble("CA_HT"));
						
						lignes.add(lp);
					}
				}
				else {
					LignePalmaresClient lp = new LignePalmaresClient();

					lp.setNumero(rset.getString("Client_Id"));
					lp.setClient(rset.getString("Raison_Sociale"));
					lp.setCaHT(rset.getDouble("CA_HT"));
					lp.setCaTTC(rset.getDouble("CA_TTC"));
					lp.setDetailSeulement(false); // on affichera une ligne complte
					lp.setGroupe(""); // initialisation
					lp.setHtGp(0); // initialisation
					
					lignes.add(lp);
				}
			}		
			rset.close();
			stt.close();
			s.closeConnection(con, null);
		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}
	public int getNbLignes() {
		return lignes.size();
	}
} // fin DataPalmaresClient
