/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 * Ligne de dtail d'un compte de tiers
 */

package org.opensi.facturation.actions.editions;


import org.opensi.util.tools.Arrondi;


public class LigneDetailCompte {	


	protected String tiers;
	protected String numCompte;
	protected double montantHT;
	protected double montantTVA;
	protected double montantTTC;
	
	private Arrondi r = new Arrondi(2);
	
	public void setTiers(String tiers) { this.tiers = tiers; }
	public void setNumCompte(String numCompte) { this.numCompte = numCompte; }	
	public void setMontantHT(double montantHT) { this.montantHT = r.round(montantHT); }
	public void setMontantTVA(double montantTVA) { this.montantTVA = r.round(montantTVA); }
	public void setMontantTTC(double montantTTC) { this.montantTTC = r.round(montantTTC); }
	

	public LigneDetailCompte(String numCompte, String tiers, double montantHT, double montantTTC) {

		this.numCompte = numCompte;
		this.tiers = tiers;

		this.add(montantHT, montantTTC);    
	}


	public void add(double montantHT, double montantTTC) {
	
		this.montantHT += montantHT;
		this.montantTTC += montantTTC;	 
		this.montantTVA += montantTTC - montantHT;
	}

}
