/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 * Gnration d'un tableau des affaires
 */

package org.opensi.facturation.actions.listing;


import org.experlog.openeas.api.ServletRequest;
import org.experlog.openeas.api.Action;
import org.experlog.openeas.api.Session;

import java.sql.*;

import org.opensi.util.listing.ListingFile;
import org.opensi.util.listing.ListingTabFile;
import org.opensi.util.tools.DateTime;


public class ListeAffaires extends Action {


  public boolean serverSide() { return true; }

  public boolean service(Session s, ServletRequest r, Object info) throws Exception {


		String fichier = r.getParameter("Fichier");
		String buffer = s.getAppConfiguration().get("opensi.absdir") +"/iobuffer/";

		String base = s.getCookie().get("BaseDossier");

		String tri1 = r.getParameter("Tri1");
		String tri2 = r.getParameter("Tri2");
		String tri3 = r.getParameter("Tri3");

		String etat = r.getParameter("Etat");
		String debutDelai = r.getParameter("Debut_Delai");
		String finDelai = r.getParameter("Fin_Delai");


		ListingFile lf = new ListingTabFile();

		lf.newLine();
		lf.addToLine("N Affaire");
		lf.addToLine("Intitul\u00E9");
		lf.addToLine("Ouverture");
		lf.addToLine("Cloture");
		lf.addToLine("N Client");
		lf.addToLine("Client");
		lf.addToLine("Etat");
		lf.addToLine("R\u00E9f. Commande");
		lf.addToLine("Date commande");
		lf.addToLine("D\u00E9lai");
		lf.addToLine("Total HT");

		Connection con = s.getConnection(null);

		Statement stt = con.createStatement();

		String reqAffaires = "select a.*, c.Total_HT, c.Ref_Com, c.Delai, c.Date_Com from "+ base +".AFFAIRE a left join "+ base +".COM_CLIENT c on a.Affaire_Id=c.Affaire_Id";

		reqAffaires += " where true ";

		if (!etat.equals("")) {
			reqAffaires += " and a.Etat='"+ etat +"'";
		}

		if (!debutDelai.equals("")) {
			reqAffaires += " and c.Delai>="+ DateTime.parseDate(debutDelai, "yyyy:MM:dd");
		}

		if (!finDelai.equals("")) {
			reqAffaires += " and c.Delai<="+ DateTime.parseDate(finDelai, "yyyy:MM:dd");
		}


		reqAffaires += " order by "+ tri1 +(tri2.equals("")?"":","+ tri2) + (tri3.equals("")?"":","+ tri3);


		ResultSet rset = stt.executeQuery(reqAffaires);

		while (rset.next()) {
			lf.newLine();
			lf.addToLine(rset.getString("Num_Entier"));
			lf.addToLine(rset.getString("Nom_Affaire"));
			lf.addToLine(DateTime.formatTime(rset.getLong("Date_Creation"), "dd/MM/yyyy"));
			lf.addToLine(rset.getLong("Date_Cloture")==0?"":DateTime.formatTime(rset.getLong("Date_Cloture"), "dd/MM/yyyy"));
			lf.addToLine(rset.getString("Client_Id"));
			lf.addToLine(rset.getString("Raison_Sociale"));

			String strEtat = rset.getString("Etat");

					 if (strEtat.equals("N")) strEtat = "Nouvelle";
			else if (strEtat.equals("D")) strEtat = "En cours";
			else if (strEtat.equals("V")) strEtat = "Valid\u00E9e";
			else if (strEtat.equals("C")) strEtat = "Clotur\u00E9e";

			lf.addToLine(strEtat);

			String totalHT = (rset.getString("Total_HT")==null?"0":rset.getString("Total_HT").replaceAll("\\.", ","));
			String refCom = (rset.getString("Ref_Com")==null?"":rset.getString("Ref_Com"));
			String delai = (rset.getString("Delai")==null?"":(rset.getLong("Delai")==0?"":DateTime.formatTime(rset.getLong("Delai"), "dd/MM/yyyy")));
			String dateCom = (rset.getString("Date_Com")==null?"":(rset.getLong("Date_Com")==0?"":DateTime.formatTime(rset.getLong("Date_Com"), "dd/MM/yyyy")));

			lf.addToLine(refCom);
			lf.addToLine(dateCom);
			lf.addToLine(delai);
			lf.addToLine(totalHT);
		}

		lf.write(buffer, fichier, true);

		s.closeConnection(con, null);

		return true;

	} // fin service


} // fin ListeAffaires
