/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 * Gnration d'un tableau des affaires
 */

package org.opensi.facturation.actions.listing;


import org.experlog.openeas.api.ServletRequest;
import org.experlog.openeas.api.Action;
import org.experlog.openeas.api.Session;

import java.sql.*;

import org.opensi.util.listing.ListingFile;
import org.opensi.util.listing.ListingTabFile;
import org.opensi.util.tools.DateTime;


public class ListeArticlesEnAttente extends Action {


  public boolean serverSide() { return true; }

  public boolean service(Session s, ServletRequest r, Object info) throws Exception {


		String fichier = r.getParameter("Fichier");
		String buffer = s.getAppConfiguration().get("opensi.absdir") +"/iobuffer/";

		String base = s.getCookie().get("BaseDossier");

		ListingFile lf = new ListingTabFile();

		lf.newLine();
		lf.addToLine("R\u00E9f\u00E9rence");
		lf.addToLine("D\u00E9signation");
		lf.addToLine("Date de commande");
		lf.addToLine("N\u00B0 Commande");
		lf.addToLine("N\u00B0 Fournisseur");
		lf.addToLine("Quantit\u00E9");

		Connection con = s.getConnection(null);

		Statement stt = con.createStatement();
		String getArtAtt = "select ac.Reference, ac.Designation, c.Date_Commande, c.Num_Entier, c.Fournisseur_Id, sum(ac.Quantite)- BON.BR as Quantite";
		getArtAtt += " from (select ac.Reference, c.Num_Entier,coalesce(sum(abr.Quantite),0) as BR";
		getArtAtt += " from " + base + ".COMMANDE c, " + base + ".ARTICLE_COMMANDE ac   left join " + base + ".ARTICLE_BON_RECEPTION abr on ac.ligne_Id=abr.Ref_Ligne left join " + base + ".BON_RECEPTION br on br.BR_Id=abr.BR_Id and br.Etat='V'";  
		getArtAtt += " where ac.Commande_Id=c.Commande_Id   and c.Etat='V'   and ac.Type_Ligne='S'";
		getArtAtt += " group by Reference, c.Num_Entier order by Reference) as BON," + base + ".COMMANDE c, " + base + ".ARTICLE_COMMANDE ac";
		getArtAtt += " where ac.Commande_Id=c.Commande_Id   and c.Etat='V'   and ac.Type_Ligne='S'";
		getArtAtt += " and BON.Reference=ac.Reference and BON.Num_Entier=c.Num_Entier";
		getArtAtt += " group by Reference, c.Num_Entier ";
		getArtAtt += " having Quantite>0 order by Reference";

		ResultSet rset = stt.executeQuery(getArtAtt);

		while (rset.next()) {
			lf.newLine();
			lf.addToLine(rset.getString("Reference"));
			lf.addToLine(rset.getString("Designation"));
			lf.addToLine(DateTime.formatTime(rset.getLong("Date_Commande"), "dd/MM/yyyy"));
			lf.addToLine(rset.getString("Num_Entier"));
			lf.addToLine(rset.getString("Fournisseur_Id"));
			lf.addToLine(rset.getString("Quantite").replaceAll("\\.", ","));
		}

		lf.write(buffer, fichier, true);

		s.closeConnection(con, null);

		return true;

	} // fin service


} // fin ListeArticlesEnAttente
