/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 * Gnration d'un tableau des commandes fournisseurs
 */

package org.opensi.facturation.actions.listing;


import org.experlog.openeas.api.ServletRequest;
import org.experlog.openeas.api.Action;
import org.experlog.openeas.api.Session;

import java.sql.*;

import org.opensi.util.listing.ListingFile;
import org.opensi.util.listing.ListingTabFile;
import org.opensi.util.tools.DateTime;


public class ListeCommandes extends Action {


  public boolean serverSide() { return true; }

  public boolean service(Session s, ServletRequest r, Object info) throws Exception {


		String fichier = r.getParameter("Fichier");
		String buffer = s.getAppConfiguration().get("opensi.absdir") +"/iobuffer/";

		String base = s.getCookie().get("BaseDossier");

		String tri1 = r.getParameter("Tri1");
		String tri2 = r.getParameter("Tri2");
		String tri3 = r.getParameter("Tri3");

		String etat = r.getParameter("Etat");
		String dateDebut = r.getParameter("Date_Debut");
		String dateFin = r.getParameter("Date_Fin");


		ListingFile lf = new ListingTabFile();

		lf.newLine();
		lf.addToLine("N Commande");
		lf.addToLine("Intitul\u00E9");
		lf.addToLine("Date Commande");
		lf.addToLine("N Fournisseur");
		lf.addToLine("Fournisseur");
		lf.addToLine("Etat");
		lf.addToLine("Total HT");

		Connection con = s.getConnection(null);

		Statement stt = con.createStatement();

		String reqCommandes = "select c.Num_Entier, c.Intitule, c.Date_Commande, f.Fournisseur_Id, f.Raison_Sociale, c.Etat, c.Total_HT from "+ base +".COMMANDE c, "+ base +".FICHE_FOURNISSEUR f where c.Fournisseur_Id=f.Fournisseur_Id";

		if (!etat.equals("")) {
			reqCommandes += " and c.Etat='"+ etat +"'";
		}

		if (!dateDebut.equals("")) {
			reqCommandes += " and c.Date_Commande>="+ DateTime.parseDate(dateDebut, "yyyy:MM:dd");
		}

		if (!dateFin.equals("")) {
			reqCommandes += " and c.Date_Commande<="+ DateTime.parseDate(dateFin, "yyyy:MM:dd");
		}


		reqCommandes += " order by "+ tri1 +(tri2.equals("")?"":","+ tri2) + (tri3.equals("")?"":","+ tri3);


		ResultSet rset = stt.executeQuery(reqCommandes);

		while (rset.next()) {
			lf.newLine();
			lf.addToLine(rset.getString("Num_Entier"));
			lf.addToLine("\"" + rset.getString("Intitule") + "\"");
			lf.addToLine(DateTime.formatTime(rset.getLong("Date_Commande"), "dd/MM/yyyy"));
			lf.addToLine(rset.getString("Fournisseur_Id"));
			lf.addToLine("\"" + rset.getString("Raison_Sociale") + "\"");

			String strEtat = rset.getString("Etat");
			if (strEtat.equals("N")) strEtat = "Nouvelle";
			else if (strEtat.equals("B")) strEtat = "Bloqu\u00E9e";
			else if (strEtat.equals("P")) strEtat = "Pr\u00E9paration";
			else if (strEtat.equals("V")) strEtat = "Valid\u00E9e";
			else if (strEtat.equals("F")) strEtat = "Finie";
			lf.addToLine(strEtat);

			String totalHT = (rset.getString("Total_HT")==null?"0":rset.getString("Total_HT").replaceAll("\\.", ","));
			lf.addToLine(totalHT);
		}

		lf.write(buffer, fichier, true);

		s.closeConnection(con, null);

		return true;

	} // fin service


} // fin ListeCommandes
