/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 * Gnration d'un tableau des affaires
 */

package org.opensi.facturation.actions.listing;


import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;

import org.experlog.openeas.api.Action;
import org.experlog.openeas.api.ServletRequest;
import org.experlog.openeas.api.Session;
import org.opensi.facturation.CalculStock;
import org.opensi.util.listing.ListingFile;
import org.opensi.util.listing.ListingTabFile;
import org.opensi.util.tools.DateTime;


public class ListeCommandesWeb extends Action {


  public boolean serverSide() { return true; }

  public boolean service(Session s, ServletRequest r, Object info) throws Exception {

	  

		String fichier = r.getParameter("Fichier");
		String buffer = s.getAppConfiguration().get("opensi.absdir") +"/iobuffer/";

		String base = s.getCookie().get("BaseDossier");
		
		String article_id = r.getParameter("article_id");
		String facture_id = r.getParameter("facture_id");
		String num_com_site = r.getParameter("num_com_site");
		String login = r.getParameter("login");
		String montant_TTC = r.getParameter("montant_TTC");
		String nom_cli = r.getParameter("nom_cli");
		String date_debut = r.getParameter("date_debut");
		String date_fin = r.getParameter("date_fin");
		String site_id = r.getParameter("site_id");
		String mode_p = r.getParameter("mode_p");
		String statut_c = r.getParameter("statut_c");
		String statut_p = r.getParameter("statut_p");
		String bloque = r.getParameter("bloque");
		
		// variables du CSV
		String liste_statut_envoi;
		String liste_stock = "";
		String liste_num_com_site;
		String liste_nom_site;
		String liste_date_com;
		String liste_nom_client;
		double liste_montant_HT;
		double liste_montant_TTC;
		String liste_statut;
		String liste_mode_expe;
		String liste_mpaie;
		String liste_paye;
		String liste_login;

		Connection con = s.getConnection(null);
		Statement stt = con.createStatement();

		String reqDate = "select coalesce(max(Date_Liv),0) as Date_Liv from " + base + ".BON_LIVRAISON where Com_Web_Id=? and Etat='V'";
		PreparedStatement psreqDate = con.prepareStatement(reqDate);


		ListingFile lf = new ListingTabFile();

		lf.newLine();
		lf.addToLine("Date");
		lf.addToLine("N Commande");
		lf.addToLine("Site");
		lf.addToLine("Login");
		lf.addToLine("Client");
		lf.addToLine("Statut");
		lf.addToLine("Stat Envoi");
		lf.addToLine("Stock");
		lf.addToLine("Exp\u00E9dition");
		lf.addToLine("Mode Paiement");
		lf.addToLine("Etat Paiement");
		lf.addToLine("Montant HT");
		lf.addToLine("Montant TTC");
		

		int dispo = 0;
		String sqlregl = "select Type_Calcul_Stock from PARAM_DOSSIER where Dossier_Id = '" + s.getCookie().get("Dossier_Id") + "'";
		ResultSet rset = stt.executeQuery(sqlregl);
		if (rset.next()) {
		   	dispo = rset.getInt("Type_Calcul_Stock");
		}
		
		CalculStock calcul = new CalculStock(s,dispo);
		
		String reqCom = "select Soldee,Date_Validation,coalesce(cw.Client_Site_Id,'') as Client_Site_Id,com.Total_TTC,com.Mode_Expedition,com.Com_Web_Id,c.Civ_Courte,com.Societe_Client,com.Nom_Inter,com.Prenom_Inter, com.Total_HT,Statut_Commande, Date_Commande";
		reqCom += ", Mode_Paiement, Statut_Paiement, com.Com_site_Id,com.Site_Id";
		reqCom += " from CIVILITE c,"+ base + ".COMMANDE_WEB com";
		reqCom += " left join "+ base +".CLIENT_WEB cw on com.Client_Web_Id=cw.Client_Web_Id";
		
		if (!article_id.equals("")) {
			reqCom += " left join "+ base +".ARTICLE_COMMANDE_WEB d on com.Com_Web_Id=d.Com_Web_Id";
		}
		
		if (!facture_id.equals("")) {
			reqCom += " left join "+ base +".FACTURE f on com.Com_Web_Id=f.Com_Web_Id";
		}
		
		reqCom += " where c.Civ_Id=com.Civ_Inter";

		// Utilisation des filtres de recherche

		if (!num_com_site.equals("")) {
			reqCom += " AND com.Com_Site_Id LIKE '%" + num_com_site.replaceAll("'", "''") + "%'";
		}

		if (!login.equals("")) {
			reqCom += " AND cw.Client_Site_Id LIKE '" + login + "%'";
		}

		if (!montant_TTC.equals("")) {
			reqCom += " AND com.Total_TTC like '" + montant_TTC + "%'";
		}

		if (!nom_cli.equals("")) {
			reqCom += " AND (com.Nom_Inter LIKE '" + nom_cli.replaceAll("'", "''") + "%' or com.Societe_Client LIKE '" + nom_cli.replaceAll("'", "''") + "%')";
		}

		if (!article_id.equals("")) {
			reqCom += " AND d.Article_Id LIKE '%" + article_id + "%'";
		}

		if (!facture_id.equals("")) {
			reqCom += " AND f.Num_Entier LIKE '%" + facture_id + "%'";
		}
		
		if (!date_debut.equals("")) {
			DateTime dd = new DateTime(DateTime.parseDate(date_debut, "yyyy:MM:dd"));
			reqCom += " AND Date_Commande>=" + dd.getTimeInMillis();
		}

		if (!date_fin.equals("")) {
			DateTime df = new DateTime(DateTime.parseDate(date_fin, "yyyy:MM:dd"));
			df.setDay(df.getDay()+1);
			reqCom += " AND Date_Commande<" + df.getTimeInMillis();
		}

		if (!site_id.equals("T")) {
			int sid = Integer.parseInt(site_id);
			reqCom += " AND com.Site_Id=" + sid;
		}

		if (!mode_p.equals("T")) {
			reqCom += " AND Mode_Paiement='" + mode_p +"'";
		}

		if (!statut_c.equals("T")) {
			if (statut_c.equals("R")) {
				reqCom += " AND Statut_Commande='C'";
			} else {
				reqCom += " AND Statut_Commande='" + statut_c +"'";
			}
		}
		
		if (!statut_p.equals("T")) {
			if (statut_p.equals("P")) {
				reqCom += " AND Statut_Paiement in ('1','2')";
			}
			else {
				reqCom += " AND Statut_Paiement='" + statut_p + "'";
			}
		}
		if (!bloque.equals("T")) {
			reqCom += " AND Bloque='" + bloque +"'";
		}

		reqCom += " group by com.Com_Web_Id order by Date_Commande limit 1000";
		rset = stt.executeQuery(reqCom);
		while (rset.next()) {
			long Date_BL = 0;
			int partiel=0;
			int com_web_id = rset.getInt("Com_Web_Id");
			int soldee =  rset.getInt("Soldee");
			char statut = ((rset.getString("Statut_Commande") != null) ? rset.getString("Statut_Commande").charAt(0) : ' ');

			psreqDate.setInt(1,com_web_id);
			ResultSet rset2 = psreqDate.executeQuery();
			if (rset2.next()) {
				if(rset.getLong("Date_Liv")>0) {
					Date_BL = rset.getLong("Date_Liv");
					partiel=1;
				}
			}
			double stock = calcul.stock(com_web_id);
			double total = calcul.total(com_web_id);
			liste_stock= "";
			if ((!statut_c.equals("C") && !statut_c.equals("R")) || (statut_c.equals("R") && stock!=total && total!=0) || (statut_c.equals("C") && stock==total)) {
				if (statut_c.equals("R") || (statut_c.equals("T") && statut_c.equals("C") && (stock!=total))) {
					statut = 'R';
				}
				if (statut_c.equals("C")) {
					liste_stock = stock+" / "+total;
				}

				if (partiel==0) {
					liste_statut_envoi = "Non envoy\u00E9";
				}
				else if (partiel==1 && (statut_c.equals("E") || statut_c.equals("L")) && soldee==0) {
					liste_statut_envoi = "Complet - " + DateTime.formatTime(Date_BL, "dd/MM/yyyy");
				}
				else {
					liste_statut_envoi = (soldee==1)?"Partiel - Solde":"Partiel - " + DateTime.formatTime(Date_BL, "dd/MM/yyyy");
				}
					
				liste_num_com_site = rset.getString("Com_Site_Id");
				liste_nom_site = rset.getString("Nom_Site");
				liste_date_com = DateTime.formatTime(rset.getLong("Date_Commande"), "dd/MM/yyyy HH:mm");
				
				if (rset.getString("Societe_Client").equals("")) {
						liste_nom_client = (rset.getString("Civ_Courte") + " " + rset.getString("Nom_Inter") + " " + rset.getString("Prenom_inter")).trim();
				}
				else {
					liste_nom_client = rset.getString("Societe_Client").trim() + " - " + (rset.getString("Civ_courte") + " " + rset.getString("Nom_Inter") + " " + rset.getString("Prenom_Inter")).trim();		
				}
					
					liste_montant_HT = rset.getDouble("Total_HT");
					liste_montant_TTC = rset.getDouble("Total_TTC");
					
					switch (statut) {
						case 'N':
							liste_statut = "Nouvelle";
						break;
			
						case 'R':
							liste_statut = "R\u00E9assort";
						break;

						case 'C':
							liste_statut = "En cours";
						break;
			
						case 'E':
							liste_statut = "Envoy\u00E9e";
						break;
			
						case 'A':
							liste_statut = "Annul\u00E9e";
						break;
			
						case 'L':
							liste_statut = "Livr\u00E9e";
						break;
						
						case 'M':
							liste_statut = "Non Aboutie";
						break;
			
						default:
							liste_statut = "INCONNU";
						break;
					}
			
					liste_mode_expe = rset.getString("Mode_Expedition");
					liste_mpaie = rset.getString("Mode_Paiement");
					
					int statutPaie = rset.getInt("Statut_Paiement");
					switch (statutPaie) {
						case 0:
							liste_paye = "Non pay\u00E9e";
						break;
						
						case 1:
							liste_paye = "Pay\u00E9e";
						break;
						
						case 2:
							liste_paye = "Partiel. pay\u00E9e";
						break;
						
						default:
							liste_paye = "Inconnu";
						break;
					}
					
					liste_login = rset.getString("Client_Site_Id");
					
					lf.newLine();
					lf.addToLine(liste_date_com);
					lf.addToLine(liste_num_com_site);
					lf.addToLine(liste_nom_site);
					lf.addToLine(liste_login);
					lf.addToLine(liste_nom_client);
					lf.addToLine(liste_statut);
					lf.addToLine(liste_statut_envoi);
					lf.addToLine("'" + liste_stock); // forcer champ texte
					lf.addToLine(liste_mode_expe);
					lf.addToLine(liste_mpaie);
					lf.addToLine(liste_paye);
					lf.addToLine(("" + liste_montant_HT).replaceAll("\\.", ","));
					lf.addToLine(("" + liste_montant_TTC).replaceAll("\\.", ","));
			}
		}

		lf.write(buffer, fichier, true);

		s.closeConnection(con, null);

		return true;

	} // fin service


} // fin ListeCommandesWeb
