/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 * Donnes ncessaires  l'dition des tarifs mis  jour
 */

package org.opensi.facturation.actions.majtarifs;


import java.sql.Connection;
import java.sql.Date;
import java.sql.ResultSet;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.ArrayList;

import org.experlog.openeas.api.Session;


public class DataMajTarifs {


	// les lignes de la mise  jour des tarifs
	protected ArrayList<LigneArticle> lignesTarifs = new ArrayList<LigneArticle>(10);
	protected ArrayList<LigneTarifSpecifique> lignesTarifsSpecifiques = new ArrayList<LigneTarifSpecifique>(10);
	
	protected String dateCourante;

	protected String dossierId = "";
	protected String raisonSociale = "";
	protected String adresse = "";
	protected String compAdresse = "";
	protected String codePostal = "";
	protected String ville = "";
	
	protected double capital;
	protected String typeSociete;
	protected String tvaIntra;
	protected String rcs;
	protected String siren;

	protected int element;
	protected boolean repercution;
	
	public DataMajTarifs(Session s, MajTarifs mt) {
		try {
			
			dossierId = s.getCookie().get("Dossier_Id");
			
			this.lignesTarifs = mt.lignesTarifs;
			this.lignesTarifsSpecifiques = mt.lignesTarifsSpecifiques;
			this.element = mt.element;
			this.repercution = mt.repercution;
			
			SimpleDateFormat formatDate = new SimpleDateFormat("dd/MM/yyyy");
			this.dateCourante = formatDate.format(new Date(System.currentTimeMillis()));
		
			Connection con = s.getConnection(null);
			Statement stt = con.createStatement();

			String reqLeDossier = "select * from DOSSIER where Dossier_Id='"+ dossierId+ "'";
			ResultSet rset = stt.executeQuery(reqLeDossier);
			if (rset.next()) {
				this.raisonSociale = rset.getString("Raison_Sociale");
				this.adresse = rset.getString("Adresse");
				this.compAdresse = rset.getString("Comp_Adresse");
				this.codePostal = rset.getString("Code_Postal");
				this.ville = rset.getString("Ville");
				this.siren = formatSiren(rset.getString("Num_SIRET"));
				this.typeSociete = rset.getString("Type_Societe");
				this.capital = rset.getDouble("Montant_Capital");
				this.tvaIntra = rset.getString("Num_TVA_Intra");
				this.rcs = rset.getString("Ville_RCS");
			}
			rset.close();
			
			stt.close();			
			s.closeConnection(con, null);
			
		} catch(Exception e) {
			e.printStackTrace();
		}	
	}
	
	
	public int getNbLignes() {
		return lignesTarifs.size();
	}
	
	public int getNbLignesTarifsSpec() {
		return lignesTarifsSpecifiques.size();
	}
	
	public String formatSiren(String siret) {
		if (siret.length()>=9) {
			return siret.substring(0,3) +" "+ siret.substring(3,6) +" "+ siret.substring(6,9);
		}
		return siret;
	}
	
	
} // fin DataMajTarifs
