/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

package org.opensi.facturation.actions.transcompta;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import org.experlog.openeas.api.Action;
import org.experlog.openeas.api.ServletRequest;
import org.experlog.openeas.api.Session;
import org.opensi.compta.Ecriture;
import org.opensi.compta.Operation;
import org.opensi.util.tools.DateTime;


public class RegulariserEcheance extends Action {

  private Connection con;
  private String base;
  private String baseCompta;
	private String dossierId;
	private String compteClientsDivers;

	private PreparedStatement psCpteClient;
	private PreparedStatement psCpteRegul;
	private PreparedStatement psIntCpte;
	private Statement stt;
	private Statement stt2;

  public boolean serverSide() { return true; }

  public boolean service(Session s, ServletRequest r, Object info) throws Exception {


    String codeJournal = r.getParameter("Code_Journal");
    String Echeance_Id = r.getParameter("Echeance_Id");

		dossierId = s.getCookie().get("Dossier_Id");

		base = s.getCookie().get("BaseDossier");

    con = s.getConnection(null);
		stt = con.createStatement();
		stt2 = con.createStatement();

		String reqComptesDefaut = "select Numero_Compte_Clients from PARAM_DOSSIER where Dossier_Id='"+ dossierId +"'";

		ResultSet rset = stt.executeQuery(reqComptesDefaut);
		rset.next();

		compteClientsDivers = rset.getString("Numero_Compte_Clients");


		String reqCpteClient = "select c.Numero_Compte from "+ base +".FICHE_CLIENT e,"+ base +".COMPTE c "
												 + "where e.Client_Id=? and e.Numero_Compte=c.Numero_Compte";

		String reqCpteRegul = "select Numero_Compte_Regul_VE from PARAM_DOSSIER where Dossier_Id='"+ dossierId +"'";

		String reqIntCompte = "select Intitule from "+ base +".COMPTE where Numero_Compte=?";


		psCpteClient = con.prepareStatement(reqCpteClient);
		psCpteRegul = con.prepareStatement(reqCpteRegul);
		psIntCpte = con.prepareStatement(reqIntCompte);

		String reqEcheance="";
		if (Echeance_Id!=null) {
			 reqEcheance = "select * from " + base + ".ECHEANCE_CLIENT e";
    	 reqEcheance += " where Echeance_Id="+Echeance_Id;
		}
		rset = stt.executeQuery(reqEcheance);

		if (rset.next()) {

			String clientId = rset.getString("Client_Id");
			String numPiece = rset.getString("Numero");
			double regul = rset.getDouble("Regulariser");

			DateTime dt = new DateTime();
			dt.setDay(1);
			long dateEcriture = dt.getDateInMillis();
			getbase(dateEcriture);

			dt = new DateTime();
			long dateOp = dt.getDateInMillis();


			Ecriture ecriture = new Ecriture(codeJournal, dateEcriture);

			// ajout des oprations  l'ecriture comptable

			// operation du compte client

			if (regul>0) {
				String compteClient = getCompteClient(clientId);

				Operation op = new Operation();
				op.setDateOp(dateOp);
				op.setNumPiece(numPiece);

				op.setNumeroCompte(compteClient);
				op.setLibelle(getIntitule(compteClient));
				op.setMontantC(regul);

				ecriture.addOp(op);
			}

			// operation du compte Numero_Compte_Regul_VE

			if (regul>0) {
				String compteRegul=getCompteRegul();

				Operation op = new Operation();
				op.setDateOp(dateOp);
				op.setNumPiece(numPiece);
				op.setNumeroCompte(compteRegul);
				op.setLibelle(getIntitule(compteRegul));
				op.setMontantD(regul);
				ecriture.addOp(op);
			}

			// insertion en base de l'ecriture comptable ssi quilibre

			if (ecriture.isStable()) {
      	ecriture.insertDB(con, baseCompta, base);
				ecriture.printEcriture();
      }
			else {
				System.out.println("\nTRANSFERT COMPTA: ECRITURE DESEQUILIBREE\n");
				ecriture.printEcriture();
			}

		} // fin boucle reglements
		s.closeConnection(con, null);

		return true;
  }

	private String getIntitule(String numCompte) throws SQLException {

		psIntCpte.setString(1, numCompte);
		ResultSet rset = psIntCpte.executeQuery();
		return ( rset.next() ) ? rset.getString("Intitule") : "-";
	}

	private String getCompteClient(String clientId) throws SQLException {

		if (clientId.equals("")) {
			return compteClientsDivers;
		}
		else {
			psCpteClient.setString(1, clientId);
			ResultSet rset = psCpteClient.executeQuery();

    	if (rset.next()) {
      	return rset.getString("Numero_Compte");
    	}
			else {
				return compteClientsDivers;
			}
		}
	}

	private String getCompteRegul() throws SQLException {

		ResultSet rset = psCpteRegul.executeQuery();
   	if (rset.next()) {
     	return rset.getString("Numero_Compte_Regul_VE");
   	}
		else {
			return "";
		}
	}

	private boolean getbase(long date) throws SQLException {

		String reqBaseCompta = "select Nom_Base from EXERCICE where Debut_Exercice<="+ date +" and Fin_Exercice>="+ date +" and Dossier_Id='"+ dossierId +"'";
		ResultSet rset2 = stt2.executeQuery(reqBaseCompta);
		if (rset2.next()) {
			baseCompta = rset2.getString("Nom_Base");
		}
		return true;
	}
} // fin Regulariser.java
