/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

package org.opensi.facturation.actions.transcompta;

import java.sql.*;

import org.experlog.openeas.api.Action;
import org.experlog.openeas.api.ServletRequest;
import org.experlog.openeas.api.Session;
import org.opensi.compta.Ecriture;
import org.opensi.compta.Operation;
import org.opensi.util.tools.DateTime;


public class RegulariserReglementFournisseur extends Action {

  private Connection con;
  private String base;
  private String baseCompta;
	private String dossierId;
	private String compteFournisseursDivers;

	private PreparedStatement psCpteFournisseur;
	private PreparedStatement psCpteRegul;
	private PreparedStatement psIntCpte;
	private Statement stt;
	private Statement stt2;

  public boolean serverSide() { return true; }

  public boolean service(Session s, ServletRequest r, Object info) throws Exception {


    String codeJournal = r.getParameter("Code_Journal");
    String Reglement_Id = r.getParameter("Reglement_Id");

		dossierId = s.getCookie().get("Dossier_Id");

		base = s.getCookie().get("BaseDossier");

    con = s.getConnection(null);
		stt = con.createStatement();
		stt2 = con.createStatement();

		String reqComptesDefaut = "select Numero_Compte_Fournisseurs "
														+ "from PARAM_DOSSIER where Dossier_Id='"+ dossierId +"'";

		ResultSet rset = stt.executeQuery(reqComptesDefaut);
		rset.next();

		compteFournisseursDivers = rset.getString("Numero_Compte_Fournisseurs");


		String reqCpteFournisseur = "select c.Numero_Compte from "+ base +".FICHE_FOURNISSEUR e,"+ base +".COMPTE c "
												 + "where e.Fournisseur_Id=? and e.Numero_Compte=c.Numero_Compte";

		String reqCpteRegul = "select Numero_Compte_Regul_AC from PARAM_DOSSIER where Dossier_Id='"+ dossierId +"'";

		String reqIntCompte = "select Intitule from "+ base +".COMPTE where Numero_Compte=?";


		psCpteFournisseur = con.prepareStatement(reqCpteFournisseur);
		psCpteRegul = con.prepareStatement(reqCpteRegul);
		psIntCpte = con.prepareStatement(reqIntCompte);

		String reqReglement="";
		if (Reglement_Id!=null) {
			 reqReglement = "select * from " + base + ".REGLEMENT_FOURNISSEUR e";
    	 reqReglement += " where Reglement_Id="+Reglement_Id;
		}
		rset = stt.executeQuery(reqReglement);

		if (rset.next()) {
			long dateReglement = rset.getLong("Date_Reg");

			String fournisseurId = rset.getString("Fournisseur_Id");
			String numPiece = rset.getString("Num_Piece");
			double regul = rset.getDouble("Regulariser");

			getbase(dateReglement);

			DateTime dt = new DateTime();
			dt.setDay(1);
			long dateEcriture = dt.getDateInMillis();

			Ecriture ecriture = new Ecriture(codeJournal, dateEcriture);

			// ajout des oprations  l'ecriture comptable

			// operation du compte fournisseur

			if (regul>0) {
				String compteFournisseur = getCompteFournisseur(fournisseurId);

				Operation op = new Operation();
				op.setDateOp(dateReglement);
				op.setNumPiece(numPiece);

				op.setNumeroCompte(compteFournisseur);
				op.setLibelle(getIntitule(compteFournisseur));
				op.setMontantC(regul);

				ecriture.addOp(op);
			}

			// operation du compte Numero_Compte_Regul_AC

			if (regul>0) {
				String compteRegul=getCompteRegul();

				Operation op = new Operation();
				op.setDateOp(dateReglement);
				op.setNumPiece(numPiece);
				op.setNumeroCompte(compteRegul);
				op.setLibelle(getIntitule(compteRegul));
				op.setMontantD(regul);
				ecriture.addOp(op);
			}

			// insertion en base de l'ecriture comptable ssi quilibre

			if (ecriture.isStable()) {
      	ecriture.insertDB(con, baseCompta, base);
      }
			else {
				System.out.println("\nTRANSFERT COMPTA: ECRITURE DESEQUILIBREE\n");
				ecriture.printEcriture();
			}

		} // fin boucle reglements
		s.closeConnection(con, null);

		return true;
  }

	private String getIntitule(String numCompte) throws SQLException {

		psIntCpte.setString(1, numCompte);
		ResultSet rset = psIntCpte.executeQuery();
		return ( rset.next() ) ? rset.getString("Intitule") : "-";
	}

	private String getCompteFournisseur(String fournisseurId) throws SQLException {

		if (fournisseurId.equals("")) {
			return compteFournisseursDivers;
		}
		else {
			psCpteFournisseur.setString(1, fournisseurId);
			ResultSet rset = psCpteFournisseur.executeQuery();

    	if (rset.next()) {
      	return rset.getString("Numero_Compte");
    	}
			else {
				return compteFournisseursDivers;
			}
		}
	}

	private String getCompteRegul() throws SQLException {

		ResultSet rset = psCpteRegul.executeQuery();
   	if (rset.next()) {
     	return rset.getString("Numero_Compte_Regul_AC");
   	}
		else {
			return "";
		}
	}

	private boolean getbase(long date) throws SQLException {

		String reqBaseCompta = "select Nom_Base from EXERCICE where Debut_Exercice<="+ date +" and Fin_Exercice>="+ date +" and Dossier_Id='"+ dossierId +"'";
		ResultSet rset2 = stt2.executeQuery(reqBaseCompta);
		if (rset2.next()) {
			baseCompta = rset2.getString("Nom_Base");
		}
		return true;
	}
} // fin Regulariser.java
