/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

package org.opensi.facturation.actions.transcompta;

import java.sql.*;

import org.experlog.openeas.api.Session;
import org.experlog.openeas.api.Action;
import org.experlog.openeas.api.ServletRequest;

import java.util.HashMap;
import java.util.Iterator;

import org.opensi.compta.Ecriture;
import org.opensi.compta.Operation;

import org.opensi.util.tools.DateTime;
import org.opensi.util.tools.Arrondi;


public class TransfertFactures extends Action {


  private Connection con;
  private String base;

	private String compteClientsDivers;

	private PreparedStatement psCptesTva;
	private PreparedStatement psCpteNatUE;
	private PreparedStatement psCpteClient;
	private PreparedStatement psCpteArticleN;
	private PreparedStatement psCpteFamilleN;
	private PreparedStatement psCpteSousFamilleN;
	private PreparedStatement psCpteArticleNatUE;
	private PreparedStatement psCpteFamilleNatUE;
	private PreparedStatement psCpteSousFamilleNatUE;
	private PreparedStatement psIntCpte;
	private PreparedStatement psMarqueFact;
	private PreparedStatement psMarqueAvoir;
	private PreparedStatement psBaseCompta;
	private PreparedStatement psCodeTvaPort;
	private PreparedStatement psCodeN;


	HashMap<Integer, String> cptesVTva = new HashMap<Integer, String>(100);


	private Arrondi rd = new Arrondi(2);


  public boolean serverSide() { return true; }

  public boolean service(Session s, ServletRequest r, Object info) throws Exception {


    String codeJournal = r.getParameter("Code_Journal");
		String typePeriode = r.getParameter("Type_Periode");
		String client = r.getParameter("Client_Id");

		long debutPeriode;
		long finPeriode;

		if (typePeriode.equals("P")) {
			long periode = Long.parseLong(r.getParameter("Periode"));

			DateTime dtp = new DateTime(periode);
			dtp.setDay(1);
			debutPeriode = dtp.getDateInMillis();

			dtp.setDay(dtp.currentMaxDay());
			finPeriode = dtp.getDateFullTime();
		}
		else {
			debutPeriode = Long.parseLong(r.getParameter("Date_Debut"));
			finPeriode = Long.parseLong(r.getParameter("Date_Fin"));
		}


		String dossierId = s.getCookie().get("Dossier_Id");

		base = s.getCookie().get("BaseDossier");

    con = s.getConnection(null);


		String reqBaseCompta = "select Nom_Base from EXERCICE where Debut_Exercice<=? and Fin_Exercice>=? and Dossier_Id='"+ dossierId +"'";

		psBaseCompta = con.prepareStatement(reqBaseCompta);
		
		ResultSet rset;
		
		Statement stt = con.createStatement();

		String reqComptesDefaut = "select Numero_Compte_Clients, Numero_Compte_Escompte_VE, Numero_Compte_Port_VE "
														+ "from PARAM_DOSSIER where Dossier_Id='"+ dossierId +"'";

		rset = stt.executeQuery(reqComptesDefaut);
		rset.next();
		
		compteClientsDivers = rset.getString("Numero_Compte_Clients");
    String compteLivraison = rset.getString("Numero_Compte_Port_VE");
    String compteEscompteVE = rset.getString("Numero_Compte_Escompte_VE");

		HashMap<Integer, String> cptesTva = new HashMap<Integer, String>(100);


		String reqCptesTva = "select Compte_TVA_Vente, Compte_Vente, Code_TVA from "+ base +".TAUX_TVA";
		
		String reqCpteNatUE = "select Compte_Vente from "+ base +".VENTIL_TVA_NATIONAL_UE where Code_TVA=? and Code_Pays=?";

		String reqCpteClient = "select c.Numero_Compte from "+ base +".FICHE_CLIENT e,"+ base +".COMPTE c "
												 + "where e.Client_Id=? and e.Numero_Compte=c.Numero_Compte";

		String reqCpteArticleN = "select ca.Compte_Vente from "+ base +".COMPTE_ARTICLE ca,"+ base +".COMPTE c "
														+ "where c.Numero_Compte=ca.Compte_Vente and Article_Id=? and ca.Code_TVA=?";

		String reqCpteFamilleN = "select cf.Compte_Vente from "+ base +".COMPTE_FAMILLE_ARTICLE cf,"+ base +".COMPTE c,"+ base +".FICHE_ARTICLE a "
														+ "where c.Numero_Compte=cf.Compte_Vente and a.Famille=cf.Famille and a.Article_Id=? and cf.Code_TVA=?";

		String reqCpteSousFamilleN = "select csf.Compte_Vente from "+ base +".COMPTE_SOUS_FAMILLE_ARTICLE csf,"+ base +".COMPTE c,"+ base +".FICHE_ARTICLE a "
														+ "where c.Numero_Compte=csf.Compte_Vente and a.Famille=csf.Famille and csf.Sous_Famille=a.Sous_Famille and a.Article_Id=? and csf.Code_TVA=?";

		String reqCpteArticleNatUE = "select ca.Compte_Vente from "+ base +".COMPTE_ARTICLE_TVA_NATIONAL_UE ca,"+ base +".COMPTE c "
														+ "where c.Numero_Compte=ca.Compte_Vente and Article_Id=? and ca.Code_TVA=? and ca.Code_Pays=?";

		String reqCpteFamilleNatUE = "select cf.Compte_Vente from "+ base +".COMPTE_FAMILLE_ARTICLE_TVA_NATIONAL_UE cf,"+ base +".COMPTE c,"+ base +".FICHE_ARTICLE a "
														+ "where c.Numero_Compte=cf.Compte_Vente and a.Famille=cf.Famille and a.Article_Id=? and cf.Code_TVA=? and cf.Code_Pays=?";

		String reqCpteSousFamilleNatUE = "select csf.Compte_Vente from "+ base +".COMPTE_SOUS_FAMILLE_ARTICLE_TVA_NATIONAL_UE csf,"+ base +".COMPTE c,"+ base +".FICHE_ARTICLE a "
														+ "where c.Numero_Compte=csf.Compte_Vente and a.Famille=csf.Famille and csf.Sous_Famille=a.Sous_Famille and a.Article_Id=? and csf.Code_TVA=? and csf.Code_Pays=?";

		String reqIntCompte = "select Intitule from "+ base +".COMPTE where Numero_Compte=?";

		String majMarqueFact = "update "+ base +".FACTURE set Transferee=1 where Facture_Id=?";

		String majMarqueAvoir = "update "+ base +".AVOIR set Transfere=1 where Avoir_Id=?";

		String reqCodeTvaPort = "select Code_TVA from "+ base +".TAUX_TVA where Taux_TVA=? and Code_Pays=?";
		
		String reqCodeN = "select Code_TVA from "+ base +".TAUX_TVA where Code_TVA=? and Code_Pays='FR'";


		psCptesTva = con.prepareStatement(reqCptesTva);
		psCpteNatUE = con.prepareStatement(reqCpteNatUE);
		psCpteClient = con.prepareStatement(reqCpteClient);
		psCpteArticleN = con.prepareStatement(reqCpteArticleN);
		psCpteFamilleN = con.prepareStatement(reqCpteFamilleN);
		psCpteSousFamilleN = con.prepareStatement(reqCpteSousFamilleN);		
		psCpteArticleNatUE = con.prepareStatement(reqCpteArticleNatUE);
		psCpteFamilleNatUE = con.prepareStatement(reqCpteFamilleNatUE);
		psCpteSousFamilleNatUE = con.prepareStatement(reqCpteSousFamilleNatUE);		
		psIntCpte = con.prepareStatement(reqIntCompte);
		psMarqueFact = con.prepareStatement(majMarqueFact);
		psMarqueAvoir = con.prepareStatement(majMarqueAvoir);
		
		psCodeTvaPort = con.prepareStatement(reqCodeTvaPort);
		psCodeN = con.prepareStatement(reqCodeN);


		ResultSet rsCT = psCptesTva.executeQuery();

		while (rsCT.next()) {
			cptesTva.put(new Integer(rsCT.getInt("Code_TVA")), rsCT.getString("Compte_TVA_Vente"));
			cptesVTva.put(new Integer(rsCT.getInt("Code_TVA")), rsCT.getString("Compte_Vente"));
		}

		rsCT.close();


		// GENERATION DES ECRITURES DE FACTURES

		String reqVentilTvas = "select Taux_TVA, Code_TVA, sum(Prix * Quantite * (1-Ristourne/100)) as Montant_Base "
												 + "from "+ base +".ARTICLE_FACTURE where Facture_Id=? and Taux_TVA>0 group by Taux_TVA order by Taux_TVA";

		String reqArtFact = "select * from "+ base +".ARTICLE_FACTURE where Facture_Id=?";


		PreparedStatement psVentilTvas = con.prepareStatement(reqVentilTvas);
		PreparedStatement psArtFact = con.prepareStatement(reqArtFact);



		String reqFactures = "select f.*, p.Zone_UE from "+ base +".FACTURE f, PAYS p where Numero>0 and Transferee=0 and Date_Facture<="+ finPeriode +" and Date_Facture>="+ debutPeriode
											 + " and p.Code_Pays=f.Code_Pays_Liv and Total_HT>0"+ (client.equals("")?"":" and Client_Id='"+ client +"'") +" order by Num_Entier";

		rset = stt.executeQuery(reqFactures);


		while (rset.next()) {

			long echeance = rset.getLong("Echeance");
			long dateFacture = rset.getLong("Date_Facture");

			int factureId = rset.getInt("Facture_Id");

			String clientId = rset.getString("Client_Id");
			String numPiece = rset.getString("Num_Entier");
			String libelle = rset.getString("Raison_Sociale");

			double tRemise = rset.getDouble("Remise");
			double tEscompte = rset.getDouble("Escompte");
			double fraisPort = rset.getDouble("Frais_Port");
			double tauxTvaPort = rset.getDouble("Taux_TVA_Port");
			String codePaysLiv = rset.getString("Code_Pays_Liv");
			boolean zoneUE = (rset.getInt("Zone_UE")==1 && !codePaysLiv.equalsIgnoreCase("FR"));
			int codeTvaPort = getCodeTvaPort(tauxTvaPort, codePaysLiv, rset.getInt("TVA_Liv")==1);

			boolean editionTTC = (rset.getInt("Edition_TTC")==1);


			DateTime dt = new DateTime(dateFacture);
			dt.setDay(1);
			long dateEcriture = dt.getDateInMillis();


			Ecriture ecriture = new Ecriture(codeJournal, dateEcriture);

			HashMap<String, Double> vtvas = new HashMap<String, Double>(2);
			HashMap<String, Double> vventes = new HashMap<String, Double>(2);


			// ventilation des comptes de TVA et calcul du total TVA

			double totalTVA = 0;

			if (fraisPort>0 && tauxTvaPort>0) {

				String compteTVA = cptesTva.get(new Integer(codeTvaPort));
				double montantTVA;

				if (editionTTC)
					montantTVA = rd.round(fraisPort * (tauxTvaPort/100) / (tauxTvaPort/100+1));
				else
					montantTVA = rd.round(fraisPort * (tauxTvaPort/100));

				totalTVA += montantTVA;

				vtvas.put(compteTVA, new Double(montantTVA));
			}


			psVentilTvas.setInt(1, factureId);
			ResultSet rsVT = psVentilTvas.executeQuery();

			while (rsVT.next()) {

				double tauxTVA = rsVT.getDouble("Taux_TVA");
				int codeTVA = rsVT.getInt("Code_TVA");
				double montantTVA;

				if (editionTTC)
					montantTVA = rd.round(rsVT.getDouble("Montant_Base") * (1-tRemise/100) * (tauxTVA/100) / (tauxTVA/100+1));
				else
					montantTVA = rd.round(rsVT.getDouble("Montant_Base") * (1-tRemise/100) * (tauxTVA/100));

				String compteTVA = cptesTva.get(new Integer(codeTVA));

				totalTVA += montantTVA;

				if (vtvas.containsKey(compteTVA)) {
					montantTVA += vtvas.get(compteTVA).doubleValue();
				}

				vtvas.put(compteTVA , new Double(rd.round(montantTVA)));
			}


			// parcours des articles de la facture pour calculer la ventilation des comptes de vente

			double htFacture = 0;

			psArtFact.setInt(1, factureId);
      ResultSet rsAF = psArtFact.executeQuery();

      while (rsAF.next()) {

				String reference = rsAF.getString("Reference");
				String typeLigne = rsAF.getString("Type_Ligne");

				double quantite = rsAF.getDouble("Quantite");
				double puHT = rsAF.getDouble("Prix");
				double ristourne = rsAF.getDouble("Ristourne");
				double tauxTVA = rsAF.getDouble("Taux_TVA");
				int codeTVA = rsAF.getInt("Code_TVA");

				String compteHT = (typeLigne.equalsIgnoreCase("S")?getCompteHT(reference, codeTVA, tauxTVA, zoneUE, codePaysLiv):getCompteDefault(codeTVA, tauxTVA, zoneUE, codePaysLiv));

				double montantHT;

				if (editionTTC)
					montantHT = rd.round(quantite * puHT * (1-ristourne/100) / (1 + tauxTVA/100));
				else
					montantHT = rd.round(quantite * puHT * (1-ristourne/100));

				if (montantHT>0) {

					htFacture += montantHT;

        	if (vventes.containsKey(compteHT)) {
						montantHT += vventes.get(compteHT).doubleValue();
					}

					vventes.put(compteHT, new Double(rd.round(montantHT)));
				}
			}


			// application du pourcentage de remise globale aux comptes de vente et calcul du total HT
			// la remise globale est applique maintenant pour viter au maximum les carts

			double fraisPortHT = (editionTTC?rd.round(fraisPort / (1+tauxTvaPort/100)):fraisPort);

			double totalHT = fraisPortHT;

			Iterator li = vventes.keySet().iterator();

			while (li.hasNext()) {

				String compteHT = (String)li.next();

				double valeurCpte = vventes.get(compteHT).doubleValue();

				double valeurRem = rd.round(valeurCpte * (1-tRemise/100));

				totalHT += valeurRem;

				if (valeurRem>0)
					vventes.put(compteHT, new Double(valeurRem));
				else
					vventes.put(compteHT, new Double(0));
			}


			htFacture = rd.round(htFacture * (1-tRemise/100) + fraisPortHT);

			// rajustement de la ventilation HT  partir du dernier compte HT ventil

			if (htFacture>totalHT) {
				ajusterHT(rd.round(htFacture-totalHT), 'P', vventes);
			}
			else if (htFacture<totalHT) {
				ajusterHT(rd.round(totalHT-htFacture), 'M', vventes);
			}


			double montantTTC = htFacture + totalTVA;


			// ajout des oprations  l'ecriture comptable

			// operations sur comptes de vente

			li = vventes.keySet().iterator();

			while (li.hasNext()) {

				String compteHT = (String)li.next();
				double montantHT = vventes.get(compteHT).doubleValue();

				if (montantHT>0) {
					Operation op = new Operation();
					op.setDateOp(dateFacture);
					op.setNumPiece(numPiece);
					op.setDateEcheance(echeance);

					op.setNumeroCompte(compteHT);
					op.setLibelle(getIntitule(compteHT));
					op.setMontantC(montantHT);

					ecriture.addOp(op);
				}
			}

			// affectation des frais de port au compte de frais de livraison

			if (fraisPort>0) {

				Operation op = new Operation();
				op.setDateOp(dateFacture);
				op.setNumPiece(numPiece);
				op.setDateEcheance(echeance);

				op.setNumeroCompte(compteLivraison);
				op.setLibelle(getIntitule(compteLivraison));
				op.setMontantC(fraisPortHT);

				ecriture.addOp(op);
			}

			// operations sur comptes de TVA

			li = vtvas.keySet().iterator();

			while (li.hasNext()) {

				String compteTVA = (String)li.next();
				double montantTVA = vtvas.get(compteTVA).doubleValue();

				if (montantTVA>0) {
					Operation op = new Operation();
					op.setDateOp(dateFacture);
					op.setNumPiece(numPiece);
					op.setDateEcheance(echeance);

					op.setNumeroCompte(compteTVA);
					op.setLibelle(getIntitule(compteTVA));
					op.setMontantC(montantTVA);

					ecriture.addOp(op);
				}
			}


			// operation d'escompte

			double montantEscompte = rd.round(montantTTC * (tEscompte/100));

			if (montantEscompte>0) {
				Operation op = new Operation();
				op.setDateOp(dateFacture);
				op.setNumPiece(numPiece);
				op.setDateEcheance(echeance);

				op.setNumeroCompte(compteEscompteVE);
				op.setLibelle(getIntitule(compteEscompteVE));
				op.setMontantD(montantEscompte);

				ecriture.addOp(op);
			}


			// operation du compte client

			double montantNet = rd.round(montantTTC - montantEscompte);

			if (montantNet>0) {
				String compteClient = getCompteClient(clientId);

				Operation op = new Operation();
				op.setDateOp(dateFacture);
				op.setNumPiece(numPiece);
				op.setDateEcheance(echeance);

				op.setNumeroCompte(compteClient);
				op.setLibelle(getIntitule(compteClient));
				op.setMontantD(montantNet);

				ecriture.addOp(op);
			}


			// insertion en base de l'ecriture comptable ssi quilibre

			if (ecriture.isStable()) {
				psBaseCompta.setLong(1, dateFacture);
				psBaseCompta.setLong(2, dateFacture);
				ResultSet rsExo = psBaseCompta.executeQuery();
				if (rsExo.next()) {
      		ecriture.insertDB(con, rsExo.getString("Nom_Base"), base);
					marquerFacture(factureId);
				}
      }
			else {
				System.out.println("\nTRANSFERT DES VENTES : ECRITURE DESEQUILIBREE\n");
				ecriture.printEcriture();
				System.out.println("Montant Net --> "+ montantNet);
			}

		} // fin boucle factures




		// GENERATION DES ECRITURES D'AVOIRS

		reqVentilTvas = "select Taux_TVA, Code_TVA, sum(Prix * Quantite * (1-Ristourne/100)) as Montant_Base "
											 + "from "+ base +".ARTICLE_AVOIR where Avoir_Id=? and Taux_TVA>0 group by Taux_TVA order by Taux_TVA";

		String reqArtAvoir = "select * from "+ base +".ARTICLE_AVOIR where Avoir_Id=?";


		psVentilTvas = con.prepareStatement(reqVentilTvas);
		PreparedStatement psArtAvoir = con.prepareStatement(reqArtAvoir);


		String reqAvoirs = "select a.*, p.Zone_UE from "+ base +".AVOIR a, PAYS p where Numero>0 and Transfere=0 and Date_Avoir<="+ finPeriode +" and Date_Avoir>="+ debutPeriode
										 + " and p.Code_Pays=a.Code_Pays_Liv and Total_HT>0"+ (client.equals("")?"":" and Client_Id='"+ client +"'") +" order by Num_Entier";

		rset = stt.executeQuery(reqAvoirs);


		while (rset.next()) {

			long dateAvoir = rset.getLong("Date_Avoir");

			int avoirId = rset.getInt("Avoir_Id");

			String clientId = rset.getString("Client_Id");
			String numPiece = rset.getString("Num_Entier");
			String libelle = rset.getString("Raison_Sociale");

			double tRemise = rset.getDouble("Remise");
			double tEscompte = rset.getDouble("Escompte");
			double fraisPort = rset.getDouble("Frais_Port");
			double tauxTvaPort = rset.getDouble("Taux_TVA_Port");
			String codePaysLiv = rset.getString("Code_Pays_Liv");
			boolean zoneUE = (rset.getInt("Zone_UE")==1 && !codePaysLiv.equalsIgnoreCase("FR"));
			int codeTvaPort = getCodeTvaPort(tauxTvaPort, codePaysLiv, rset.getInt("TVA_Liv")==1);

			boolean editionTTC = (rset.getInt("Edition_TTC")==1);

			DateTime dt = new DateTime(dateAvoir);
			dt.setDay(1);
			long dateEcriture = dt.getDateInMillis();


			Ecriture ecriture = new Ecriture(codeJournal, dateEcriture);

			HashMap<String, Double> vtvas = new HashMap<String, Double>(2);
			HashMap<String, Double> vventes = new HashMap<String, Double>(2);


			// ventilation des comptes de TVA et calcul du total TVA

			double totalTVA = 0;

			if (fraisPort>0 && tauxTvaPort>0) {

				String compteTVA = cptesTva.get(new Integer(codeTvaPort));
				double montantTVA;

				if (editionTTC)
					montantTVA = rd.round(fraisPort * (tauxTvaPort/100) / (tauxTvaPort/100+1));
				else
					montantTVA = rd.round(fraisPort * (tauxTvaPort/100));

				totalTVA += montantTVA;

				vtvas.put(compteTVA, new Double(montantTVA));
			}


			psVentilTvas.setInt(1, avoirId);
			ResultSet rsVT = psVentilTvas.executeQuery();

			while (rsVT.next()) {

				double tauxTVA = rsVT.getDouble("Taux_TVA");
				int codeTVA = rsVT.getInt("Code_TVA");
				double montantTVA;

				if (editionTTC)
					montantTVA = rd.round(rsVT.getDouble("Montant_Base") * (1-tRemise/100) * (tauxTVA/100) / (tauxTVA/100+1));
				else
					montantTVA = rd.round(rsVT.getDouble("Montant_Base") * (1-tRemise/100) * (tauxTVA/100));

				String compteTVA = cptesTva.get(new Integer(codeTVA));

				totalTVA += montantTVA;

				if (vtvas.containsKey(compteTVA)) {
					montantTVA += vtvas.get(compteTVA).doubleValue();
				}

				vtvas.put(compteTVA , new Double(rd.round(montantTVA)));
			}


			// parcours des articles de la facture pour calculer la ventilation des comptes de vente

			double htAvoir = 0;

			psArtAvoir.setInt(1, avoirId);
      ResultSet rsAF = psArtAvoir.executeQuery();

      while (rsAF.next()) {

				String reference = rsAF.getString("Reference");
				String typeLigne = rsAF.getString("Type_Ligne");

				double quantite = rsAF.getDouble("Quantite");
				double puHT = rsAF.getDouble("Prix");
				double ristourne = rsAF.getDouble("Ristourne");
				double tauxTVA = rsAF.getDouble("Taux_TVA");
				int codeTVA = rsAF.getInt("Code_TVA");


				String compteHT = (typeLigne.equalsIgnoreCase("S")?getCompteHT(reference, codeTVA, tauxTVA, zoneUE, codePaysLiv):getCompteDefault(codeTVA, tauxTVA, zoneUE, codePaysLiv));

				double montantHT;

				if (editionTTC)
					montantHT = rd.round(quantite * puHT * (1-ristourne/100) / (1 + tauxTVA/100));
				else
					montantHT = rd.round(quantite * puHT * (1-ristourne/100));

				if (montantHT>0) {
					htAvoir += montantHT;

        	if (vventes.containsKey(compteHT)) {
						montantHT += vventes.get(compteHT).doubleValue();
					}

					vventes.put(compteHT, new Double(rd.round(montantHT)));
				}
			}


			// application du pourcentage de remise globale aux comptes de vente et calcul du total HT
			// la remise globale est applique maintenant pour viter au maximum les carts

			double fraisPortHT = (editionTTC?rd.round(fraisPort / (1+tauxTvaPort/100)):fraisPort);

			double totalHT = fraisPortHT;

			Iterator li = vventes.keySet().iterator();

			while (li.hasNext()) {

				String compteHT = (String)li.next();

				double valeurCpte = vventes.get(compteHT).doubleValue();

				double valeurRem = rd.round(valeurCpte * (1-tRemise/100));

				totalHT += valeurRem;

				if (valeurRem>0)
					vventes.put(compteHT, new Double(valeurRem));
				else
					vventes.put(compteHT, new Double(0));
			}


			htAvoir = rd.round(htAvoir * (1-tRemise/100) + fraisPortHT);

			// rajustement de la ventilation HT  partir du dernier compte HT ventil

			if (htAvoir>totalHT) {
				ajusterHT(rd.round(htAvoir-totalHT), 'P', vventes);
			}
			else if (htAvoir<totalHT) {
				ajusterHT(rd.round(totalHT-htAvoir), 'M', vventes);
			}


			double montantTTC = htAvoir + totalTVA;


			// ajout des oprations  l'ecriture comptable

			// operations sur comptes de vente

			li = vventes.keySet().iterator();

			while (li.hasNext()) {

				String compteHT = (String)li.next();
				double montantHT = vventes.get(compteHT).doubleValue();

				if (montantHT>0) {
					Operation op = new Operation();
					op.setDateOp(dateAvoir);
					op.setNumPiece(numPiece);

					op.setNumeroCompte(compteHT);
					op.setLibelle(getIntitule(compteHT));
					op.setMontantD(montantHT);

					ecriture.addOp(op);
				}
			}

			// affectation des frais de port au compte de frais de livraison

			if (fraisPort>0) {

				Operation op = new Operation();
				op.setDateOp(dateAvoir);
				op.setNumPiece(numPiece);

				op.setNumeroCompte(compteLivraison);
				op.setLibelle(getIntitule(compteLivraison));
				op.setMontantD(fraisPortHT);

				ecriture.addOp(op);
			}

			// operations sur comptes de TVA

			li = vtvas.keySet().iterator();

			while (li.hasNext()) {

				String compteTVA = (String)li.next();
				double montantTVA = vtvas.get(compteTVA).doubleValue();

				if (montantTVA>0) {
					Operation op = new Operation();
					op.setDateOp(dateAvoir);
					op.setNumPiece(numPiece);

					op.setNumeroCompte(compteTVA);
					op.setLibelle(getIntitule(compteTVA));
					op.setMontantD(montantTVA);

					ecriture.addOp(op);
				}
			}


			// operation d'escompte

			double montantEscompte = rd.round(montantTTC * (tEscompte/100));

			if (montantEscompte>0) {
				Operation op = new Operation();
				op.setDateOp(dateAvoir);
				op.setNumPiece(numPiece);

				op.setNumeroCompte(compteEscompteVE);
				op.setLibelle(getIntitule(compteEscompteVE));
				op.setMontantC(montantEscompte);

				ecriture.addOp(op);
			}

			// operation du compte client

			double montantNet = rd.round(montantTTC - montantEscompte);

			if (montantNet>0) {
				String compteClient = getCompteClient(clientId);

				Operation op = new Operation();
				op.setDateOp(dateAvoir);
				op.setNumPiece(numPiece);

				op.setNumeroCompte(compteClient);
				op.setLibelle(getIntitule(compteClient));
				op.setMontantC(montantNet);

				ecriture.addOp(op);
			}


			// insertion en base de l'ecriture comptable ssi quilibre

			if (ecriture.isStable()) {
				psBaseCompta.setLong(1, dateAvoir);
				psBaseCompta.setLong(2, dateAvoir);
				ResultSet rsExo = psBaseCompta.executeQuery();
				if (rsExo.next()) {
      		ecriture.insertDB(con, rsExo.getString("Nom_Base"), base);
					marquerAvoir(avoirId);
				}
      }
			else {
				System.out.println("\nTRANSFERT DES VENTES : ECRITURE DESEQUILIBREE\n");
				ecriture.printEcriture();
				System.out.println("Montant Net --> "+ montantNet);
			}

		} // fin  boucle avoirs

		s.closeConnection(con, null);

		return true;
  }





	private void marquerFacture(int factureId) throws SQLException {

		psMarqueFact.setInt(1, factureId);
		psMarqueFact.executeUpdate();
	}


	private void marquerAvoir(int avoirId) throws SQLException {

		psMarqueAvoir.setInt(1, avoirId);
		psMarqueAvoir.executeUpdate();
	}


	private void ajusterHT(double montant, char sens, HashMap<String, Double> vventes) throws SQLException {

		Iterator li = vventes.keySet().iterator();

		while (li.hasNext() && montant>0) {

			String compteHT = (String)li.next();

			double montantHT = vventes.get(compteHT).doubleValue();

			if (sens=='P') {
				montantHT += montant;
				montant = 0;
			}
			else {
				montantHT = (montantHT>montant?montantHT - montant:0);
				montant -= montantHT;
			}

			if (montantHT>0)
				vventes.put(compteHT, new Double(montantHT));
			else
				vventes.put(compteHT, new Double(0));
		}
	}


	private String getIntitule(String numCompte) throws SQLException {

		psIntCpte.setString(1, numCompte);
		ResultSet rset = psIntCpte.executeQuery();
		return rset.next()?rset.getString("Intitule"):"-";
	}


	private String getCompteClient(String clientId) throws SQLException {

		if (clientId.equals("")) {
			return compteClientsDivers;
		}
		else {
			psCpteClient.setString(1, clientId);
			ResultSet rset = psCpteClient.executeQuery();

    	if (rset.next()) {
      	return rset.getString("Numero_Compte");
    	}
			else {
				return compteClientsDivers;
			}
		}
	}


	private String getCompteFamilleN(String reference, int codeTVA) throws SQLException {

    psCpteFamilleN.setString(1, reference);
		psCpteFamilleN.setInt(2, codeTVA);
    ResultSet rset = psCpteFamilleN.executeQuery();

    if (rset.next()) {
      return rset.getString("Compte_Vente");
    }
		else {
			return cptesVTva.get(new Integer(codeTVA));
		}
  }


	private String getCompteSousFamilleN(String reference, int codeTVA) throws SQLException {

    psCpteSousFamilleN.setString(1, reference);
		psCpteSousFamilleN.setInt(2, codeTVA);
    ResultSet rset = psCpteSousFamilleN.executeQuery();

    if (rset.next()) {
      return rset.getString("Compte_Vente");
    }
		else {
			return getCompteFamilleN(reference, codeTVA);
		}
  }


	private String getCompteArticleN(String reference, int codeTVA) throws SQLException {

		psCpteArticleN.setString(1, reference);
		psCpteArticleN.setInt(2, codeTVA);
    ResultSet rset = psCpteArticleN.executeQuery();

    if (rset.next()) {
      return rset.getString("Compte_Vente");
    }
		else {
			return getCompteSousFamilleN(reference, codeTVA);
		}
  }


	private String getCompteFamilleNatUE(String reference, int codeTVA, String codePays) throws SQLException {

    psCpteFamilleNatUE.setString(1, reference);
		psCpteFamilleNatUE.setInt(2, codeTVA);
		psCpteFamilleNatUE.setString(3, codePays);
    ResultSet rset = psCpteFamilleNatUE.executeQuery();

    if (rset.next()) {
      return rset.getString("Compte_Vente");
    }
		else {		
			psCpteNatUE.setInt(1, codeTVA);
			psCpteNatUE.setString(2, codePays);
			ResultSet rsNUE = psCpteNatUE.executeQuery();
			rsNUE.next();
			return rsNUE.getString("Compte_Vente");			
		}
  }


	private String getCompteSousFamilleNatUE(String reference, int codeTVA, String codePays) throws SQLException {

    psCpteSousFamilleNatUE.setString(1, reference);
		psCpteSousFamilleNatUE.setInt(2, codeTVA);
		psCpteSousFamilleNatUE.setString(3, codePays);
    ResultSet rset = psCpteSousFamilleNatUE.executeQuery();

    if (rset.next()) {
      return rset.getString("Compte_Vente");
    }
		else {
			return getCompteFamilleNatUE(reference, codeTVA, codePays);
		}
  }


	private String getCompteArticleNatUE(String reference, int codeTVA, String codePays) throws SQLException {

		psCpteArticleNatUE.setString(1, reference);
		psCpteArticleNatUE.setInt(2, codeTVA);
		psCpteArticleNatUE.setString(3, codePays);
    ResultSet rset = psCpteArticleNatUE.executeQuery();

    if (rset.next()) {
      return rset.getString("Compte_Vente");
    }
		else {
			return getCompteSousFamilleNatUE(reference, codeTVA, codePays);
		}
  }


	private String getCompteHT(String reference, int codeTVA, double tauxTVA, boolean zoneUE, String codePays) throws SQLException {

		if (zoneUE && tauxTVA>0) {
			psCodeN.setInt(1, codeTVA);
			ResultSet rsCN = psCodeN.executeQuery();
			
			if (rsCN.next()) {
				return getCompteArticleNatUE(reference, codeTVA, codePays);
			}
			else {
				return getCompteArticleN(reference, codeTVA);
			}
		}		
		else {
			return getCompteArticleN(reference, codeTVA);
		}
	}


	private String getCompteDefault(int codeTVA, double tauxTVA, boolean zoneUE, String codePays) throws SQLException {

		if (zoneUE && tauxTVA>0) {
		
			psCodeN.setInt(1, codeTVA);
			ResultSet rsCN = psCodeN.executeQuery();
			
			if (rsCN.next()) {
				psCpteNatUE.setInt(1, codeTVA);
				psCpteNatUE.setString(2, codePays);
				ResultSet rsNUE = psCpteNatUE.executeQuery();
				rsNUE.next();
				return rsNUE.getString("Compte_Vente");
			}
			else {
				return cptesVTva.get(new Integer(codeTVA));
			}
		}		
		else {
			return cptesVTva.get(new Integer(codeTVA));
		}
	}


	private int getCodeTvaPort(double taux, String codePaysLiv, boolean tvaLiv) throws SQLException {
	
		psCodeTvaPort.setDouble(1, taux);
	
		if (tvaLiv) {
			psCodeTvaPort.setString(2, codePaysLiv);
		}
		else {
			psCodeTvaPort.setString(2, "FR");
		}
		
		ResultSet rset = psCodeTvaPort.executeQuery();
		rset.next();
		
		return rset.getInt(1);
	}


} // fin TransfertFactures.java

