/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

package org.opensi.facturation.reglements.clients;

import java.sql.*;

import java.util.Iterator;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.HashMap;

import org.experlog.openeas.api.Session;
import org.opensi.util.tools.Arrondi;



public class CalculEcheance {

	private String Client_Id;
	private String Client;
	private String Mode_Reg;
	private double Montant;
	private double Montant_initial;
	private double Montant_regl;
	private String Base;
	private Session s;
	private int nb;
	private int i;
	private HashMap<String, String> tab=new HashMap<String, String>();
	private ResultSet rset;
	private LinkedHashMap<Integer, String[]> liste=new LinkedHashMap<Integer, String[]>();
	private Statement st;
	private Arrondi arrondi=new Arrondi(2);
	private ArrayList<String> liste_fini=new ArrayList<String>();
	private ArrayList<String[]> listesomme=new ArrayList<String[]>();



	public CalculEcheance (String Sess,String Base,String Client_Id,String Client,String Mode_Reg,String Montant,String Montant_Regl) {
		try {
		this.Base=Base;
		this.Client_Id=Client_Id;
		this.Client=Client;
		this.Mode_Reg=Mode_Reg;
		this.Montant=(new Double(Montant)).doubleValue();
		this.Montant_initial=(new Double(Montant)).doubleValue();
		this.Montant_regl=(new Double(Montant_Regl)).doubleValue();
		
		this.nb=0;
		this.s = Session.findClient(Sess);
			Connection c = s.getConnection(null);
			st = c.createStatement();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public boolean liste () {
		try {

			String sqlCountEch = "select count(Echeance_Id) as nb from " + Base + ".ECHEANCE_CLIENT"+
			" where Client_Id = '"+ Client_Id +"' and Etat != 'R'";
			if (Client_Id.equals("")) {
				sqlCountEch+=" and Raison_Sociale = '"+s.sqlEncode(Client)+"'";
			}
			sqlCountEch+=" order by Type,Date_Echeance, Numero";
			rset = st.executeQuery(sqlCountEch);
			if (rset.next()) {
				nb=rset.getInt(1);
			}
			
			String sqlListeEch = "select * from " + Base + ".ECHEANCE_CLIENT"+
			" where Client_Id = '"+ Client_Id +"' and Etat != 'R'";
			if (Client_Id.equals("")) {
				sqlListeEch+=" and Raison_Sociale = '"+s.sqlEncode(Client)+"'";
			}
			sqlListeEch+=" order by Type,Date_Echeance, Numero";
			rset = st.executeQuery(sqlListeEch);

			
			while (rset.next()) {
				String tree[]=new String [5];
				tree[0]=rset.getString("Echeance_Id");
				tree[1]=rset.getString("Type");
				tree[2]=rset.getString("Montant_Restant");
				tree[3]=rset.getString("Mode_Reglement");
				tree[4]=rset.getString("Date_Echeance");
				liste.put(rset.getInt("Echeance_Id"),tree);
				tab.put(tree[0],"0.00");

				int nbsomme=listesomme.size();
				if (nb<15) {
					for (i=0;i<nbsomme;i++)
					{
						double val=new Double(listesomme.get(i)[2]).doubleValue();
						double somme=rset.getDouble("Montant_Restant")+val;
						somme=arrondi.round(somme);
						if (somme<=Montant) {
							String Mode=listesomme.get(i)[1];
							String cle=listesomme.get(i)[0];
							Mode=(Mode.equals(tree[3]))?tree[3]:"";

							String som[]={cle+";"+tree[0],Mode,(new Double(somme)).toString()};
							listesomme.add(som);
						}
					}
				}
				if (rset.getDouble("Montant_Restant")<Montant) {
					String nouv []={tree[0],tree[3],tree[2]};
					listesomme.add(nouv);
				}
			}

		} catch (Exception e) {
			e.printStackTrace();
		}
		return true;
	}

	public boolean calcul () {
		try {

			boolean suite=false;
			impute_egal(true);
			if (Montant!=0){
				if (Montant==Montant_initial) {
					suite=somme_egal(true,Montant_regl);
					if (Montant!=0 && Montant==Montant_initial){
						if (suite) {somme_egal(true,Montant);}
					}
				}
				if (Montant!=0){
					trouve_diff(true);
					if (Montant!=0){
						if (Montant==Montant_initial) {
							impute_egal(false);
							if (Montant!=0){
								if (Montant==Montant_initial) {
									suite=somme_egal(false,Montant_regl);
									if (Montant!=0 && Montant==Montant_initial){
										if (suite) {somme_egal(false,Montant);}
									}
								}
							}
						}
						if (Montant!=0){
							trouve_diff(false);
						}
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return true;
	}


	public boolean impute_egal(boolean meme_mode) {
		try {

			String [] ech=trouve_egal(meme_mode,Montant_regl);
			String [] ech_avo=trouve_egal(meme_mode,Montant);

			if (!ech[1].equals("") && !ech_avo[1].equals("")) {
				if ((new Long (ech[1]).longValue())<=(new Long (ech_avo[1]).longValue())) {
					tab.put(ech[0],(new Double(Montant_regl)).toString());
					Montant-=Montant_regl;
					Montant=arrondi.round(Montant);
					Montant_regl=0;
					liste_fini.add(ech[0]);
				}
				else {
					tab.put(ech_avo[0],(new Double(Montant)).toString());
					Montant=0;
					Montant_regl=0;
					liste_fini.add(ech_avo[0]);
				}
			}
			else if (!ech[1].equals("") || !ech_avo[1].equals("")) {
				if (ech_avo[1].equals("")) {
					tab.put(ech[0],(new Double(Montant_regl)).toString());
					Montant-=Montant_regl;
					Montant=arrondi.round(Montant);
					Montant_regl=0;
					liste_fini.add(ech[0]);
				}
				else {
					tab.put(ech_avo[0],(new Double(Montant)).toString());
					Montant=0;
					Montant_regl=0;
					liste_fini.add(ech_avo[0]);
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return true;
	}


	public String [] trouve_egal(boolean meme_mode,double mont) {
		String [] ech=new String [2];
		ech[0]="";
		ech[1]="";
		boolean trouve=false;
		int i=0;
		try {
			Iterator it = liste.keySet().iterator();
			while (it.hasNext() && !trouve)
			{
				String [] elem = (String[]) liste.get(it.next());
				boolean egal;
				double Restant=Double.parseDouble(elem[2]);
				String Mode=elem[3];
				String Id=elem[0];
				String date=elem[4];
				if (meme_mode)
					egal=Mode_Reg.equals(Mode);
				else
					egal=!Mode_Reg.equals(Mode);
				if (egal)
				{
					if (Restant==mont && mont!=0)
					{
						trouve=true;
						ech[0]=Id;
						ech[1]=date;
					}
				}
				i++;
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return ech;
	}


	public boolean somme_egal(boolean meme_mode,double mont) {
		boolean suite=true;
		try {
			if (meme_mode){

				for (int i=0;i<listesomme.size();i++)
				{
					double val=new Double(listesomme.get(i)[2]).doubleValue();
					String Mode=listesomme.get(i)[1];
					String Id=listesomme.get(i)[0];
					if (Mode_Reg.equals(Mode))
					{
						if (val==mont && mont!=0 && Montant!=0)
						{
							suite=false;
							int nombre=1;
							for (int j=0;j<Id.length();j++)
							{
								if ((Id.charAt(j))==';')
									nombre++;

							}
							String Ech []=Id.split(";");
							for (int k=0;k<nombre;k++)
							{
								Integer value = new Integer(Ech[k]);
								double Restant=(Double.parseDouble(liste.get(value)[2]));
								tab.put(Ech[k],liste.get(value)[2]);
								liste_fini.add(Ech[k]);
								Montant-=Restant;
								Montant=arrondi.round(Montant);
								if (Restant<=Montant_regl) {
									Montant_regl-=Restant;
									Montant_regl=arrondi.round(Montant_regl);
								}
								else {
									Montant_regl=0;
								}
							}
						}
					}
				}
			}
			else
			{
				for (int i=0;i<listesomme.size();i++)
				{
					double val=new Double(listesomme.get(i)[2]).doubleValue();
					String Mode=listesomme.get(i)[1];
					String Id=listesomme.get(i)[0];
					if (!Mode_Reg.equals(Mode))
					{
						if (val==mont && mont!=0 && Montant!=0)
						{
							suite=false;
							int nombre=1;
							for (int j=0;j<Id.length();j++)
							{
								if ((Id.charAt(j))==';')
									nombre++;

							}
							String Ech []=Id.split(";");
							for (int k=0;k<nombre;k++)
							{
								Integer value = new Integer(Ech[k]);
								double Restant=(Double.parseDouble(liste.get(value)[2]));
								tab.put(Ech[k],liste.get(value)[2]);
								liste_fini.add(Ech[k]);
								Montant-=Restant;
								Montant=arrondi.round(Montant);
								if (Restant<=Montant_regl) {
									Montant_regl-=Restant;
									Montant_regl=arrondi.round(Montant_regl);
								}
								else {
									Montant_regl=0;
								}

							}
						}
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return suite;
	}

	public boolean trouve_diff(boolean meme_mode) {
		try {
			Iterator it = liste.keySet().iterator();
			while (it.hasNext())
			{
				String [] elem = (String[]) liste.get(it.next());
				boolean egal;
				double Restant=Double.parseDouble(elem[2]);
				String Type=elem[1];
				String Mode=elem[3];
				String Id=elem[0];
				if (meme_mode)
					egal=Mode_Reg.equals(Mode);
				else
					egal=!Mode_Reg.equals(Mode);
				if (egal && !liste_fini.contains(Id))
				{
					if (Restant<=Montant)
					{
						tab.put(Id,(new Double(Restant)).toString());
						liste_fini.add(Id);
						Montant-=Restant;
						Montant=arrondi.round(Montant);
						if (Restant<=Montant_regl) {
							Montant_regl-=Restant;
							Montant_regl=arrondi.round(Montant_regl);
						}
						else {
							Montant_regl=0;
						}
					}
					else if (Montant!=0)
					{
						if (Type.equals("Echeance") || !meme_mode) {
							tab.put(Id,(new Double(Montant)).toString());
							Montant_regl=0;
							Montant=0;
						}
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return true;
	}
	public String getMontant_Impute(String ech_Id) {
		return tab.get(ech_Id);
	}
}
