/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

package org.opensi.util;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;

/**
 * Repertory quelques fonctions systemes utiles
 */

public class FonctionsSysteme {
	public static void creerDossierSiInexistant(String dossier) {
		try {
			File Dossier = new File(dossier);
			if (!Dossier.exists()) {
				Dossier.mkdir();
			}
		}
		catch (Exception e) {
			System.out.println("[FonctionsSystemes.creerDossierSiInexistant]ERREUR:" + e);
		}
	}

	/**
	 * 
	 * @param source
	 * @param dest
	 */
	public static void copier(File source, File dest) {
		try {
			FileInputStream inStream = new FileInputStream(source);
			FileOutputStream outStream = new FileOutputStream(dest);

			// tant que ce n'est pas la fin du fichier
			while (inStream.available() > 0) {
				outStream.write(inStream.read());
			}

			// fermeture des fichiers
			inStream.close();
			outStream.close();
		}
		catch (Exception e) {
			System.out.println("[FonctionsSystemes.copier] ERREUR" + e);
		}
	}
}
