/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


package org.opensi.util;

import java.util.Properties;
import java.io.InputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.FileNotFoundException;

/*
 * Classe Version :
 *  Traite les information concernant la version d'OpenSi
 */
 
public class Version {

  Properties prop;

  public Version(String fileName) {
    try {
      InputStream istr = new FileInputStream(fileName);
      prop = new Properties();
      prop.load(istr);
    } catch(FileNotFoundException fnfe) {
      fnfe.printStackTrace();
    } catch(IOException ioe) {
      ioe.printStackTrace();
    }
  }

  public String getVersion() {
    return prop.getProperty("version");
  }

  public String getReleaseName() {
    return prop.getProperty("releasename");
  }

  public String getClientRelease() {
    return prop.getProperty("clientrelease");
  }
  
  public String getMinRelease() {
    return prop.getProperty("minrelease");
  }
  
  public String getCurrentRelease() {
    return prop.getProperty("currentrelease");
  }

  public String getUrlUpdate(String os) {
    String aux = os.toLowerCase();
    if (aux.startsWith("linux")) {
      aux = "unix-user";
    } else if (aux.startsWith("win")) {
      aux = "windows-firefox";
    } else if (aux.startsWith("mac")) {
      aux = "unix-user";
    }
    return prop.getProperty("urlupdate").replaceAll("<os>",aux);
  }

}
