/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

package org.opensi.util.actions;

import java.io.*;
import java.sql.*;

import org.experlog.openeas.api.Session;
import org.experlog.openeas.api.Action;
import org.experlog.openeas.api.ServletRequest;
import org.experlog.openeas.api.AppConfiguration;


public class ExecuteSql extends Action {


  public boolean serverSide() { return true; }

  public boolean service(Session s, ServletRequest r, Object info) throws Exception {

    String nomBase = r.getParameter("NomBase");
    String insertBase = "insert into "+ nomBase +".";
    String createBase = "create table "+ nomBase +".";
    String nomScript = r.getParameter("NomScript");
    String insertRegexp = "insert +into +";
    String createRegexp = "create +table +";

    AppConfiguration ac = s.getAppConfiguration();

    Connection con = s.getConnection(null);

    Statement stt = con.createStatement();
		
    String cheminfichierbase = ac.get("opensi.absdir") +"/database/mysql/"+ nomScript;

    BufferedReader bufreader = new BufferedReader(new FileReader(cheminfichierbase));

    String ligne;
    String req = "";
		
    while ((ligne = bufreader.readLine()) != null) {
      int id = ligne.indexOf("--");
      if (id == -1) {
        req += ligne.replaceAll(insertRegexp,insertBase).replaceAll(createRegexp,createBase);
      } else {
        req += ligne.substring(0,id).replaceAll(insertRegexp,insertBase).replaceAll(createRegexp,createBase);
      }
      if (req.endsWith(";")) {
        stt.execute(req);
        req = "";
      }
    }

    s.closeConnection(con, null);
		
    return true;
  }

}
