/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

package org.opensi.util.openoffice;

public class OooStyleLigne extends OooStyle

{

	private float hauteur;
	
	private final float HAUTEUR_DEFAUT=0.427f;

	public OooStyleLigne(String lenom, float lahauteur)
	{
		super(lenom);
		
		if(lahauteur<0.1)
		{
			hauteur=HAUTEUR_DEFAUT;
		}
		else
		{
			hauteur=lahauteur;
		}
	}
	
	public OooStyleLigne(String lenom)
	{
		super(lenom);
		hauteur=HAUTEUR_DEFAUT;
	}
	
	public String getFamilleStyle()
	{
		return "table-row";
	}

	public String getPropriete()
	{
		return "fo:break-before=\"auto\" style:row-height=\""+hauteur+"cm\"";
	}


}
