/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

package org.opensi.util.tools;


import java.util.Calendar;


public class DataCheck {
	
		
	public static boolean isEmpty(String str) {
		return str.length()==0;
	}
	
	
	public static boolean isPeriode(long periode) {	
		
		Calendar cal = Calendar.getInstance();
		
		cal.clear();
		cal.setTimeInMillis(periode);
		
		return cal.get(Calendar.DAY_OF_MONTH)==1 && cal.get(Calendar.HOUR_OF_DAY)==0 && cal.get(Calendar.MINUTE)==0 && cal.get(Calendar.SECOND)==0;
	}
	
	
	public static boolean isDateOp(long dateOp) {
		
		Calendar cal = Calendar.getInstance();
		
		cal.clear();
		cal.setTimeInMillis(dateOp);
		
		return cal.get(Calendar.HOUR_OF_DAY)==0 && cal.get(Calendar.MINUTE)==0 && cal.get(Calendar.SECOND)==0;
	}
	
	
	public static boolean isAlpha(String str) {
	
		boolean alpha = true;
	
		for (int i=0;i<str.length();i++) {
			alpha = alpha && str.charAt(i)<='z' && str.charAt(i)>='A'; 
		}
	
		return alpha; 
	}
	
	
	public static boolean isNumeric(String str) {
	
		boolean numeric = true;
	
		for (int i=0;i<str.length();i++) {
			numeric = numeric && str.charAt(i)>='0' && str.charAt(i)<='9'; 
		}
	
		return numeric; 
	}
	
	
	public static boolean isAlphaNum(String str) {
	
		boolean alphanum = true;
	
		for (int i=0;i<str.length();i++) {
			alphanum = alphanum && (str.charAt(i)<='z' && str.charAt(i)>='A' || str.charAt(i)>='0' && str.charAt(i)<='9'); 
		}
	
		return alphanum;
	}
	
	
	public static boolean isTypeCompte(String str) {
	
		return str.equalsIgnoreCase("G") || str.equalsIgnoreCase("C") || str.equalsIgnoreCase("F");
	}
	
	
	public static boolean isYesNo(String str) {
	
		return str.equalsIgnoreCase("y") || str.equalsIgnoreCase("n");
	}
	
	
	public static boolean isTypeJournal(String str) {
	
		return str.equalsIgnoreCase("TR") || str.equalsIgnoreCase("AC") || str.equalsIgnoreCase("AN") || str.equalsIgnoreCase("VE") || str.equalsIgnoreCase("OD");
	}
	
	
	public static boolean isCpteGen(String str) {
		try {
		
			return str.length()==8 && Integer.parseInt(str.substring(0,1))<=7 && Integer.parseInt(str.substring(0,1))>0 && isNumeric(str);
		
		} catch(NumberFormatException nfe) {
			return false;
		}
	}
	
	
	public static boolean isCpteTiers(String str) {
		
		return str.length()==8 && str.startsWith("0") && isAlphaNum(str);
	}
	
  
} // fin DataCheck
