/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 *  Requetes multiples d'insertion ou de suppression d'articles web.
 */

package org.opensi.webmanager.init_vente;

import java.sql.Connection;
import java.sql.Statement;

import org.experlog.openeas.api.Action;
import org.experlog.openeas.api.ServletRequest;
import org.experlog.openeas.api.Session;

/**
 * Modifie le stock web de tout un groupe d'articles.
 */
public class ModifStockGroupeArticles extends Action {

	/**
	 * 
	 * @return
	 */
	public boolean serverSide() {
		return true;
	}

	/**
	 * 
	 * @param s
	 * @param r
	 * @param info
	 * @throws java.lang.Exception
	 * @return
	 */
	public boolean service(Session s, ServletRequest r, Object info) throws Exception {

		String id_article = r.getParameter("id_article");
		String sous_famille = r.getParameter("sous_famille");
		String famille = r.getParameter("famille");
		String marque = r.getParameter("marque");
		String collection = r.getParameter("collection");
		String reference = r.getParameter("reference");
		String designation = r.getParameter("designation");
		String couleur = r.getParameter("couleur");
		String taille = r.getParameter("taille");
		String typeCalcul = r.getParameter("typeCalcul");
		String valeur = r.getParameter("valeur");

		String base = r.getParameter("base");
		String site_id = r.getParameter("site_id");

		double valeur_double = 0.0;
		if (!valeur.equals("")) {
			valeur_double = Double.parseDouble(valeur);
		}

		Connection con = s.getConnection(null);
		// Constitution de la liste des articles auquels il faut affecter un
		// stock
		// Selon le mode de calcul, on n'as pas besoin des memes infos

		String condWhere = "";
		if (id_article.equals("")) {
			// On regarde les filtres  appliquer  la requete
			if (!marque.equals("[toutes]")) {
				condWhere += " AND Marque='" + s.sqlEncode(marque) + "'";
			}

			if (!sous_famille.equals("[toutes]")) {
				condWhere += " AND Sous_Famille='" + s.sqlEncode(sous_famille) + "'";
			}

			if (!famille.equals("[toutes]")) {
				condWhere += " AND Famille='" + s.sqlEncode(famille) + "'";
			}

			if (!couleur.equals("[toutes]")) {
				condWhere += " AND Couleur='" + s.sqlEncode(couleur) + "'";
			}

			if (!collection.equals("[toutes]")) {
				condWhere += " AND Collection='" + s.sqlEncode(collection) + "'";
			}

			if (!taille.equals("[toutes]")) {
				condWhere += " AND Taille='" + s.sqlEncode(taille) + "'";
			}

			if (!reference.equals("")) {
				condWhere += " AND w.Article_Id LIKE '%" + s.sqlEncode(reference) + "%'";
			}

			if (!designation.equals("[toutes]")) {
				condWhere += " AND Designation LIKE '%" + s.sqlEncode(designation) + "%'";
			}
		}
		else {
			condWhere = " AND w.Article_Id='" + s.sqlEncode(id_article) + "'";
		}

		String typeCalculBD = "";
		String calculBD = "";
		if (typeCalcul.equals("TAMPON")) {
			typeCalculBD = "T";

			if (valeur_double < 0) {
				calculBD = "(Stock_Init+Entrees-Sorties)+" + valeur_double;
			}
			else {
				calculBD = "(Stock_Init+Entrees-Sorties)-" + valeur_double;
			}
		}
		else if (typeCalcul.equals("PC_OPENSI")) {
			typeCalculBD = "P";
			calculBD = "((Stock_Init+Entrees-Sorties)*" + valeur + ")/100";
		}
		else if (typeCalcul.equals("MEME")) {
			typeCalculBD = "P";
			calculBD = "(Stock_Init+Entrees-Sorties)";
			valeur_double = 100.0;
		}

		// Preparation de la requete multiple
		String reqMultiple = "UPDATE " + base + ".FICHE_ARTICLE_WEB w, ";
		reqMultiple += " " + base + ".STOCKS_ARTICLE s, " + base + ".FICHE_ARTICLE a ";
		reqMultiple += " SET w.Stock_Web=" + calculBD;
		reqMultiple += " ,w.Date_Stock_Ref=";
		reqMultiple += " (";
		reqMultiple += " 	SELECT MAX(Date_Mvt)";
		reqMultiple += " 	FROM " + base + ".STOCKS_ARTICLE s1 LEFT JOIN " + base + ".MVT_STOCK m ON m.Article_Id=s1.Article_Id ";
		reqMultiple += " 	WHERE s1.Article_Id=a.Article_Id";
		reqMultiple += " 	GROUP BY (s1.Article_Id)";
		reqMultiple += " )";
		reqMultiple += ", w.Calcul_Stock='" + typeCalculBD + "', w.Valeur_Stock=" + valeur_double + ",w.Stock_Modifie=1";
		reqMultiple += " WHERE s.Article_Id=w.Article_Id AND w.Article_Id=a.Article_Id and a.Supprime=0 AND w.Site_Id=" + site_id + " " + condWhere;

		System.out.println("[Req qui tue(Stock)]" + reqMultiple);

		Statement state = con.createStatement();
		state.executeUpdate(reqMultiple);

		String requeteReparation = "UPDATE " + base + ".FICHE_ARTICLE_WEB SET Date_Stock_Ref=0 WHERE Date_Stock_Ref IS NULL";

		state.executeUpdate(requeteReparation);

		s.closeConnection(con, null);

		return true;

	}

}
