/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 *  Traitement des fichiers des photos de produits
 */

package org.opensi.webmanager.utils;

import java.io.File;

import org.experlog.openeas.api.Action;
import org.experlog.openeas.api.ServletRequest;
import org.experlog.openeas.api.Session;
import org.opensi.util.FonctionsSysteme;

/**
 * Gre les photos
 */
public class ManagePhotos extends Action {

	/**
	 * 
	 * @return
	 */
	public boolean serverSide() {
		return true;
	}

	/**
	 * 
	 * @param s
	 * @param r
	 * @param info
	 * @throws java.lang.Exception
	 * @return
	 */
	public boolean service(Session s, ServletRequest r, Object info) throws Exception {

		String chemin = s.getAppConfiguration().get("opensi.absdir");

		String fichierImage = r.getParameter("Fichier");
		String dossier = s.getCookie().get("Dossier_Id");
		String famille = r.getParameter("famille");
		String sous_famille = r.getParameter("sousfamille");
		String marque = r.getParameter("marque");

		System.out.print("[ManagePhotos] Je vais manager la photo:" + fichierImage);

		if (marque.equals("")) {
			if (sous_famille.equals("")) {
				FonctionsSysteme.creerDossierSiInexistant(chemin + "/photos_familles/");
				FonctionsSysteme.creerDossierSiInexistant(chemin + "/photos_familles/" + dossier + "/");

				File source = new File(chemin + "/iobuffer/" + fichierImage);
				File destination = new File(chemin + "/photos_familles/" + dossier + "/" + fichierImage);

				FonctionsSysteme.copier(source, destination);

			}
			else {
				FonctionsSysteme.creerDossierSiInexistant(chemin + "/photos_familles/");
				FonctionsSysteme.creerDossierSiInexistant(chemin + "/photos_familles/" + dossier + "/");
				FonctionsSysteme.creerDossierSiInexistant(chemin + "/photos_familles/" + dossier + "/" + famille + "/");

				File source = new File(chemin + "/iobuffer/" + fichierImage);
				File destination = new File(chemin + "/photos_familles/" + dossier + "/" + famille + "/" + fichierImage);

				FonctionsSysteme.copier(source, destination);
			}
		}
		else {
			FonctionsSysteme.creerDossierSiInexistant(chemin + "/photos_marques/");
			FonctionsSysteme.creerDossierSiInexistant(chemin + "/photos_marques/" + dossier + "/");

			File source = new File(chemin + "/iobuffer/" + fichierImage);
			File destination = new File(chemin + "/photos_marques/" + dossier + "/" + fichierImage);

			FonctionsSysteme.copier(source, destination);

		}

		return true;

	}

} // fin ManagePhotos

